namespace eval bondfluid {

    global ProgramName

    # Tdyn settings
    variable show_ransol [IsVarOnTdynDefaults show_ransol 1]
    variable show_heatrans [IsVarOnTdynDefaults show_heatrans 1]
    variable show_advect [IsVarOnTdynDefaults show_advect 1]
    variable show_ursolver [IsVarOnTdynDefaults show_ursolver 1]
    variable show_alemesh [IsVarOnTdynDefaults show_alemest 1]

    # Selected boundary name
    variable Boundary_Name

    # Advect Species variables
    variable Species_Names
    variable Species_Values
    variable Species_UValues
    # Advect Species variables
    variable Species_Valnames \
	    [list \
	    [list "Flux Spc " Flux_Spc func 1 ""] \
	    [list "Reactive Flux Spc " Reactive_Flux_Spc func 1 ""] \
	    ]
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    variable Species_UValnames \
	    [list \
	    [list "Flux Spc Units" Flux_Spc_Units unit 1 concentration] \
	    [list "Reactive Flux Spc Units" Reactive_Flux_Spc_Units unit 1 concentration] \
	    ]
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    # Advect Species support variables
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist
    variable sname

    # URSolver Species variables
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    # URSolver Species variables
    variable URVariables_Valnames \
	    [list \
	    [list "Flux Phi " Flux_Phi func 1 ""] \
	    [list "Reactive Flux Phi " Reactive_Flux_Phi func 1 ""] \
	    ]
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    variable URVariables_UValnames \
	    [list \
	    [list "Flux Phi Units" Flux_Phi_Units unit 1 concentration] \
	    [list "Reactive Flux Phi Units" Reactive_Flux_Phi_Units unit 1 concentration] \
	    ]
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    # URSolver Species support variables
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname

    # Alemesh Questions
    variable Springs_List [list \
	    [list 1 1 1 1 1 1] \
	    [list 2 2 2 2 2 2] \
	    [list 3 3 3 3 3 3] \
	    [list 4 4 4 4 4 4] \
	    [list 5 5 5 5 5 5] \
	    [list 6 6 6 6 6 6] \
	    [list 7 7 7 7 7 7] \
	    ]

    # List of available Fluid Body Questions in Mat File.
    if { $ProgramName == "Tdyn2D" } {
	variable Fluid_Body_Questions [list \
		[list SWITCH integer 0 ransol] \
		[list BoundType string 0 ransol] \
		[list Yplus integer 1 ransol] \
		[list Delta float 1 ransol] \
		[list Delta_Units unit 0 ransol] \
		[list Cw float 1 ransol] \
		[list Roughness float 1 ransol] \
		[list Roughness_Units unit 0 ransol] \
		[list FTau_Field float 1 ransol] \
		[list Kenr_Field float 1 ransol] \
		[list Elen_Field float 1 ransol] \
		[list Sharp_Angle float 1 ransol] \
		[list Fix_Angle float 1 ransol] \
		[list SternC_Angle float 1 ransol] \
		[list Angle_Units unit 0 ransol] \
		[list Centre_of_Gravity_X float 1 ransol] \
		[list Centre_of_Gravity_Y float 1 ransol] \
		[list Heat_Flux func 1 heatrans] \
		[list Heat_Flux_Units unit 0 heatrans] \
		[list Reactive_Heat_Flux func 1 heatrans] \
		[list Reactive_Heat_Flux_Units unit 0 heatrans] \
		[list Species_Properties string 0 advect] \
		[list Spc_Units string 0 advect] \
		[list Variables_Properties string 0 ursolver] \
		[list URV_Units string 0 ursolver] \
		[list Body_Mass float 1 alemesh] \
		[list Body_Mass_Units unit 0 alemesh] \
		[list Radius_of_Gyration_Z float 1 alemesh] \
		[list Radii_of_Gyration_Units unit 0 alemesh] \
		[list Displacement_OX string 0 alemesh] \
		[list Displacement_OY string 0 alemesh] \
		[list Rotation_OZ string 0 alemesh] \
		[list Springs string 0 alemesh] \
		[list KD_Units unit 0 alemesh] \
		[list KR_Units unit 0 alemesh] \
		]
    } elseif { $ProgramName == "Tdyn3D" } {
	variable Fluid_Body_Questions [list \
		[list SWITCH integer 0 ransol] \
		[list BoundType string 0 ransol] \
		[list Yplus integer 1 ransol] \
		[list Delta float 1 ransol] \
		[list Delta_Units unit 0 ransol] \
		[list Cw float 1 ransol] \
		[list Roughness float 1 ransol] \
		[list Roughness_Units unit 0 ransol] \
		[list FTau_Field float 1 ransol] \
		[list Kenr_Field float 1 ransol] \
		[list Elen_Field float 1 ransol] \
		[list Sharp_Angle float 1 ransol] \
		[list Fix_Angle float 1 ransol] \
		[list SternC_Angle float 1 ransol] \
		[list Angle_Units unit 0 ransol] \
		[list Centre_of_Gravity_X float 1 ransol] \
		[list Centre_of_Gravity_Y float 1 ransol] \
		[list Centre_of_Gravity_Z float 1 ransol] \
		[list Heat_Flux func 1 heatrans] \
		[list Heat_Flux_Units unit 0 heatrans] \
		[list Reactive_Heat_Flux func 1 heatrans] \
		[list Reactive_Heat_Flux_Units unit 0 heatrans] \
		[list Species_Properties string 0 advect] \
		[list Spc_Units string 0 advect] \
		[list Variables_Properties string 0 ursolver] \
		[list URV_Units string 0 ursolver] \
		[list Body_Mass float 1 alemesh] \
		[list Body_Mass_Units unit 0 alemesh] \
		[list Radius_of_Gyration_Z float 1 alemesh] \
		[list Radii_of_Gyration_Units unit 0 alemesh] \
		[list Displacement_OX string 0 alemesh] \
		[list Displacement_OY string 0 alemesh] \
		[list Displacement_OZ string 0 alemesh] \
		[list Rotation_OZ string 0 alemesh] \
		[list Springs string 0 alemesh] \
		[list KD_Units unit 0 alemesh] \
		[list KR_Units unit 0 alemesh] \
		]
    }
    foreach item $Fluid_Body_Questions {
	variable [lindex $item 0]
    }
    # List of available Solid Contact Questions in Mat File.

    variable Contact_Questions [list \
	    [list Thermal_Resistance float 1 heatrans] \
	    [list Thermal_Reactive_Units unit 0 heatrans] \
	    [list Switch string 0 heatrans] \
	    [list Species_Properties string 0 advect] \
	    [list Resistance_Spc_Units string 0 advect] \
	    [list Variables_Properties string 0 ursolver] \
	    [list Resistance_Phi_Units string 0 ursolver] \
	    ]
    foreach item $Contact_Questions {
	variable [lindex $item 0]
    }

    # Function Editor variables lists
    variable heatrans_ff \
	    [ list \
	    {bondfluid::Heat_Flux} {Heat Flux} \
	    {bondfluid::Reactive_Heat_Flux} {Reactive Heat Flux} \
	    ]

    variable fluid_variables "x y z nx ny nz t it rand dt e pi vx vy vz pr tm\
	    vt v_ tau wc ds ke ep om kt pk dn bt sp# ph#"
    variable example_fluid_variables "x y z nx ny nz t it rand dt exp(1)\
	    pi vx vy vz pr tm vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable fluid_operators "+ - * / ^ mod div rmod rdiv max min Dx() Dy() Dz()\
	    ~ < <= > >= = != & |"
    variable predefined_ff [list $fluid_variables $example_fluid_variables $fluid_operators]
}



################################################################################
#
#   Initialize Fluid Boundary Window
#
################################################################################

proc bondfluid::init { BASE selmatname } {

    global ProgramName

    # Tdyn settings
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh

    # Selected Boundary Name
    variable Boundary_Name $selmatname
    # Variables Lists
    variable Fluid_Body_Questions
    foreach item $Fluid_Body_Questions {
	variable [lindex $item 0]
    }
    # Function Editor Variables
    variable heatrans_ff
    variable fluid_variables
    variable example_fluid_variables
    variable fluid_operators
    variable predefined_ff

    # Advect Species support variables
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    variable snlist

    # URSolver support variables
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames
    variable ursnlist

    # Alemesh Questions
    variable Springs_List

    # Read values of selected material
    bondfluid::getvalues

    #####  HELP Text variables - BODY TYPE #####
    # RANSOL Fields
    set help_BoundType \
	    "Law of the Wall boundary Type. Next boundary conditions (in momentum equation) are available:\n\tCw_U2Wall: Wall stress is calculated by Cw*U^2\n\tITTC_Wall: Wall stress are corrected, taking into account the ITTC57 friction line\n\tNone_Wall: No conditions\n\tRoughWall: Law of the Wall with Roughness efect and y(delta) prescribed\n\tDeltaWall: Reichardt Law of the Wall with y(delta) prescribed\n\tYplusWall: Reichardt Law of the Wall with y+(yplus) prescribed\n\tInvisWall: Null Normal Velocity\n\tV_fixWall: Null Velocity\n\tUser_Wall: Boundary conditions may defined by the user"
    set help_Yplus \
	    "Nondimensional distance to the wall"
    set help_Delta \
	    "Distance to the wall"
    set help_Cw \
	    "Constant of the Cw_U2 or ITTC friction lines"
    set help_Roughness \
	    "Roughness or characteristic length of the wall.\nIt is used to calculate boundary conditions on the wall.\nThis value shouldn't be less that 0.0001 times the average element size of the body."
    set help_Roughness_Units \
	    "Units of the roughness of the wall."
    set help_FTau_Field \
	    "Field of Fluid Traction at the wall. Function is evaluated using Internal Units."
    set help_Kenr_Field \
	    "Field of Eddy Kinetic Energy at the wall. Function is evaluated using Internal Units."
    set help_Elen_Field \
	    "Field of Turbulent Length Scale at the wall. Function is evaluated using Internal Units."
    set help_Sharp_Angle \
	    "Maximum angle to apply (automatically) Kutta-Jukowsky condition (recommended 20o)"
    set help_Fix_Angle \
	    "Maximum angle to fix (automatically) the velocity (recommended 100o)"
    set help_SternC_Angle \
	    "Maximum angle between velocity and hull in the floating line.\nIt is used to control the stern flow conditions (recommended 60)"
    switch $ProgramName {
	"Tdyn2D" {
	    set help_Centre_of_Gravity \
		    "Insert the X, Y coordinate of Center of Gravity in geometry units."
	}
	"Tdyn3D" {
	    set help_Centre_of_Gravity \
		    "Insert the X, Y, Z coordinate of Center of Gravity in geometry units."
	}
    }
    # HEATRANS Fields
    set help_Heat_Flux \
	    "Heat flux through the boundary. Positive values are taken as heating flow.\nIt may be a function or a constant (i.e. a 10+200*(5-tm), see Function editor in the bottom-right corner of the window).\nUnits are defined in Problem Data>UNITS>General Units window."
    set help_Heat_Flux_Units \
	    "Heat flux units used in the definition of the heat transfer problem."
    set help_Reactive_Heat_Flux \
	    "Reactive heat flux through the boundary. Positive values are taken as heating flow.\nIt may be a function or a constant (i.e. a 1.2e-4*tm^3, see Function editor in the bottom-right corner of the window).\nUnits are defined in Problem Data>UNITS>General Units window."
    set help_Reactive_Heat_Flux_Units \
	    "Reactive heat flux units used in the definition of the heat transfer problem."
    # ADVECT Fields
    set help_Species_Properties \
	    "Flux_Spc: Species flux through the boundary. Positive values are taken as entering flow\n Reactive_Flux_Spc: Reactive species flux through the boundary."
    set help_Advect "ADVECT module data.\n\
	    Select species from the list and edit their properties.\n\
	    New species may be created by pressing '+' button.\n\
	    It is also possible to delete current species by pressing '-' button.\n\
	    Changing species names or their number will affect all existing fluid materials."
    # URSOLVER Fields
    set help_Variables_Properties \
	    "Flux_Phi: Variables flux through the boundary. Positive values are taken as entering flow\n Reactive_Flux_Phi: Reactive variables flux through the boundary."
    # ALEMESH Fields
    set help_Body_Mass \
	    "Enter the body mass."
    set help_Body_Mass_Units \
	    "Enter the units for body mass."
    set help_Radius_of_Gyration_Z \
	    "Radius of Gyration on OZ"
    set help_Radii_of_Gyration_Units \
	    "Enter the units for Radii of Gyration values."
    switch $ProgramName {
	"Tdyn2D" {
	    set help_Displacement \
		    "Allows translation parallel to OX, OY (surge)"
	}
	"Tdyn3D" {
	    set help_Displacement \
		    "Allows translation parallel to OX, OY, OZ (surge)"
	}
    }
    set help_Rotation_OZ \
	    "Allows planar rotation perpendicular to OZ (yaw)"
    set help_Springs \
	    "Spring links. Give the spring constants (displacement-KD and rotation-KR) and the origin (fixed) and end of the spring. Units are given in Data>Pooblem_Data>UNITS>General_Units option."
    set help_KD_Units \
	    "Force per length units used for defining spring constants."
    set help_KR_Units \
	    "Force per angle units used for defining spring constants."

    #####  HELP Text variables - CONTACT TYPE #####
    # HEATRANS Fields
    set help_Thermal_Resistance \
	    "Thermal_Resistance: Resistance flux through the boundary (resulting flux is equal to resistance multiplied by temperature increment)."
    # ADVECT Fields
    set help_Species_Properties \
	    "Resistance_Spc: Resistance flux through the boundary (resulting flux is equal to resistance multiplied by Spc increment)."
    # URSOLVER Fields
    set help_Variables_Properties \
	    "Resistance_Phi: Resistance flux through the boundary (resulting flux is equal to resistance multiplied by Phi increment)."


    # Main Notebook pages GRID
    set pages [NoteBook $BASE.pages -arcradius 0]
    if { $show_ransol == 1 } {
	set page1 [$pages insert 0 page1 -text "RANSOL"]
	set fpage1 [$pages getframe page1]
    }
    if { $show_heatrans == 1 } {
	set page2 [$pages insert 1 page2 -text "HEATRANS"]
	set fpage2 [$pages getframe page2]
    }
    if { $show_advect == 1 } {
	set page3 [$pages insert 2 page3 -text "ADVECT"]
	set fpage3 [$pages getframe page3]
    }
    if { $show_ursolver == 1 } {
	set page4 [$pages insert 3 page4 -text "URSOLVER"]
	set fpage4 [$pages getframe page4]
    }
    if { $show_alemesh == 1 } {
	set page5 [$pages insert 4 page5 -text "ALEMESH"]
	set fpage5 [$pages getframe page5]
    }

    if { $show_ransol == 1 } {
	$pages raise page1
    } elseif { $show_heatrans == 1 } {
	$pages raise page2
    } elseif { $show_advect == 1 } {
	$pages raise page3
    } elseif { $show_ursolver == 1 } {
	$pages raise page4
    } elseif { $show_alemesh == 1 } {
	$pages raise page4
    }

    # GRIDS PAGES
    grid $pages -row 1 -column 0 -sticky nwes -pady 5
    if { $show_ransol == 1 } {
	grid columnconf $fpage1 15 -weight 1
	grid rowconf $fpage1 15 -weight 1
    }
    if { $show_heatrans == 1 } {
	grid columnconf $fpage2 10 -weight 1
	grid rowconf $fpage2 10 -weight 1
    }
    if { $show_advect == 1 } {
	grid columnconf $fpage3 1 -weight 1
	grid rowconf $fpage3 1 -weight 1
    }
    if { $show_ursolver == 1 } {
	grid columnconf $fpage4 1 -weight 1
	grid rowconf $fpage4 1 -weight 1
    }
    if { $show_alemesh == 1 } {
	grid columnconf $fpage5 15 -weight 1
	grid rowconf $fpage5 15 -weight 1
    }

    if { $show_ransol == 1 } {

	#--------------------------- PAGE RANSOL ---------------------------#

	# Combo boxes Units definitions
	 lappend vals_BoundType "InvisWall" "DeltaWall" "RoughWall" "YplusWall" \
		  "Cw_U2Wall" "ITTC_Wall" "V_fixWall" "User_Wall" "None_Wall"
	lappend vals_Delta_Units "m" "dm" "cm" "mm" "in" "pica" "ft" "yd" "Nmi"
	lappend vals_Roughness_Units "um" "m" "dm" "cm" "mm" "in" "pica" "ft" "yd" "Nmi"
	lappend vals_Angle_Units "deg" "rad"

	# Invisible size label
	set sizelabel [label $fpage1.l_sizelabel \
		-text "                                   " -bd 0 ]

	# Bound Type
	set l_BoundType [Label $fpage1.l_boundtype -text "Bound Type " -helptext $help_BoundType]
	set e_BoundType [ComboBox $fpage1.e_boundtype -values $vals_BoundType \
		-editable false -width [TUI_getcbxsize 11 $vals_BoundType] \
		-textvariable bondfluid::BoundType]

	# Yplus
	set l_Yplus [Label $fpage1.l_yplus -text "Yplus " -helptext $help_Yplus]
	set e_Yplus [entry $fpage1.e_yplus -textvariable bondfluid::Yplus]

	# Delta
	set l_Delta [Label $fpage1.l_delta -text "Delta " -helptext $help_Delta]
	set e_Delta [entry $fpage1.e_delta -textvariable bondfluid::Delta]
	set e_Delta_Units [ComboBox $fpage1.e_delta_units -values $vals_Delta_Units \
		-editable false -width [TUI_getcbxsize 11 $vals_Delta_Units] \
		-textvariable bondfluid::Delta_Units]

	# Cw
	set l_Cw [Label $fpage1.l_cw -text "Cw " -helptext $help_Cw]
	set e_Cw [entry $fpage1.e_cw -textvariable bondfluid::Cw]

	# Roughness
	set l_Roughness [Label $fpage1.l_roughness -text "Roughness " -helptext $help_Roughness]
	set e_Roughness [entry $fpage1.e_roughness -textvariable bondfluid::Roughness]
	set e_Roughness_Units [ComboBox $fpage1.e_roughness_units -values $vals_Roughness_Units \
		-editable false -width [TUI_getcbxsize 11 $vals_Roughness_Units] \
		-textvariable bondfluid::Roughness_Units]

	# FTau Field
	set l_FTau_Field [Label $fpage1.l_ftau -text "FTau Field " -helptext $help_FTau_Field]
	set e_FTau_Field [entry $fpage1.e_ftau -textvariable bondfluid::FTau_Field]

	# Kenr Field
	set l_Kenr_Field [Label $fpage1.l_kenr -text "Kenr Field " -helptext $help_Kenr_Field]
	set e_Kenr_Field [entry $fpage1.e_kenr -textvariable bondfluid::Kenr_Field]

	# Elen Field
	set l_Elen_Field [Label $fpage1.l_elen -text "Elen Field " -helptext $help_Elen_Field]
	set e_Elen_Field [entry $fpage1.e_elen -textvariable bondfluid::Elen_Field]

	# Sharp_Angle
	set l_Sharp_Angle [Label $fpage1.l_sharpangle -text "Sharp Angle " -helptext $help_Sharp_Angle]
	set e_Sharp_Angle [entry $fpage1.e_sharpangle -textvariable bondfluid::Sharp_Angle]

	# Fix_Angle
	set l_Fix_Angle [Label $fpage1.l_fixangle -text "Fix Angle " -helptext $help_Fix_Angle]
	set e_Fix_Angle [entry $fpage1.e_fixangle -textvariable bondfluid::Fix_Angle]

	# SternC_Angle
	set l_SternC_Angle [Label $fpage1.l_sterncangle -text "SternC Angle " -helptext $help_SternC_Angle]
	set e_SternC_Angle [entry $fpage1.e_sterncangle -textvariable bondfluid::SternC_Angle]
	set e_Angle_Units [ComboBox $fpage1.e_angle_units -values $vals_Angle_Units \
		-editable false -width [TUI_getcbxsize 11 $vals_Angle_Units] \
		-textvariable bondfluid::Angle_Units]

	# Centre of Gravity
	switch $ProgramName {
	    "Tdyn2D" {
		set ltext_cog "Centre of Gravity (X Y) "
	    }
	    "Tdyn3D" {
		set ltext_cog "Centre of Gravity (X Y Z) "
	    } 
	}
	set l_Centre_of_Gravity [Label $fpage1.l_cog -text $ltext_cog -helptext $help_SternC_Angle]
	set f_cog [frame $fpage1.f_cog -relief flat]
	set e_Centre_of_Gravity_X [entry $f_cog.e_cog_x -width 6 -textvariable bondfluid::Centre_of_Gravity_X]
	set e_Centre_of_Gravity_Y [entry $f_cog.e_cog_y -width 6 -textvariable bondfluid::Centre_of_Gravity_Y]
	if { $ProgramName == "Tdyn3D" } {
	    set e_Centre_of_Gravity_Z [entry $f_cog.e_cog_z -width 6 -textvariable bondfluid::Centre_of_Gravity_Z]
	}

	# GRIDS
	# SizeLabel
	grid $sizelabel -row 0 -column 0 -sticky en
	grid $l_BoundType -row 1 -column 0 -pady 2 -sticky en
	grid $e_BoundType -row 1 -column 1 -pady 1 -sticky wn
	grid $l_Yplus -row 2 -column 0 -pady 2 -sticky en
	grid $e_Yplus -row 2 -column 1 -pady 1 -sticky wn
	grid $l_Delta -row 3 -column 0 -pady 2 -sticky en
	grid $e_Delta -row 3 -column 1 -pady 1 -sticky wn
	grid $e_Delta_Units -row 3 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_Cw -row 4 -column 0 -pady 2 -sticky en
	grid $e_Cw -row 4 -column 1 -pady 1 -sticky wn
	grid $l_Roughness -row 5 -column 0 -pady 2 -sticky en
	grid $e_Roughness -row 5 -column 1 -pady 1 -sticky wn
	grid $e_Roughness_Units -row 5 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_FTau_Field -row 6 -column 0 -pady 2 -sticky en
	grid $e_FTau_Field -row 6 -column 1 -pady 1 -sticky wn
	grid $l_Kenr_Field -row 7 -column 0 -pady 2 -sticky en
	grid $e_Kenr_Field -row 7 -column 1 -pady 1 -sticky wn
	grid $l_Elen_Field -row 8 -column 0 -pady 2 -sticky en
	grid $e_Elen_Field -row 8 -column 1 -pady 1 -sticky wn
	grid $l_Sharp_Angle -row 9 -column 0 -pady 2 -sticky en
	grid $e_Sharp_Angle -row 9 -column 1 -pady 1 -sticky wn
	grid $l_Fix_Angle -row 10 -column 0 -pady 2 -sticky en
	grid $e_Fix_Angle -row 10 -column 1 -pady 1 -sticky wn
	grid $l_SternC_Angle -row 11 -column 0 -pady 2 -sticky en
	grid $e_SternC_Angle -row 11 -column 1 -pady 1 -sticky wn
	grid $e_Angle_Units -row 11 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_Centre_of_Gravity -row 12 -column 0 -pady 2 -sticky en
	grid $f_cog -row 12 -column 1 -pady 1 -sticky wne
	grid $e_Centre_of_Gravity_X -row 0 -column 0 -sticky wn
	grid $e_Centre_of_Gravity_Y -row 0 -column 1 -sticky wn
	if { $ProgramName == "Tdyn3D" } {
	    grid $e_Centre_of_Gravity_Z -row 0 -column 2 -sticky wn
	}
	grid columnconf $f_cog 3 -weight 1

	
    }

    if { $show_heatrans == 1 } {

	#--------------------------- PAGE HEATRANS ---------------------------#
	
	# Combo boxes Units definitions
	lappend vals_Heat_Flux_Units "Kcal/hour.m\u00b2" "KW/m\u00b2" "cal/hour.m\u00b2" "W/m\u00b2" "cal/s.m\u00b2"
	lappend vals_Reactive_Heat_Flux_Units "Kcal/hour.m\u00b2.Gt" "KW/m\u00b2.Gt" "cal/hour.m\u00b2.Gt" "W/m\u00b2.Gt" "cal/s.m\u00b2.Gt"

	# Invisible label to keep size
	set sizelabel [label $fpage2.l_sizelabel \
		-text "                                   " -bd 0 ]

	# Heat Flux
	set l_Heat_Flux [Label $fpage2.l_heat_flux -text "Heat Flux " -helptext $help_Heat_Flux]
	set e_Heat_Flux [entry $fpage2.e_heat_flux -textvariable bondfluid::Heat_Flux]
	set e_Heat_Flux_Units [ComboBox $fpage2.e_Heat_Flux_units -values $vals_Heat_Flux_Units \
		-editable false -width [TUI_getcbxsize 11 $vals_Heat_Flux_Units] \
		-textvariable bondfluid::Heat_Flux_Units]

	# Reactive Heat Flux
	set l_Reactive_Heat_Flux [Label $fpage2.l_reactive_heat_flux -text "Reactive Heat Flux " -helptext $help_Reactive_Heat_Flux]
	set e_Reactive_Heat_Flux [entry $fpage2.e_reactive_heat_flux -textvariable bondfluid::Reactive_Heat_Flux]
	set e_Reactive_Heat_Flux_Units [ComboBox $fpage2.e_Reactive_Heat_Flux_units -values $vals_Reactive_Heat_Flux_Units \
		-editable false -width [TUI_getcbxsize 11 $vals_Reactive_Heat_Flux_Units] \
		-textvariable bondfluid::Reactive_Heat_Flux_Units]

	# GRIDS
	# SizeLabel
	grid $sizelabel -row 0 -column 0 -sticky en
	grid $l_Heat_Flux -row 1 -column 0 -pady 2 -sticky en
	grid $e_Heat_Flux -row 1 -column 1 -pady 1 -sticky wn
	grid $e_Heat_Flux_Units -row 1 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_Reactive_Heat_Flux -row 2 -column 0 -pady 2 -sticky en
	grid $e_Reactive_Heat_Flux -row 2 -column 1 -pady 1 -sticky wn
	grid $e_Reactive_Heat_Flux_Units -row 2 -column 2 -padx 7 -pady 1 -sticky wn

    }

    if { $show_advect == 1 } {

	#--------------------------- PAGE ADVECT ---------------------------#

	# Title Frame Species List
	set tfr_spclist [TitleFrame $fpage3.tfr_spclist -relief ridge -bd 3\
		-text "Defined Species" -side left ]
	set frame_spclist [$tfr_spclist getframe]

	# Paned window
	set pw [PanedWindow $frame_spclist.pw]
	set pane1 [$pw add -weight 1]
	set pane2 [$pw add -weight 0]

	# Species Names in scrolled window
	set spc_scrw [ScrolledWindow $pane1.spc_scrw -scrollbar both]
	set snlist [listbox $spc_scrw.snlist -selectbackground lightblue -selectforeground black \
		-selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
	$spc_scrw setwidget $snlist

	# Selected Specie values frame
	set svlist [frame $pane2.svlist -relief flat]

	# GRIDS
	# Title Frame
	grid $tfr_spclist -row 1 -column 0 -columnspan 5 -sticky wnes
	grid $pw -row 0 -column 0 -sticky wnes
	grid $spc_scrw -row 0 -column 0 -sticky wnes
	grid rowconf $pane1 0 -weight 1
	grid columnconf $pane1 0 -weight 1
	grid rowconf $pane2 0 -weight 1
	grid columnconf $pane2 0 -weight 1
	grid rowconf $frame_spclist 1 -weight 1
	grid columnconf $frame_spclist 1 -weight 1

	GidHelpRecursive $tfr_spclist $help_Advect

	# BINDS 
	bind $snlist <<ListboxSelect>> ";
	bondfluid::valsavespecie $snlist \"last\" \"advect\"; 
	bondfluid::displayspecievalues $snlist \"advect\";
	bondfluid::displayspeciesnames $snlist \"advect\";
	"
	bind $snlist <ButtonPress-3> "+bondfluid::popupmenu $snlist \"\" \"\" \"\" 2 %X %Y"

	# Insert Species Names to listbox
	bondfluid::displayspeciesnames $snlist "advect"
	# Selecting first Specie
	bondfluid::updatespcselection $snlist 0 "advect"
	# Create Species Values widgets
	bondfluid::makespecie $snlist $svlist "advect"
	# Put specie values into entries
	bondfluid::displayspecievalues $snlist "advect"

    }

    if { $show_ursolver == 1 } {

	#--------------------------- PAGE URSOLVER ---------------------------#

	# Title Frame Species List
	set tfr_spclist [TitleFrame $fpage4.tfr_spclist -relief ridge -bd 3\
		-text "Defined Variables" -side left ]
	set frame_spclist [$tfr_spclist getframe]

	# Paned window
	set upw [PanedWindow $frame_spclist.pw]
	set upane1 [$upw add -weight 1]
	set upane2 [$upw add -weight 0]

	# Variables Names in scrolled window
	set ursv_scrw [ScrolledWindow $upane1.ursv_scrw -scrollbar both]
	set ursnlist [listbox $ursv_scrw.ursnlist -selectbackground lightblue -selectforeground black \
		-selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
	$ursv_scrw setwidget $ursnlist

	# Selected Specie values frame
	set ursvlist [frame $upane2.ursvlist -relief flat]

	# GRIDS
	# Title Frame
	grid $tfr_spclist -row 1 -column 0 -columnspan 5 -sticky wnes
	grid $upw -row 0 -column 0 -sticky wnes
	grid $ursv_scrw -row 0 -column 0 -sticky wnes
	grid rowconf $upane1 0 -weight 1
	grid columnconf $upane1 0 -weight 1
	grid rowconf $upane2 0 -weight 1
	grid columnconf $upane2 0 -weight 1
	grid rowconf $frame_spclist 1 -weight 1
	grid columnconf $frame_spclist 1 -weight 1

	# BINDS 
	bind $ursnlist <<ListboxSelect>> ";
	bondfluid::valsavespecie $ursnlist \"last\" \"ursolver\"; 
	bondfluid::displayspecievalues $ursnlist \"ursolver\";
	bondfluid::displayspeciesnames $ursnlist \"ursolver\";
	"
	bind $ursnlist <ButtonPress-3> "+bondfluid::popupmenu $ursnlist \"\" \"\" \"\" 2 %X %Y"

	# GidHelpRecursive $tfr_spclist $help_URSolver

	# Insert Species Names to listbox
	bondfluid::displayspeciesnames $ursnlist "ursolver"
	# Selecting first Specie
	bondfluid::updatespcselection $ursnlist 0 "ursolver"
	# Create Species Values widgets
	bondfluid::makespecie $ursnlist $ursvlist "ursolver"
	# Put specie values into entries
	bondfluid::displayspecievalues $ursnlist "ursolver"
    }

    if { $show_heatrans == 1 } {

	#--------------------------- PAGE ALEMESH ---------------------------#
	
	# Combo boxes Units definitions
	lappend vals_KD_Units "N/m" "KN/m" "KN/cm" "KN/mm" "N/mm"
	lappend vals_KR_Units "N/deg" "N/rad" "KN/deg" "KN/rad"

	set cbxsizes [TUI_getcbxsize 11 $vals_Heat_Flux_Units]
	set cbxsizes [TUI_getcbxsize $cbxsizes $vals_Reactive_Heat_Flux_Units]

	# Invisible label to keep size
	set sizelabel [label $fpage5.l_sizelabel \
		-text "                                   " -bd 0 ]

	# Heat Flux
	set l_Heat_Flux [Label $fpage5.l_heat_flux -text "Heat Flux " -helptext $help_Heat_Flux]
	set e_Heat_Flux [entry $fpage5.e_heat_flux -textvariable bondfluid::Heat_Flux]
	set e_Heat_Flux_Units [ComboBox $fpage5.e_Heat_Flux_units -values $vals_Heat_Flux_Units \
		-editable false -width $cbxsizes -textvariable bondfluid::Heat_Flux_Units]

	# Reactive Heat Flux
	set l_Reactive_Heat_Flux [Label $fpage5.l_reactive_heat_flux -text "Reactive Heat Flux " -helptext $help_Reactive_Heat_Flux]
	set e_Reactive_Heat_Flux [entry $fpage5.e_reactive_heat_flux -textvariable bondfluid::Reactive_Heat_Flux]
	set e_Reactive_Heat_Flux_Units [ComboBox $fpage5.e_Reactive_Heat_Flux_units -values $vals_Reactive_Heat_Flux_Units \
		-editable false -width $cbxsizes -textvariable bondfluid::Reactive_Heat_Flux_Units]

	# Displacement
	set l_Displacement [Label $fpage5.l_Displacement -text "Displacement " -helptext $help_Displacement]
	set f_Displacement [frame $fpage5.f_displacelemt -relief flat]
	set b_Displacement_OX [checkbutton $f_Displacement.b_displx -offvalue "No" -onvalue "Yes" \
		-variable bondfluid::Displacement_OX -takefocus 1 -indicatoron 1 -text "X"]
	set b_Displacement_OY [checkbutton $f_Displacement.b_disply -offvalue "No" -onvalue "Yes" \
		-variable bondfluid::Displacement_OY -takefocus 1 -indicatoron 1 -text "Y"]
	if { $ProgramName == "Tdyn3D"} {
	    set b_Displacement_OZ [checkbutton $f_Displacement.b_displz -offvalue "No" -onvalue "Yes" \
		    -variable bondfluid::Displacement_OZ -takefocus 1 -indicatoron 1 -text "Z"]
	}

	# Rotation OZ
	set l_Rotation_OZ [Label $fpage5.l_rotation -text "Rotation OZ " -helptext $help_Rotation_OZ]
	set b_Rotation_OZ [checkbutton $fpage5.b_rotoz -offvalue "No" -onvalue "Yes" \
		-variable bondfluid::Rotation_OZ -takefocus 1 -indicatoron 1]

	# Springs
	switch $ProgramName {
	    "Tdyn2D" {
		set columns [list \
		        0 KD left \
		        0 KR left \
		        0 FixX left \
		        0 FixY left \
		        0 EndX left \
		        0 EndY left]
	    }
	    "Tdyn3D" {
		set columns [list \
		        0 KD left \
		        0 KR left \
		        0 FixX left \
		        0 FixY left \
		        0 FixZ left \
		        0 EndX left \
		        0 EndY left \
		        0 EndZ left]
	    }
	}

	# Springs
	set tbl_height [llength $Springs_List]
	if { $tbl_height > 7 } {
	    set tbl_height 7
	} elseif { $tbl_height < 4 } {
	    set tbl_height 4
	}
	set l_Springs [Label $fpage5.l_springs -text "Springs " -helptext $help_Springs]
	set f_Springs [frame $fpage5.f_springs -relief flat]
	set scr_Springs [ScrolledWindow $f_Springs.springs_scrw -scrollbar vertical -auto none]
	set tbl_Springs [tablelist::tablelist $scr_Springs.tbl_springs -columns $columns \
		-listvariable bondfluid::Springs_List -selectmode extended -stretch all \
		-takefocus 1 -height $tbl_height]
	for { set i 0 } { $i < [llength [lindex $Springs_List 0]] } { incr i } {
	    $tbl_Springs columnconfigure $i -editable 1
	}
	$scr_Springs setwidget $tbl_Springs

	# Buttons PLUS MINUS - under the Species Names listbox
	set btnbox [ButtonBox $f_Springs.btnbox -spacing 0 -padx 1 -pady 1 -homogeneous 0]
	$btnbox add -image $buttons::ibtn_plus -width 20 -height 20 \
		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
		-padx 4 -pady 1 -helptext "Add a row" \
		-command "bondfluid::addspring"
	$btnbox add -image $buttons::ibtn_minus -width 20 -height 20 \
		-highlightthickness 1 -takefocus 0 -relief link -borderwidth 1 \
		-padx 4 -pady 1 -helptext "Delete a row" \
		-command "bondfluid::removespring \[$tbl_Springs curselection\]"

	# KD Units
	set l_KD_Units [Label $fpage5.l_KD_Units -text "KD Units " -helptext $help_KD_Units]
	set e_KD_Units [ComboBox $fpage5.e_KD_Units_units -values $vals_KD_Units \
		-editable false -width $cbxsizes -textvariable bondfluid::KD_Units]

	# KR Units
	set l_KR_Units [Label $fpage5.l_KR_Units -text "KR Units " -helptext $help_KR_Units]
	set e_KR_Units [ComboBox $fpage5.e_KR_Units_units -values $vals_KR_Units \
		-editable false -width $cbxsizes -textvariable bondfluid::KR_Units]

	# GRIDS
	# SizeLabel
	grid $sizelabel -row 0 -column 0 -sticky en
	grid $l_Heat_Flux -row 1 -column 0 -pady 2 -sticky en
	grid $e_Heat_Flux -row 1 -column 1 -pady 1 -sticky wn
	grid $e_Heat_Flux_Units -row 1 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_Reactive_Heat_Flux -row 2 -column 0 -pady 2 -sticky en
	grid $e_Reactive_Heat_Flux -row 2 -column 1 -pady 1 -sticky wn
	grid $e_Reactive_Heat_Flux_Units -row 2 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_Displacement -row 3 -column 0 -pady 2 -sticky en
	grid $f_Displacement -row 3 -column 1 -pady 2 -sticky wne
	grid $b_Displacement_OX -row 0 -column 0 -padx 1 -sticky wn
	grid $b_Displacement_OY -row 0 -column 1 -padx 1 -sticky wn
	if { $ProgramName == "Tdyn3D"} {
	    grid $b_Displacement_OZ -row 0 -column 2 -padx 1 -sticky wn
	}
	grid columnconf $f_Displacement 3 -weight 1
	grid $l_Rotation_OZ -row 4 -column 0 -pady 2 -sticky en
	grid $b_Rotation_OZ -row 4 -column 1 -pady 1 -sticky wn
	grid $l_Springs -row 5 -column 0 -pady 2 -sticky en
	grid $f_Springs -row 5 -column 1 -columnspan 5 -pady 2 -sticky wnes
	grid $scr_Springs -row 0 -column 0 -sticky wnes
	grid $btnbox -row 1 -column 0 -sticky wn
	grid rowconf $f_Springs 0 -weight 1
	grid columnconf $f_Springs 0 -weight 1
	grid $l_KD_Units -row 6 -column 0 -pady 2 -sticky en
	grid $e_KD_Units -row 6 -column 1 -padx 7 -pady 1 -sticky wn
	grid $l_KR_Units -row 7 -column 0 -pady 2 -sticky en
	grid $e_KR_Units -row 7 -column 1 -padx 7 -pady 1 -sticky wn
    }

    if { [info exists snlist] == 1 && [info exists ursnlist] == 1 } {
	$pages bindtabs <Button-1> "bondfluid::selectpage $snlist $ursnlist"
    } elseif { [info exists snlist] == 1 && [info exists ursnlist] != 1 } {
	$pages bindtabs <Button-1> "bondfluid::selectpage $snlist \"\""
    } elseif { [info exists snlist] != 1 && [info exists ursnlist] == 1 } {
	$pages bindtabs <Button-1> "bondfluid::selectpage \"\" $ursnlist"
    }
}


# Ading and removing rows in Springs tablelist
proc bondfluid::addspring { } {

    variable Springs_List

    lappend Springs_List [lindex $Springs_List end]

    return 1
}



proc bondfluid::removespring { sel } {

    variable Springs_List

    if { $sel == "" } {
	WarnWin "Please select a row(s) to delete."
    } else {
	if { [llength $sel] < [llength $Springs_List] } {
	    set i 0
	    set temp ""
	    while { $i < [llength $Springs_List] } {
		if { [lsearch $sel $i] == -1 } {
		    lappend temp [lindex $Springs_List $i]
		}
		incr i
	    }
	    set Springs_List $temp
	} else {
	    WarnWin "There must be at least one Spring left."
	}
    }

    return 1
}

proc bondfluid::selectpage { snlist ursnlist {pg ""} } {
    
    variable spcnlastsel
    variable ursnlastsel

    set nlist ""

    if { $pg == "page3" } {
	set type "advect"
	set nlist $snlist
	set setsel $spcnlastsel
	set leavenlist $ursnlist
    } elseif { $pg == "page4" } {
	set type "ursolver"
	set nlist $ursnlist
	set setsel $ursnlastsel
	set leavenlist $snlist
    }

    if { [string length $nlist] > 0 && ( $type == "advect" || $type == "ursolver") } {
	bondfluid::valsavespecie $leavenlist "" $type
	bondfluid::updatespcselection $nlist $setsel $type
	bondfluid::displayspecievalues $nlist $type
    }

    return 1
}



################################################################################
#
#   Species Manipulation
#   The following functions are used to manipulate the ADVECT Species Data
#   as well as the URSolver Variables Data.
#
################################################################################

proc bondfluid::makespecie { nlist vlist type } {

    # Advect Variables
    variable Species_Values
    variable Species_UValues
    variable Species_Names
    variable Species_Valnames
    variable Species_UValnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Valnames
    variable URVariables_UValnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    # Combo boxes Units definitions
    # ADVECT
    lappend units_Flux_Spc_Units "C.m/s" "mC.m/s"
    lappend units_Reactive_Flux_Spc_Units "m/s" "cm/s"
    # URSOLVER
    lappend units_Flux_Phi_Units "U/m\u00b2.s" "cU/m\u00b2.s"
    lappend units_Reactive_Flux_Phi_Units "1/m\u00b2.s" "1/cm\u00b2.s"

    # Grid Values Frame
    grid $vlist -row 0 -column 1 -sticky wnes -padx 15

    switch $type {
	"advect" {
	    # Specie Name
	    set l_sname [Label $vlist.l_sname -text "   Specie Name "]
	    set e_sname [entry $vlist.e_sname -width 21 -textvariable bondfluid::sname]
	}
	"ursolver" {
	    # Variable Name
	    set l_sname [Label $vlist.l_vname -text "Variable Name "]
	    set e_sname [entry $vlist.e_vname -width 21 -textvariable bondfluid::ursname]
	}
    }

    # GRIDS
    # Label
    grid $l_sname -row 0 -column 0 -sticky en -pady 5
    # Entry
    grid $e_sname -row 0 -column 1 -columnspan 2 -sticky wn -pady 5

    # BINDS
    bind $e_sname <Return> ";
    bondfluid::valsavespecie $nlist \"actual\" \"$type\";
    bondfluid::displayspeciesnames $nlist \"$type\";
    "
    bind $e_sname <ButtonPress-3> "+bondfluid::popupmenu $vlist \"\" \"\" \"\" 2 %X %Y"

    switch $type {
	"advect" {
	    set type_Valnames $Species_Valnames
	    set type_UValnames $Species_UValnames
	    set cbmove 1
	}
	"ursolver" {
	    set type_Valnames $URVariables_Valnames
	    set type_UValnames $URVariables_UValnames
	    set cbmove 1
	}
    }

    # Creating widgets
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set tname [lindex [lindex $type_Valnames $i] 0]
	# Defining a Label
	set lvar l_$tvar
	set $lvar [Label $vlist.$lvar -text $tname]
	# Defining an Entry
	set evar e_$tvar
	set $evar [entry $vlist.$evar -width 11 -textvariable bondfluid::$tvar]

	# GRIDS
	# Label
	grid [eval set temp $$lvar] -row [expr $i+1] -column 0 -sticky en -pady 1
	# Entry
	grid [eval set temp $$evar] -row [expr $i+1] -column 1 -sticky wn -pady 1

	# BINDS
	bind [eval set temp $$evar] <Return> ";
	bondfluid::valsavespecie $nlist \"actual\" \"$type\";
	bondfluid::displayspeciesnames $nlist \"$type\";
	"
	bind [eval set temp $$evar] <ButtonPress-3> "+bondfluid::popupmenu $vlist bondfluid::$tvar \"$tname\" \"\" 1 %X %Y"
    }
    for { set i 0 } { $i < [llength $type_UValnames] } { incr i } {
	set tuvar [lindex [lindex $type_UValnames $i] 1]
	set cuvar "units_"
	append cuvar [lindex [lindex $type_UValnames $i] 1]
	# Defining Units Combobox
	set cvar c_$tuvar
	set $cvar [ComboBox $vlist.$cvar -values [eval set temp $$cuvar] \
		-editable 1 -width 7 -textvariable bondfluid::$tuvar -takefocus 1]

	# GRIDS
	# Units Combo
	grid [eval set temp $$cvar] -row [expr $i+$cbmove] -column 2 -sticky wn -padx 2
    }

    return 1
}

proc bondfluid::displayspecievalues { nlist type } {

    # Advect Variables
    variable Species_Values
    variable Species_UValues
    variable Species_Names
    variable Species_Valnames
    variable Species_UValnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Valnames
    variable URVariables_UValnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { [lindex [$nlist curselection] 0] > -1 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	bondfluid::updatespcselection $nlist 0 $type
	set sel [lindex [$nlist curselection] 0]
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set type_Values $Species_Values
	    set type_Valnames $Species_Valnames
	    set type_UValnames $Species_UValnames
	    set type_UValues $Species_UValues
	    set vartype_name "sname"
	    set vartype_lastsel "spcnlastsel"
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set type_Values $URVariables_Values
	    set type_Valnames $URVariables_Valnames
	    set type_UValues $URVariables_UValues
	    set type_UValnames $URVariables_UValnames
	    set vartype_name "ursname"
	    set vartype_lastsel "ursnlastsel"
	}
    }

    # Display Specie / Variable name and set last selection
    set $vartype_name [lindex $type_Names $sel]
    set $vartype_lastsel $sel

    set currvals [lindex $type_Values $sel]
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	# Entries Values
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set $tvar [lindex $currvals $i]
    }
    set currvals [lindex $type_UValues $sel]
    for { set i 0 } { $i < [llength $type_UValnames] } { incr i } {
	# Combo boxes Units values
	set tvar [lindex [lindex $type_UValnames $i] 1]
	set $tvar [lindex $currvals $i]
    }

    return 1
}

proc bondfluid::displayspeciesnames { nlist type } {

    variable Species_Names
    variable URVariables_Names

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { [lindex [$nlist curselection] 0] > -1 } {
	set savesel [lindex [$nlist curselection] 0]
    } else {
	set savesel ""
    }
    set p 0
    $nlist delete 0 end
    foreach n $type_Names {
	$nlist insert $p $n
	incr p
    }

    if { $savesel > -1 } {
	$nlist selection clear 0 end
	$nlist selection set $savesel $savesel
    }

    return 1
}

proc bondfluid::updatespcselection { nlist setsel type } {

    variable Species_Names
    variable URVariables_Names
    variable spcnlastsel
    variable ursnlastsel
    variable sname
    variable ursname

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { $setsel < 0 || $setsel > [expr [llength $type_Names] -1] } {
	set setsel "end"
    }

    $nlist selection clear 0 end
    $nlist selection set $setsel $setsel

    switch $type {
	"advect" {
	    set spcnlastsel $setsel
	    set sname [lindex $type_Names $setsel]
	}
	"ursolver" {
	    set ursnlastsel $setsel
	    set ursname [lindex $type_Names $setsel]
	}
    }

    return 1
}

proc bondfluid::valsavespecie { nlist sel type } {

    # Advect Variables
    variable Species_Values
    variable Species_UValues
    variable Species_Names
    variable Species_Valnames
    variable Species_UValnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Valnames
    variable URVariables_UValnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { $sel == "actual" && [string length [$nlist curselection]] > 0 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	switch $type {
	    "advect" {
		set sel $spcnlastsel
	    }
	    "ursolver" {
		set sel $ursnlastsel
	    }
	}
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set vartype_Names "Species_Names"
	    set type_Values $Species_Values
	    set vartype_Values "Species_Values"
	    set type_Valnames $Species_Valnames
	    set type_UValnames $Species_UValnames
	    set type_UValues $Species_UValues
	    set vartype_UValues "Species_UValues"
	    set type_name $sname
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set vartype_Names "URVariables_Names"
	    set type_Values $URVariables_Values
	    set vartype_Values "URVariables_Values"
	    set type_Valnames $URVariables_Valnames
	    set type_UValnames $URVariables_UValnames
	    set type_UValues $URVariables_UValues
	    set vartype_UValues "URVariables_UValues"
	    set type_name $ursname
	}
    }

    if { $sel > -1 && !($sel > [expr [llength $type_Values] -1]) } {

	# Saving Specie / UR Variable Name
	set $vartype_Names [lreplace $type_Names $sel $sel [string trim [DWSpace2Under $type_name]]]

	# Saving Specie / UR Variable values
	set newvals ""
	for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	    set tvar [lindex [lindex $type_Valnames $i] 1]
	    lappend newvals [eval set temp $$tvar]
	}
	set $vartype_Values [lreplace $type_Values $sel $sel $newvals]
	# Saving Specie / UR Variable Units values
	set newvals ""
	for { set i 0 } { $i < [llength $type_UValnames] } { incr i } {
	    set tvar [lindex [lindex $type_UValnames $i] 1]
	    lappend newvals [eval set temp $$tvar]
	}
	set $vartype_UValues [lreplace $type_UValues $sel $sel $newvals]
    }

    return 1
}



################################################################################
#
#   PopUp Menus
#
################################################################################

proc bondfluid::popupmenu { parent {field ""} {fieldname ""} tags content x y } {

    variable predefined_ff

    catch { 
	destroy $parent.menu
    }

    set menu [menu $parent.menu -type normal]

    switch $content {
	1 {
	    # $menu add command -label "Help" -command bondfluid::definehelptagshere-stillmissing
	    if { [string length $field] > 0 } {
		eval set fval $$field
	    }
	    $menu add command -label "Define Function" \
		    -command "FEditor::init $parent \"$predefined_ff\" $field \"$fieldname\" \"$fval\" \"\" \"\""
	}
    }
    
    tk_popup $menu $x $y

    return 1
}



################################################################################
#
#   GiD Values Manipulation - GET Values, TSAVE and DUMP Values
#   - GETVALUES reads GiD values and puts them to the variables
#   - CHECKCLOSE goes through all variables and checks for changes. If changes 
#     are found, asks the user SAVE YES or NO. If YES, runs DUMP procedure.
#     This procedure also checks the temporal space of Initial Conditions.
#   - TICSAVE saves values from Initial Conditions entries to temporal variables
#     from where in case of accept saving it saves the values tom GiD memory.
#   - DUMP saves values of entries to GiD memory and in case of initial condition
#
################################################################################

proc bondfluid::getvalues { } {

    global ProgramName

    # Tdyn settings
    variable show_advect
    variable show_ursolver

    variable Fluid_Body_Questions
    variable Contact_Questions
    variable Boundary_Name

    variable Species_Names
    variable Species_Values
    variable Species_UValues
    variable Species_Valnames

    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Valnames
    

    # Read all boundary values
    set ValList [TUI_getmatvalueslist $Boundary_Name]

    # Index 0 of ValList defins type of boundary and is not modified by this script.
    set vi 1
    switch [lindex $ValList 0] {
	"Fluid_Body" {
	    foreach item $Fluid_Body_Questions {
		set itt [lindex $item 0]
		variable $itt [lindex $ValList $vi]
		incr vi
	    }
	}
	"Interf" {
	    foreach item $Contact_Questions {
		set itt [lindex $item 0]
		variable $itt [lindex $ValList $vi]
		incr vi
	    }
	}
    }

    if { $show_advect == 1 } {
	# Read Species Names from Problem Data
	set temp [join [lindex [.central.s info gendata] \
		[expr [lsearch [.central.s info gendata] "Species_Names:(SpecieName)"] + 1]]]
	set Species_Names [lreplace $temp 0 1]
    }

    if { $show_ursolver == 1 } {
	# Read URSolver Variables Names from Problem Data
	set temp [join [lindex [.central.s info gendata] \
		[expr [lsearch [.central.s info gendata] "URVariables_Names:(VariableName)"] + 1]]]
	set URVariables_Names [lreplace $temp 0 1]
    }

    if { $show_advect == 1 } {
	set Species_Values [TUI_formatspeciesvalues String2List $Species_Valnames $Species_Properties]
	set Species_UValues [TUI_formatspeciesvalues String2List $Species_Valnames $Spc_Units]
    }

    if { $show_ursolver == 1 } {
	set URVariables_Values [TUI_formatspeciesvalues String2List $URVariables_Valnames $Variables_Properties]
	set URVariables_UValues [TUI_formatspeciesvalues String2List $URVariables_Valnames $URV_Units]
    }

    # FORMAT UNITS HERE !
}

proc bondfluid::checkclose { win {dumpit 1} {askdump 1} {close 1} } {

    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver

    variable Boundary_Name
    variable Fluid_Body_Questions
    variable Contact_Questions

    variable Species_Valnames
    variable Species_Names
    variable Species_Values
    variable snlist

    variable URVariables_Valnames
    variable URVariables_Names
    variable URVariables_Values
    variable ursnlist

    foreach item $Fluid_Body_Questions {
	variable [lindex $item 0]
    }
    foreach item $Contact_Questions {
	variable [lindex $item 0]
    }
    # Last unsaved changes of Species Values - save them
    if { $show_advect == 1 } {
	bondfluid::valsavespecie $snlist "actual" "advect"
	bondfluid::formatunits spc_tomatfile
    }
    if { $show_ursolver == 1 } {
	bondfluid::valsavespecie $ursnlist "actual" "ursolver"
	# Redefine late on when you move your units definition to another place
	# This has to be done at the same time 
	bondfluid::formatunits urs_tomatfile
    }

    bondfluid::formatunits tomatfile

    if { $show_advect == 1 } {
	set Species_Values [TUI_formatspeciesvalues List2String $Species_Valnames $Species_Properties]
    }

    if { $show_ursolver == 1 } {
	set URVariables_Values [TUI_formatspeciesvalues List2String $URVariables_Valnames $URVariables_Properties]
    }

    set pv [TUI_getmatvalueslist $Boundary_Name]
    set valueschange 0
    set wtsave 0
    set vi 1
    set usr_err ""
    set num_usr_err 0
    set uerrpg_ran 0
    set uerrpg_htr 0
    set uerrpg_adv 0
    set uerrpg_urs 0

    foreach item $Fluid_Body_Questions {
	set itt [lindex $item 0]
	set $itt [string trim [eval set nothing $$itt]]
	eval set cv $$itt
	if { [string trim $cv] != [string trim [lindex $pv $vi]] } {
	    set valueschange 1
	    if { [lindex $item 2] == 1 } {
		set errcheck [TUI_valuecheck [eval set nothing $$itt] [lindex $item 1] 0 [lindex $item 4]]
	    } else {
		set errcheck "ok"
	    }
	    if { $errcheck != "ok" && [lindex $item 2] == 1} {
		incr num_usr_err
		switch "[lindex $item 3]" {
		    "ransol" {
		        if { $uerrpg_ran != 1 } {
		            append usr_err "\nRANSOL PAGE\n"
		            set uerrpg_ran 1
		        }
		    }
		    "heatrans" {
		        if { $uerrpg_htr != 1 } {
		            append usr_err "\nHEATRANS PAGE\n"
		            set uerrpg_htr 1
		        }
		    }
		}
		append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
	    }
	}
	incr vi
    }

    if { $show_advect == 1 } {
	# Check also Species Names
	set temp [join [lindex [.central.s info gendata] \
		[expr [lsearch [.central.s info gendata] "Species_Names:(SpecieName)"] + 1]]]
	set temp [lreplace $temp 0 1]
	if { $temp != $Species_Names } {
	    set valueschange 1
	    #################### !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! #####################
	    # To check Species Names repetition, change "-exact" option to "-all" 
	    # in the first following IF condition.
	    #################### !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! #####################
	      set warnedspcnames ""
	      foreach item $Species_Names {
		  if { [llength [lsearch -exact $Species_Names $item]] > 1 && [lsearch -exact $warnedspcnames $item] == -1} {
		      lappend warnedspcnames $item
		      incr num_usr_err
		      if { $uerrpg_adv != 1 } {
		          append usr_err "\nADVECT PAGE\n"
		          set uerrpg_adv 1
		      }
		      append usr_err "$num_usr_err. Specie Name: \"$item\" is included more then once in the Species List. Species have to have unique names."
		  }
		set errcheck [TUI_valuecheck $item string 0]
		if { $errcheck != "ok"} {
		    incr num_usr_err
		    if { $uerrpg_adv != 1 } {
		        append usr_err "\nADVECT PAGE\n"
		        set uerrpg_adv 1
		    }
		    append usr_err "$num_usr_err. Specie Name: \"$item\" is not correct. Species names can only include alphabetical characters, numbers and underscoore.\n"
		}
	    }
	}
	if { [TUI_getmatfieldvalue $Boundary_Name "Concentration_Properties"] != $Concentration_Properties } {
	    set spc_pos 0
	    foreach item $Species_Values {
		set tspn [lindex $Species_Names $spc_pos]
		incr spc_pos
		set valnamepos 0
		foreach itt $item {
		    set valname [lindex $Species_Valnames $valnamepos]
		    incr valnamepos
		    if { [lindex $valname 3] == 1 } {
		        set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0 [lindex $valname 4]]
		    } else {
		        set errcheck "ok"
		    }
		    if { $errcheck != "ok"} {
		        incr num_usr_err
		        if { $uerrpg_adv != 1 } {
		            append usr_err "\nADVECT PAGE\n"
		            set uerrpg_adv 1
		        }
		        append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		    }
		}
	    }
	}
    }

    if { $show_ursolver == 1 } {
	# Check also URSolver Variables Names
	set temp [join [lindex [.central.s info gendata] \
		[expr [lsearch [.central.s info gendata] "URVariables_Names:(VariableName)"] + 1]]]
	set temp [lreplace $temp 0 1]
	if { $temp != $URVariables_Names } {
	    set valueschange 1
	    #################### !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! #####################
	    # To check URSolver Variables Names repetition, change "-exact" option to "-all" 
	    # in the first following IF condition.
	    #################### !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! #####################
	      set warnedurvnames ""
	      foreach item $URVariables_Names {
		  if { [llength [lsearch -exact $URVariables_Names $item]] > 1 && [lsearch -exact $warnedurvnames $item] == -1} {
		      lappend warnedurvnames $item
		      incr num_usr_err
		      if { $uerrpg_ran != 1 } {
		          append usr_err "\nURSOLVER PAGE\n"
		          set uerrpg_urs 1
		      }
		      append usr_err "$num_usr_err. URSolver Variable Name: \"$item\" is included more then once in the Species List. Species have to have unique names."
		  }
		set errcheck [TUI_valuecheck $item string 0]
		if { $errcheck != "ok"} {
		    incr num_usr_err
		    if { $uerrpg_urs != 1 } {
		        append usr_err "\nURSOLVER PAGE\n"
		        set uerrpg_urs 1
		    }
		    append usr_err "$num_usr_err. URSolver Variable Name: \"$item\" is not correct. URSolver Variables names can only include alphabetical characters, numbers and underscoore.\n"
		}
	    }
	}
	if { [TUI_getmatfieldvalue $Boundary_Name "UR_Variables"] != $UR_Variables } {
	    set spc_pos 0
	    foreach item $URVariables_Values {
		set tspn [lindex $URVariables_Names $spc_pos]
		incr spc_pos
		set valnamepos 0
		foreach itt $item {
		    set valname [lindex $URVariables_Valnames $valnamepos]
		    incr valnamepos
		    if { [lindex $valname 3] == 1 } {
		        set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0  [lindex $valname 4]]
		    } else {
		        set errcheck "ok"
		    }
		    if { $errcheck != "ok"} {
		        incr num_usr_err
		        if { $uerrpg_urs != 1 } {
		            append usr_err "\nURSOLVER PAGE\n"
		            set uerrpg_urs 1
		        }
		        append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		    }
		}
	    }
	}
    }

    # Units are formated back to unicode so that they are not seen 
    # in MAT File format in fields whild asking if changes shouldbe saved. 
    bondfluid::formatunits frommatfile
    if { $show_advect == 1 } {
	bondfluid::formatunits spc_frommatfile
    }
    if { $show_ursolver == 1 } {
	bondfluid::formatunits urs_frommatfile
    }

    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win "Boundary: \"$Boundary_Name\"" \
		    "Boundary data has changed.\nDo you want to save changes?" question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display "The following $num_usr_err error"
		    append err_display "(s) were found in the data input:\n"
		} else {
		    set err_display "The following error was found in the data input:\n"
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		bondfluid::dump
	    }
	}
    }

    if { $close == 1 } {
	destroy $win
	return $valueschange
    } else {
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }

}

# Updates material data to file
proc bondfluid::dump { } {

    variable show_advect
    variable show_ursolver
    variable Boundary_Name

    variable Species_Names
    variable URVariables_Names

    variable Species_Rebuild
    variable URVariables_Rebuild

    variable Fluid_Body_Questions
    foreach item $Fluid_Body_Questions {
	variable [lindex $item 0]
    }
    variable Fluid_UnitsRead
    foreach item $Fluid_UnitsRead {
	variable [lindex $item 0]
    }

    # Format units to MAT File format
    foreach item $Fluid_UnitsRead {
	set itt [lindex $item 0]
	set $itt [TUI_formatunits Unicode2Nums [eval set temp $$itt] 1]
    }

    TUI_setnewmatvalues $Boundary_Name [string trim [bondfluid::getcurrentvalset]]
 
    if { $show_advect == 1 } {
	TUI_savespeciesnames "Species_Names:(SpecieName)" $Species_Names
	TUI_synchrospecies "advect" $Species_Rebuild $Boundary_Name
    }
    if { $show_ursolver == 1 } {
	TUI_savespeciesnames "URVariables_Names:(VariableName)" $URVariables_Names
	TUI_synchrospecies "ursolver" $URVariables_Rebuild $Boundary_Name
    }

    # Format units from MAT File format - for the case the user clicks only the MODIFY button
    foreach item $Fluid_UnitsRead {
	set itt [lindex $item 0]
	set $itt [TUI_formatunits Nums2Unicode [eval set temp $$itt] 0]
    }
}

proc bondfluid::getcurrentvalset { } {
    
    variable Fluid_Body_Questions
    foreach item $Fluid_Body_Questions {
	variable [lindex $item 0]
    }

    set Vallist "Fluid "
    foreach item $Fluid_Body_Questions {
	set itt [lindex $item 0]
	eval append Vallist $$itt
	append Vallist " "
    }

    return $Vallist
}