#tdynutils.tcl  -*- TCL -*- Created: JGE Feb-2002, Modified: JGE Feb-2002

###################################################
# UTILIDAD PARA CREAR UN INFORME DE LOS RESULTADOS
###################################################

proc UseCreateReportWindow { {w ""} } {
    global ProblemTypePriv

    if { $w == "" } { set w .gid.createreport }

    if { [info procs InitWindow] != "" } {
	InitWindow $w "Create report window" PrePostCreateReportWindowGeom ""
    } else {
	toplevel $w
    }

    ReportPrefs::init $ProblemTypePriv(problemtypedir)
    CreateReportWindow $w

    set b $w.buts 
    frame $b
    button $b.close -text Close -width 5 -und 0 -command "destroy $w"
    button $b.help -image [imagefromtdyn questionarrow.gif] -command "PickHelp $b.help" \
	    -highlightthickness 0

    wm protocol $w WM_DELETE_WINDOW "tkButtonInvoke $b.close"
    bind $w <Escape> "tkButtonInvoke $b.close"
    bind $w <Alt-c> "tkButtonInvoke $b.close"
    
    grid $b.close -row 2 -column 1 -sticky e -pady 3 -padx 3
    grid $b.help -row 2 -column 3 -pady 2 -sticky w
    grid $b -padx 3 -pady 3
    grid rowconfigure $w {1 2 3} -weight 1
    grid columnconfigure $w 0 -weight 1 
    wm geom $w ""
}

proc CreateReportWindow { base } {

    framelabel $base.f1 "global report"

    label $base.f1.l1 -text Title:
    entry $base.f1.e1 -textvar ReportPrefs::reporttitle

    GidHelp "$base.f1.l1 $base.f1.e1" "This is the title of the report that will be created "\
	    " with button 'Create'."

    frame $base.f1.buts0
    button $base.f1.buts0.b1 -text Description... -width 15 -command \
	    "EnterText $base._desc {ReportPrefs::reportdescription} {Report Description}"
    pack $base.f1.buts0.b1 -side left 

    GidHelp "$base.f1.buts0.b1" "Here can be entered the description of the analysis made. It"\
	    " will appear in the report"

    frame $base.f1.buts
    button $base.f1.buts.b1 -text Create -width 7 -command \
	    "ReportPrefs::CreateReport $base.f1"
    button $base.f1.buts.b2 -text View -width 7 -command \
	    "ReportPrefs::ViewReportHtmlFile $base.f1"
    button $base.f1.buts.b3 -text Export -width 7 -command \
	    "ReportPrefs::ExportReport $base.f1"

    GidHelp "$base.f1.buts.b1" "This button will create a new report of the analysis."\
	    "It can be filled afterwards by using buttons 'Insert'."

    GidHelp "$base.f1.buts.b2" "This button launches a viewer that will display the created report"\
	    "\nIt must be previously created with button 'Create'."

    set projectdir [ReportPrefs::GiveProjectDir]
    if { $projectdir == "" } { set projectdir MODEL.gid }

    GidHelp "$base.f1.buts.b3" "This button exports the report as an HTML file."\
	    "\nIt is also possible to obtain the HTML file by searching in the model "\
	    "directory: $projectdir"

    proc UpdateViewReportButton { args } {
	foreach w $args {
	    if { [winfo exists $w] } {
		if { $ReportPrefs::reportfilename == "" } {
		    $w conf -state disabled
		} else {
		    $w conf -state normal
		}
	    }
	}
    }

    trace var ReportPrefs::reportfilename w "UpdateViewReportButton $base.f1.buts.b2 \
	    $base.f1.buts.b3 ;#"
    set ReportPrefs::reportfilename $ReportPrefs::reportfilename

    grid $base.f1.buts.b1 -row 1 -column 1 -padx 2 -pady 2
    grid $base.f1.buts.b2 -row 1 -column 2 -padx 2 -pady 2
    grid $base.f1.buts.b3 -row 1 -column 3 -padx 2 -pady 2

    grid $base.f1.l1 -row 1 -column 1 -sticky e -pady $ReportPrefs::FramesSeparation
    grid $base.f1.e1 -row 1 -column 2 -sticky ew -padx 2
    grid $base.f1.buts0 -row 2 -column 1 -columnspan 2 -sticky w -padx 2
    grid $base.f1.buts -row 3 -column 1 -columnspan 2 -sticky ew
    grid columnconf $base.f1 2 -weight 1

    framelabel $base.f2 "insert current view"
    label $base.f2.l1 -text Caption:
    entry $base.f2.e1 -textvar ReportPrefs::reportlastimgcaption

    frame $base.f2.buts
    button $base.f2.buts.b1 -text Insert -width 8 -command \
	    "ReportPrefs::AddCurrentViewToReport $base"
    button $base.f2.buts.b2 -text "Delete last" -width 8 -command \
	    "ReportPrefs::DeleteLastFromReport $base image"

    GidHelp "$base.f2.l1 $base.f2.e1" "When inserting an image in the report with button 'Insert',"\
	    " caption is the text that appears just below the image, describing it."

    GidHelp "$base.f2.buts.b1" "This option inserts current view of the model at the end"\
	    " of the report."
    GidHelp "$base.f2.buts.b2" "This button deletes from the report the last inserted image"

    grid $base.f2.buts.b1 -row 1 -column 1 -padx 2 -pady 2
    grid $base.f2.buts.b2 -row 1 -column 2 -padx 2 -pady 2
    
    grid $base.f2.l1 -row 1 -column 1 -sticky e -pady $ReportPrefs::FramesSeparation
    grid $base.f2.e1 -row 1 -column 2 -sticky ew -padx 2
    grid $base.f2.buts -row 3 -column 1 -columnspan 2 -sticky ew
    grid columnconf $base.f2 2 -weight 1

    framelabel $base.f3 "insert text"
    button $base.f3.edit -text "Edit text..." -width 15 -command \
	    "EnterText $base._text {ReportPrefs::reportlasttext} {Edit text}"
    frame $base.f3.buts
    button $base.f3.buts.b1 -text Insert -width 8 -command \
	    "ReportPrefs::AddCurrentTextToReport $base"
    button $base.f3.buts.b2 -text "Delete last" -width 8 -command \
	    "ReportPrefs::DeleteLastFromReport $base text"

    GidHelp "$base.f3.edit" "Here can be entered a text to be included in the report."
    GidHelp "$base.f3.buts.b1" "This option inserts the current text at the end of the report"
    GidHelp "$base.f3.buts.b2" "This button deletes from the report the last inserted text"

    grid $base.f3.buts.b1 -row 1 -column 1 -padx 2 -pady 2
    grid $base.f3.buts.b2 -row 1 -column 2 -padx 2 -pady 2
    
    grid $base.f3.edit -row 1 -column 1 -sticky e -pady $ReportPrefs::FramesSeparation
    grid $base.f3.buts -row 3 -column 1 -columnspan 2 -sticky ew
    grid columnconf $base.f3 2 -weight 1

#    framelabel $base.f3 "insert current results"

#    frame $base.f3.buts
#    button $base.f3.buts.b1 -text Insert -width 8 -command \
#            "ReportPrefs::AddCurrentResultsToReport $base"
#    button $base.f3.buts.b2 -text "Delete last" -width 8 -command \
#            "ReportPrefs::DeleteLastFromReport $base results"

#    GidHelp "$base.f3.buts.b1" "This option inserts last results obtained with buttons"\
#            " 'Dimension' or 'Check' at the end of the report."
#    GidHelp "$base.f3.buts.b2" "This button deletes from the report the last inserted results"


#    grid $base.f3.buts.b1 -row 1 -column 1 -padx 2 -pady 2
#    grid $base.f3.buts.b2 -row 1 -column 2 -padx 2 -pady 2
    
#    grid $base.f3.buts -row 1 -column 1 -columnspan 2 -sticky ew -pady $ReportPrefs::FramesSeparation
#    grid columnconf $base.f3 2 -weight 1

#    framelabel $base.f4 "export dxf"

#    frame $base.f4.buts
#    button $base.f4.buts.b1 -text "Export DXF" -width 12 -command \
#            "ReportPrefs::ExportDXF $base"

#    GidHelp "$base.f4.buts.b1" "This button exports as a DXF file the drawing of the last"\
#            " sections obtained with buttons 'Dimension' or 'Check'"

#    grid $base.f4.buts.b1 -row 1 -column 1 -padx 2 -pady 2
    
#    grid $base.f4.buts -row 1 -column 1 -columnspan 2 -sticky ew -pady $GUIState::FramesSeparation
#    grid columnconf $base.f4 2 -weight 1

    grid $base.f1 -padx 5 -pady $ReportPrefs::FramesSeparation
    grid $base.f2 -padx 5 -pady $ReportPrefs::FramesSeparation
    grid $base.f3 -padx 5 -pady $ReportPrefs::FramesSeparation

#    pack $base.f1 -side top -padx 5 -pady $GUIState::FramesSeparation -expand 0 -fill x
#    pack $base.f2 -side top -padx 5 -pady $GUIState::FramesSeparation -expand 0 -fill x
#    pack $base.f3 -side top -padx 5 -pady $GUIState::FramesSeparation -expand 0 -fill x
#    pack $base.f4 -side top -padx 5 -pady $GUIState::FramesSeparation -expand 0 -fill x
} 

namespace eval ReportPrefs {
    variable ramdir
    variable elem ""
    variable pointelem ""
    variable lasthtmlfile ""
    variable elemuse Automatic
    variable elemname ""
    variable SymbolsAsImages 0
    variable reporttitle ""
    variable reportfilename ""
    variable reportdescription ""
    variable reportlasttext ""
    variable reportlastimgcaption ""
    variable reportexportdir ""
    variable syma 
    variable symb 
    variable symd 
    variable syme 
    variable symg 
    variable symf 
    variable symh 
    variable symmm
    variable sym12 
    variable sym14
    variable sym34 
    variable supF
    variable subF
    variable norF
    variable sqrF
    proc init { dir } {
	variable ramdir
	variable FontHeight
	variable FramesSeparation
	variable syma 
	variable symb 
	variable symd 
	variable syme 
	variable symg 
	variable symf 
	variable symh 
	variable symmm 
	variable sym12 
	variable sym14
	variable sym34 
	variable supF
	variable subF
	variable norF
	variable sqrF
	# inicializacin de algunas variables
	set ramdir $dir 
	DefFonts
	set FontHeight [font metric BoldFont -linespace]
	set FramesSeparation [expr $FontHeight/2+1]
	# creacin de los smbolos
	set syma [image create photo \
		-file [file join $dir images sym-a.gif]]
	set symb [image create photo \
		-file [file join $dir images sym-b.gif]]
	set symd [image create photo \
		-file [file join $dir images sym-d.gif]]
	set syme [image create photo \
		-file [file join $dir images sym-e.gif]]
	set symg [image create photo \
		-file [file join $dir images sym-g.gif]]
	set symf [image create photo \
		-file [file join $dir images sym-f.gif]]
	set symh [image create photo \
		-file [file join $dir images sym-h.gif]]
	set symmm [image create photo \
		-file [file join $dir images sym-mm.gif]]
	set sym12 [image create photo \
		-file [file join $dir images sym-12.gif]]
	set sym14 [image create photo \
		-file [file join $dir images sym-14.gif]]
	set sym34 [image create photo \
		-file [file join $dir images sym-34.gif]]
	set subF [image create photo \
		-file [file join $dir images sym-2d.gif]]
	set supF [image create photo \
		-file [file join $dir images sym-2u.gif]]
	set norF [image create photo \
		-file [file join $dir images sym-2n.gif]]
	set sqrF [image create photo \
		-file [file join $dir images sym-sqr.gif]]
	# Read existing file if found
	Read
    }
    proc DefFonts {} {
	global tcl_platform
	set size 12
	if { [lsearch [font names] NormalFont] != -1 } {
	    set size [font configure NormalFont -size]
	}
	if { [lsearch [font names] BoldFont] == -1 } {
	    if { $tcl_platform(platform) == "windows"} {
		font create BoldFont -family "MS Sans Serif" -size $size
	    } else {
		font create BoldFont -family {new century schoolbook} -size [expr $size+2]
	    }
	    #          option add *font BoldFont
	    option add *Button*BorderWidth 1
	}
	if { [lsearch [font names] SmallFont] == -1 } {
	    if { $tcl_platform(platform) == "windows"} {
		font create SmallFont -family "MS Sans Serif" -size [expr $size-2]
	    } else {
		font create SmallFont -family {new century schoolbook} -size [expr $size-2]
	    }
	} elseif { [font conf SmallFont -size] >= [font conf NormalFont -size]} {
	    set size [font conf NormalFont -size]
	    set family [font conf NormalFont -family]
	    font conf SmallFont -family $family -size [expr $size-2]
	}
	if { [lsearch [font names] SymbolFont] == -1 } {
	    if { $tcl_platform(platform) == "windows"} {
		font create SymbolFont -family Symbol -size $size
	    } else {
		font create SymbolFont -family Symbol -size [expr $size+2]
	    }
	    #          option add *font BoldFont
	    option add *Button*BorderWidth 1
	}
    }
    proc ViewPoint {} {
	variable pointelem
	if { $pointelem == "" } {
	    WarnLine "There is no point to view. Select firt one"
	    return
	}
	.central.s process escape escape escape escape Utilities SignalEntities \
		Nodes FNoJoin $pointelem

    }
    proc GiveTempDir {} {
	global env

	if { [info exists env(TEMP)] } {
	    return $env(TEMP)
	}
	if { [info exists env(TMP)] } {
	    return $env(TMP)
	}
	if { [info exists env(WINDIR) && [file isdir [file join $env(WINDIR) temp]]] } {
	    return [file join $env(WINDIR) temp]
	}
	if { [file isdir /tmp] } {
	    return /tmp
	}
	return ""
    }
    proc GiveProjectDir {} {
	set aa [.central.s info Project]
	set ProjectName [lindex $aa 1]
	if { [file extension $ProjectName] == ".gid" } {
	    set ProjectName [file root $ProjectName]
	}
	
	if { $ProjectName == "UNNAMED" } {
	    return ""
	}
	
	set directory $ProjectName.gid
	if { [file pathtype $directory] == "relative" } {
	    set directory [file join [pwd] $directory]
	}
	return $directory
    }
    proc ExistsReport { } {

	set aa [.central.s info Project]
	set ProjectName [lindex $aa 1]
	if { [file extension $ProjectName] == ".gid" } {
	    set ProjectName [file root $ProjectName]
	}

	set directory $ProjectName.gid
	if { [file pathtype $directory] == "relative" } {
	    set directory [file join [pwd] $directory]
	}
	set file [file join $directory [file tail $ProjectName].html]
	return [file exists $file]
    }
    proc GiveReportName { {needname "no"} } {

	if { $needname=="yes" } {
	    set info [.central.s info list_entities status]
	    regexp "name:\[ ]*(\[^\n]*)\n" $info {} projectname
	    if { [.central.s info postprocess arewein]=="YES" } {
		if { $projectname=="(null)" } { 
#                    WarnWin "A project title is needed. Save project to get it."
		    return ""
		}
	    } else {
		if { $projectname=="UNNAMED" } { 
#                    WarnWin "A project title is needed. Save project to get it."
		    return ""
		} 
	    }
	}

	set aa [.central.s info Project]
	set ProjectName [lindex $aa 1]
	if { [file extension $ProjectName] == ".gid" } {
	    set ProjectName [file root $ProjectName]
	}
	
	if { $ProjectName == "UNNAMED" } {
	    set dir [GiveTempDir]
	    if { $dir != "" } {
		return [file join $dir tmp_report.html]
	    }
	    return ""
	}

	set directory $ProjectName.gid
	if { [file pathtype $directory] == "relative" } {
	    set directory [file join [pwd] $directory]
	}
	return [file join $directory [file tail $ProjectName].html]
    }
    proc SaveFile { file { isglobal } } {
	variable varstosave
	variable varstosaveglobal

	if { [catch {
	    set fout [open $file w]
	} err] } {
	    WarnWin [concat "It is not possible to save data in file '$file'. "\
		    "Check your writing permissions"]
	    return -1
	}

	if { !$isglobal } {
	    set vars $varstosave
	} else {
	    set vars $varstosaveglobal
	}

	foreach i $vars {
	    foreach j [info vars ::ReportPrefs::$i] {
		set var [namespace tail $j]
		variable $var
		if { [array exists $var] } {
		    puts $fout "begin array $var"
		    foreach k [array names $var] {
		        puts $fout "   [list $k [set ${var}($k)]]"
		    }
		    puts $fout "end array"
		} elseif { [info exists $var] } {
		    puts $fout [list $var [set $var]]
		}
	    }
	}
	close $fout
	return 0
    }
    proc SaveLocal {} {
	set dir [GiveProjectDir]
	if { $dir != "" } {
	    set file [file join $dir concrete.prefs]
	    SaveFile $file 0
	}
    }
    proc Save {} {
	variable saveprefsonproblemtype 
	variable ramdir 
	
	set retval -1 ; set retval2 -1;

	if { $saveprefsonproblemtype } {
	    set file [file join $ramdir concrete.prefs]
	    set retval [SaveFile $file 1]
	}
	if { !$saveprefsonproblemtype || $retval } {
	    set dir [GiveProjectDir]
	    if { $dir != "" } {
		set file [file join $dir concrete.prefs]
		set retval2 [SaveFile $file 0]
	    }
	}

	if { $saveprefsonproblemtype && $retval } {
	    if { !$retval2 } {
		WarnWin [concat "It is not possible to save data in Rambshell. "\
		        "Check your writing permissions. Data has been saved locally"]
	    } else {
		WarnWin [concat "It is not possible to save data in Rambshell. "\
		        "Check your writing permissions. Data has NOT been saved"]
	    }
	}
	if { !$saveprefsonproblemtype && $retval2 } {
	    WarnWin [concat "It is not possible to save data in local project. "\
		    "Check your writing permissions and disk space. Data has NOT been saved"]
	}
    }
    proc ReadFile { file } {
	if { [catch {
	    set fin [open $file r]
	} ] } { return }
	set array ""
	while { ![eof $fin] } {
	    gets $fin aa
	    set name [lindex $aa 0]
	    set value [lindex $aa 1]
	    if { $name == "begin" && $value == "array" } {
		set array [lindex $aa 2]
		variable $array
		catch { unset $array }
	    } elseif { $name == "end" && $value == "array" } {
		set array ""
	    } elseif { $array != "" } {
		set [set array]($name) $value
	    } else {
		variable $name
		set $name $value
	    }
	}
	close $fin
    }
    proc ReadHtmlFile { file } {
	variable reporttitle
	variable reportdescription
	variable reportlasttext
	variable reportlastimgcaption
	if { [catch {
	    set fin [open $file r]
	} ] } { return }
	
	set initialtext ""
	set imagetext ""
	set lasttext ""
	set ONinitialtext 1
	set ONimagetext 0
	set ONlasttext 0
	while { ![eof $fin] } {
	    gets $fin aa
	    if { [regexp "<a\[ ]+name=\"image\"" $aa] } { 
		set ONimagetext 1 
		set imagetext ""
	    }
#            if { [regexp "<a\[ ]+name=\"tdyntext\"" $aa] }
	    if { [regexp "<br clear=left>" $aa] } {
		set ONlasttext 1
		set lasttext ""
	    }
	    if { $ONinitialtext } { append initialtext $aa }
	    if { $ONimagetext   } { append imagetext $aa }
	    if { $ONlasttext    } { append lasttext  $aa }
#            if { [regexp "<\a>" $aa] && $ONlasttext } { set ONlasttext 0 }         
	    if { [regexp "<\br>" $aa] && $ONlasttext } { set ONlasttext 0 } 
	    if { [regexp "</table>" $aa] && $ONimagetext } { set ONimagetext 0 }
	    if { [regexp "</p></p>" $aa] } { set ONinitialtext 0 }
	}
	close $fin
	
	set reporttitle ""
	regexp "<title>(.*)</title>" $initialtext {} reporttitle
	set reportdescription ""
	regexp "<p><p>(.*)</p></p>" $initialtext {} reportdescription
	set reportlastimgcaption ""
	regexp -all "<a\[ ]+name=\"image\".*<center>(.*)</center>" $imagetext {} reportlastimgcaption
	set reportlasttext ""
#        regexp -all "<a\[ ]+name=\"tdyntext\"><p><p>(.*)</p></p></a>" $lasttext {} reportlasttext
	regexp -all "<br clear=left><p><p>(.*)</p></p></br>" $lasttext {} reportlasttext
	set reporttitle [getshtml $reporttitle]
	set reportdescription [getshtml $reportdescription]
	set reportlastimgcaption [getshtml $reportlastimgcaption]
	set reportlasttext [getshtml $reportlasttext]
    }
    proc Read {} {
	variable ramdir
	variable reportfilename
	if { [ExistsReport] } {
	    set reportfilename [GiveReportName]
	    ReadHtmlFile $reportfilename
	}
    }
    proc ViewLastHtmlFile { base } {
	variable lasthtmlfile
	variable ramdir

	if { $lasthtmlfile == "" } {
	    WarnWin "There are no results to view"
	    return
	}
	if { ![file readable $lasthtmlfile] } {
	    WarnWin "Results cannot be viewed"
	    return
	}
	set top [winfo toplevel $base]
	set x [expr [winfo x $top]+[winfo width $top]/2-350]
	set y [expr [winfo y $top]+[winfo height $top]/2-300]
	set geom 650x600+${x}+$y

	HelpWindowRam -geomhelp $geom -tt -title Results -win .gid.results $lasthtmlfile

#          set exec [file join $ramdir HelpViewer]
#          exec $exec -geomhelp $geom -tt -title Results $lasthtmlfile &
    }
    proc ViewReportHtmlFile { base } {
	variable reportfilename
	variable ramdir

	if { $reportfilename == "" } {
	    WarnWin "There is no report to view. Create it first with button 'Create'"
	    return
	}

	set reportfilename [GiveReportName]

	if { ![file readable $reportfilename] } {
	    WarnWin "Report cannot be viewed (check problems in file: '$reportfilename')"
	    return
	}
	set top [winfo toplevel $base]
	set x [expr [winfo x $top]+[winfo width $top]/2-350]
	set y [expr [winfo y $top]+[winfo height $top]/2-300]
	set geom 650x600+${x}+$y
	HelpWindowRam -geomhelp $geom -tt -title Report -win .gid.report $reportfilename
#          set exec [file join $ramdir HelpViewer]
#          exec $exec -geomhelp $geom -tt -title Report $reportfilename &
    }
    proc ViewHelpFor { base file } {
	variable ramdir

#          set top [winfo toplevel $base]
#          set x [expr [winfo x $top]+[winfo width $top]/2-350]
#          set y [expr [winfo y $top]+[winfo height $top]/2-300]
#          set geom 650x600+${x}+$y
#          set exec [file join $ramdir HelpViewer]
#          exec $exec -geomhelp $geom -tt [file join $ramdir $file] &
	HelpWindow CUSTOM_HELP_FILE [file join $ramdir $file]
    }
    proc AddCurrentViewToReport { base } {
	variable reportfilename
	variable reportlastimgcaption

	if { $reportfilename == "" } {
	    WarnWin "There is no report where to add current view. Create it first with button 'Create'"
	    return
	}
	
	set reportfilename [GiveReportName]

	if { ![file writable $reportfilename] } {
	    WarnWin "Report cannot be modified (check problems in file: '$reportfilename')"
	    return
	}
	set dir [file join [file dirname $reportfilename] images]
	set i 1
	if { ![file exists $dir] } {
	    file mkdir $dir
	}
	while { [file exists [file join $dir view$i.gif]] } { incr i }
	set img [file join $dir view$i.gif]
	set shortimg [file join images view$i.gif]
	.central.s process Hardcopy GIF \"$img\" escape
	file rename $reportfilename $reportfilename.tmp
	set fin [open $reportfilename.tmp r]
	set fout [open $reportfilename w]
	while { ![eof $fin] } {
	    gets $fin aa
	    if { [regexp {</body>} $aa] } {
		puts $fout "<a name=\"image\"></a>"
		puts $fout "<br clear=all>"
		puts $fout "<table>\n<tr><td>"
		puts $fout "<img src=\"$shortimg\" align=\"center\">"
		puts $fout "</tr>\n<tr><td><center>$reportlastimgcaption</center></tr></table>"
	    } 
	    puts $fout $aa
	}
	close $fin
	close $fout
	file delete $reportfilename.tmp
	WarnWinReport "Image inserted OK" $base
    }
    proc AddCurrentTextToReport { base } {
	variable reportfilename
	variable reportlasttext

	if { $reportfilename == "" } {
	    WarnWin "There is no report where to add current view. Create it first with button 'Create'"
	    return
	}
	
	set reportfilename [GiveReportName]

	if { ![file writable $reportfilename] } {
	    WarnWin "Report cannot be modified (check problems in file: '$reportfilename')"
	    return
	}
	
	file rename $reportfilename $reportfilename.tmp
	set fin [open $reportfilename.tmp r]
	set fout [open $reportfilename w]
	while { ![eof $fin] } {
	    gets $fin aa
	    if { [regexp {</body>} $aa] } {
#                putshtml $fout "<a name=\"tdyntext\"><p>$reportlasttext</p></a>"
		putshtml $fout "<br clear=left><p>$reportlasttext</p></br>"
	    }
	    puts $fout $aa
	}
	close $fin
	close $fout
	file delete $reportfilename.tmp
	WarnWinReport "Text inserted OK" $base
    }
    proc AddCurrentResultsToReport { base } {
	variable reportfilename
	variable lasthtmlfile

	if { $reportfilename == "" } {
	    WarnWin [concat "There is no report where to add current results. "\
		    "Create it first with button 'Create'"]
	    return
	}

	set reportfilename [GiveReportName]

	if { ![file writable $reportfilename] } {
	    WarnWin "Report cannot be modified (check problems in file: '$reportfilename')"
	    return
	}
	if { ![file readable $lasthtmlfile] } {
	    WarnWin "There are no results to add. Create them with 'Dimension' or 'Check'"
	    return
	}
	set imgtodir [file join [file dirname $reportfilename] images]
	set fromdir [file dirname $lasthtmlfile]
	set i 1
	if { ![file exists $imgtodir] } {
	    file mkdir $imgtodir
	}
	file rename $reportfilename $reportfilename.tmp
	set fin [open $reportfilename.tmp r]
	set finres [open $lasthtmlfile r]
	set fout [open $reportfilename w]
	while { ![eof $fin] } {
	    gets $fin aa
	    if { [regexp {</body>} $aa] } {
		puts $fout "<a name=\"results\"></a>"
		puts $fout "<br clear=all><hr width=90% align=center>"
		set isinit 0
		while { ![eof $finres] } {
		    gets $finres bb
		    if { [regexp {<body} $bb] } {
		        set isinit 1
		    } elseif { !$isinit } { continue }
		    if { [regexp {</body} $bb] } { break }
		    set ini 0
		    while { [regexp -indices "<img\[ ]+src=\"(\[^\"]+)\"" [string range $bb $ini end] \
		            {} imgidx] } {
		        set idx1 [expr $ini+[lindex $imgidx 0]]
		        set idx2 [expr $ini+[lindex $imgidx 1]]
		        set imgname [string range $bb $idx1 $idx2]
		        if { [regexp {^sym-} [file tail $imgname]] } {
		            if { ![file exists  [file join $imgtodir [file tail $imgname]]] } {
		                file copy [file join $fromdir $imgname] $imgtodir
		            }
		            set newname [file tail $imgname]
		        } else {
		            regexp {^[^0-9.]+} [file tail $imgname] shortname
		            set i 1
		            while { [file exists [file join $imgtodir $shortname$i.gif]] } { incr i }
		            set newname $shortname$i.gif
		            set imgtoname [file join $imgtodir $newname]
		            file copy [file join $fromdir $imgname] $imgtoname
		        }
		        set bb [join [list [string range $bb 0 [expr $idx1-1]] \
		                [file join images $newname] [string range $bb \
		                [expr $idx2+1] end]] ""]
		        set ini $idx2
		    }
		    puts $fout $bb
		}
	    } 
	    puts $fout $aa
	}
	close $fin
	close $fout
	close $finres
	file delete $reportfilename.tmp
	WarnWinReport "Results inserted OK" $base
    }
    proc DeleteLastFromReport { base what } {
	variable reportfilename
	variable lasthtmlfile

	if { $reportfilename == "" } {
	    WarnWin "There is no report where to delete last $what. Create it first with button 'Create'"
	    return
	}

	set reportfilename [GiveReportName]

	if { ![file writable $reportfilename] } {
	    WarnWin "Report cannot be modified (check problems in file: '$reportfilename')"
	    return
	}

	set fin [open $reportfilename r]
	set nline 1
	set linebegin ""
	set lineend ""
	while { ![eof $fin] } {
	    gets $fin aa
	    if { $what == "results" } {
		if { [regexp "<a\[ ]+name=\"results\"" $aa] } {
		    set linebegin $nline
		    set lineend ""
		} elseif { [regexp "<a\[ ]+name=\"image\"" $aa] } {
		    if { $linebegin != "" && $lineend == "" } {
		        set lineend [expr $nline -1]
		    }
		}
	    } elseif { $what == "image" } {
		if { [regexp "<a\[ ]+name=\"image\"" $aa] } {
		    set linebegin $nline
		    set lineend ""
		} elseif { [regexp "<a\[ ]+name=\"results\"" $aa] } {
		    if { $linebegin != "" && $lineend == "" } {
		        set lineend [expr $nline -1]
		    }
		}
	    } elseif { $what == "text" } {
#                 if { [regexp "<a\[ ]+name=\"tdyntext\"" $aa] }
		if { [regexp "<br clear=left" $aa] } {
		    set linebegin $nline
		    set lineend ""
		} elseif { [regexp "</br>" $aa] } {        
#                } elseif { [regexp "</a>" $aa] } {
		    if { $linebegin != "" && $lineend == "" } {
		        set lineend [expr $nline -1]
		    }
		}
	    }
	    if { [regexp {</body>} $aa] } {
		if { $linebegin != "" && $lineend == "" } {
		    set lineend [expr $nline -1]
		}
		break
	    }
	    incr nline
	}
	close $fin

	if { $linebegin == "" } {
	    WarnWin "error: There is no $what to delete in the report"
	    return
	}
	set retval [tk_dialogRAM  $base._tmp Warning "Are you sure to delete last $what from report?" \
		warning 0 OK Cancel]
	if { $retval == 1 } { return }

	file rename $reportfilename $reportfilename.tmp
	
	set fin [open $reportfilename.tmp r]
	set fout [open $reportfilename w]

	set dir [file dirname $reportfilename]
	set nline 1
	while { ![eof $fin] } {
	    gets $fin aa
	    if { $nline < $linebegin || $nline > $lineend } {
		puts $fout $aa
	    } else {
		set ini 0
		while { [regexp -indices "<img\[ ]+src=\"(\[^\"]+)\"" [string range $aa $ini end] \
		        {} imgidx] } {
		    set idx1 [expr $ini+[lindex $imgidx 0]]
		    set idx2 [expr $ini+[lindex $imgidx 1]]
		    set imgname [file join $dir [string range $aa $idx1 $idx2]]
		    if { [regexp {^sym-} [file tail $imgname]] } {
		        # nothing
		    } elseif { [file exists $imgname] } {
		        file delete $imgname
		    }
		    set ini $idx2
		}
	    }
	    incr nline
	}
	close $fin
	close $fout
	file delete $reportfilename.tmp
	WarnWinReport "Last $what deleted OK from report" $base
    }
    proc ExportReport { base } {
	variable reportfilename
	variable reportexportdir

	if { $reportfilename == "" } {
	    WarnWin "There is no report to export. Create it first with button 'Create'"
	    return
	}

	set reportfilename [GiveReportName]

	if { ![file readable $reportfilename] } {
	    WarnWin "Report cannot be read (check problems in file: '$reportfilename')"
	    return
	}
	if { ![file isdir $reportexportdir] } {
	    set reportexportdir [pwd]
	}
	
	global tk_strictMotif
	set tk_strictMotif_save $tk_strictMotif
	set tk_strictMotif 0
	set filename [tk_getSaveFile -defaultextension .html -filetypes {{"HTML files" ".html .htm"}} \
		-initialdir $reportexportdir -initialfile [file tail $reportfilename] -parent $base \
		-title "Export report"]
	set tk_strictMotif $tk_strictMotif_save
	if { $filename == "" } { return }
	set reportexportdir [file dirname $filename]
	if { [string compare -nocase $reportexportdir [file dirname $reportfilename]]==0 } {
	    WarnWin "Cannot export to the model directory"
	    return
	}
	set imgdir [file join $reportexportdir images]
	if { [file exists $imgdir] } {
	    set retval [tk_dialogRAM  $base._tmp Warning [concat "Are you sure to delete directory "\
		    " '$imgdir' and all its contents?"]\
		    warning 0 OK Cancel]
	    if { $retval == 1 } { return }
	    if { [catch {
		file delete -force $imgdir
	    } err] } {
		WarnWin "error: Could not delete directory '$imgdir' ($err)"
		return
	    }
	}

	if { [catch {
	    file copy -force [file join [file dirname $reportfilename] images] \
		    $imgdir
	    file copy -force $reportfilename $filename
	} err] } {
	    WarnWin [concat "Problems exporting report to '$filename' ($err). "\
		    "Check write permissions and disk space"]
	    return
	}
	WarnWin "Report exported OK to file '$filename'"
    }
    proc ExportDXF { base } {
	variable reportexportdir
	variable reportfilename

	set dir [GiveProjectDir]
	set dxffile [file join $dir tmp_concrete.dxf]
	if { ![file readable $dxffile] } {
	    WarnWin "There is no DXF file to export. Use buttons 'Dimension' or 'Check' to create"
	    return
	}

	if { ![file isdir $reportexportdir] } {
	    set reportexportdir [pwd]
	}
	global tk_strictMotif
	set tk_strictMotif_save $tk_strictMotif
	set tk_strictMotif 0
	set initialfile ""
	if { $reportfilename != "" } {
	    set initialfile [file join [file root [file tail $reportfilename]].dxf]
	}
	set filename [tk_getSaveFile -defaultextension .dxf -filetypes {{"DXF files" ".dxf .DXF"}} \
		-initialdir $reportexportdir -initialfile $initialfile -parent $base \
		-title "Export DXF"]
	set tk_strictMotif $tk_strictMotif_save
	if { $filename == "" } { return }
	set reportexportdir [file dirname $filename]

	if { [catch {
	    file copy -force $dxffile $filename
	} err] } {
	    WarnWin [concat "Problems exporting DXF file to '$filename' ($err). "\
		    "Check write permissions and disk space"]
	    return
	}
	WarnWin "DXF exported OK to file '$filename'"
    }
    # Convierte el pseudo-html interno en verdadero html
    proc putshtml { fout text } {
	variable SymbolsAsImages

	if { $SymbolsAsImages } {
	    # translation of symbols
	    regsub -all {<sym>a</sym>} $text {<img src="images/sym-a.gif">} text
	    regsub -all {<sym>b</sym>} $text {<img src="images/sym-b.gif">} text
	    regsub -all {<sym>g</sym>} $text {<img src="images/sym-g.gif">} text
	    regsub -all {<sym>d</sym>} $text {<img src="images/sym-d.gif">} text
	    regsub -all {<sym>e</sym>} $text {<img src="images/sym-e.gif">} text
	    regsub -all {<sym>f</sym>} $text {<img src="images/sym-f.gif">} text
	    regsub -all {<sym>h</sym>} $text {<img src="images/sym-h.gif">} text
	}
	regsub -all {<nor>} $text {} text
	regsub -all {</nor>} $text {} text
	regsub -all {<sym>} $text "<tt><font face=\"Symbol\">" text
	regsub -all {</sym>} $text {</font></tt>} text
	regsub -all {</sel>} $text {} text
	regsub -all {<sel>} $text {} text

	set len [string length $text]
	for { set i 0 } { $i < $len } { incr i } {
	    set char [string index $text $i]
	    switch -- $char {
		\u00e1 { puts -nonewline $fout "&aacute;" }
		\u00e8 { puts -nonewline $fout "&eacute;" }
		\u00ec { puts -nonewline $fout "&iacute;" }
		\u00f2 { puts -nonewline $fout "&oacute;" }
		\u00f9 { puts -nonewline $fout "&uacute;" }
		\u00f1 { puts -nonewline $fout "&ntilde;" }
		\u00b7 { puts -nonewline $fout "&middot;" }
		default {  puts -nonewline $fout $char }
	    }
	}
	puts $fout ""
    }   
    proc getshtml { text } {
	variable SymbolsAsImages

	if { $SymbolsAsImages } {
	    # translation of symbols
	    regsub -all {<img src="images/sym-a.gif">} $text {<sym>a</sym>} text
	    regsub -all {<img src="images/sym-b.gif">} $text {<sym>b</sym>} text
	    regsub -all {<img src="images/sym-g.gif">} $text {<sym>g</sym>} text
	    regsub -all {<img src="images/sym-d.gif">} $text {<sym>d</sym>} text
	    regsub -all {<img src="images/sym-e.gif">} $text {<sym>e</sym>} text
	    regsub -all {<img src="images/sym-f.gif">} $text {<sym>f</sym>} text
	    regsub -all {<img src="images/sym-h.gif">} $text {<sym>h</sym>} text
	}        
#        regsub -all </p><p> $text \n text
#        regsub -all <p> $text {} text
#        regsub -all </p> $text {} text
	regsub -all "<tt><font face=\"Symbol\">" $text {<sym>} text
	regsub -all {</font></tt>} $text {</sym>} text

	regsub -all "&aacute;" $text {\u00e1} text
	regsub -all "&eacute;" $text {\u00e8} text
	regsub -all "&iacute;" $text {\u00ec} text
	regsub -all "&oacute;" $text {\u00f2} text
	regsub -all "&uacute;" $text {\u00f9} text
	regsub -all "ntilde;"  $text {\u00f1} text
	regsub -all "&middot;" $text {\u00b7} text

	return $text
    }
    proc CreateReport { base } {
	variable ramdir
	variable reporttitle
	variable reportfilename
	variable reportdescription

	set name [GiveReportName "yes"]

	if { $name == "" } {
	    WarnWin "A project title is needed. Save project to get it."
	    return
	}
	
	if { [file exists $name] } {
	    set retval [tk_dialogRAM  $base._temp Warning "File '$name' exists, overwrite?" \
		    warning 0 OK Cancel]
	    if { $retval == 1 } { return }
	}
	if { [catch {
	    set fout [open $name w]
	} err] } {
	    WarnWin "error: could not write file '$name' ($err)"
	    return
	}
	#WARNING
	fconfigure $fout -encoding binary
	set reportfilename $name
	

	set title [string trim $reporttitle]
	if { $title == "" } {
	    set title "--untitled--"
	}
	putshtml $fout "<html>\n<head>\n<title>$title</title>\n</head>\n<body bgcolor=\"#FFFFFF\">"
	putshtml $fout "<h1>$title</h1>"

	putshtml $fout "<p><p>$reportdescription</p></p>"

	set info [.central.s info list_entities status]
	regexp "name:\[ ]*(\[^\n]*)\n" $info {} projectname
	set nnodes 0
	set lines 0
	set triangles 0
	set quadrilats 0
	set tetrahedras 0
	set hexahedras 0
	if { [.central.s info postprocess arewein]=="YES" } {
	    if { $projectname=="(null)" } { 
		WarnWin "A project title is needed. Save project to get it."
		return
	    }
	    regexp "nodes:\[ ]*(\[^\n]*)\n" $info {} nnodes
	    regexp -line " lines: (.*)" $info {} lines
	    regexp "triangles:\[ ]*(\[^\n]*)\n" $info {} triangles
	    regexp "quadrilaterals:\[ ]*(\[^\n]*)\n" $info {} quadrilats
	    regexp "tetrahedras:\[ ]*(\[^\n]*)\n" $info {} tetrahedras
	    regexp "hexahedras:\[ ]*(\[^\n]*)\n" $info {} hexahedras
	} else {
	    if { $projectname=="UNNAMED" } { 
		WarnWin "A project title is needed. Save project to get it."
		return 
	    } 
	    regexp -line "nodes:(.*)" $info {} nnodes
	    regexp -line "Linear elements:(.*)" $info {} lines
	    regexp -line "Triangle elements:(.*)" $info {} triangles
	    regexp -line "Quadrilateral elements:(.*)" $info {} quadrilats
	    regexp -line "Tetrahedra elements:(.*)" $info {} tetrahedras
	    regexp -line "Hexahedra elements:(.*)" $info {} hexahedras
	}

	if { $tetrahedras>0 || $hexahedras>0 } { set lines 0 }

	putshtml $fout "<table border=1 align=left>"
	putshtml $fout "<tr><td>Project<td>$projectname</tr>"
	putshtml $fout "<tr><td>Num. nodes<td>$nnodes</tr>"
	if { $lines > 0 } {
	    putshtml $fout "<tr><td>Num. elm. linear<td>$lines</tr>"
	}
	if { $triangles > 0 } {
	    putshtml $fout "<tr><td>Num. elm. triang.<td>$triangles</tr>"
	}
	if { $quadrilats > 0 } {
	    putshtml $fout "<tr><td>Num. elm. quadril.<td>$quadrilats</tr>"
	}
	if { $tetrahedras > 0 } {
	    putshtml $fout "<tr><td>Num. elm. tetrahed.<td>$tetrahedras</tr>"
	}
	if { $hexahedras > 0 } {
	    putshtml $fout "<tr><td>Num. elm. hexahed.<td>$hexahedras</tr>"
	}
	putshtml $fout "</table>"

#        set val [lsearch [.central.s info gendata] Activate_Load_Cases*]
#        incr val
#        set justone 0
#        if { [lindex [.central.s info gendata] $val] == "none" } {
#            set justone 1
#        }
#        if { $justone } {
#            putshtml $fout "<h2>Hay una nica hiptesis de carga</h2>"
#        } else {
#            set val [lsearch [.central.s info gendata] Combined_load_cases*]
#            incr val
#            set lcases [lrange [lindex [.central.s info gendata] $val] 2 end]
#            set lsimple ""
#            foreach "LC isstrengths combs" $lcases {
#                foreach "fac namel" [split $combs ,] {
#                    if { [lsearch $lsimple $namel] == -1 } {
#                        lappend lsimple $namel
#                    }
#                }
#            }
#            putshtml $fout "<br clear=all>"
#            putshtml $fout "<h2>Hiptesis de carga</h2>"
#            putshtml $fout "<table border=1 align=left>"
#            putshtml $fout "<tr><td><b>hip. combinada</b><td><b>est. lim. lt.</b>"
#            foreach i $lsimple {
#                putshtml $fout "<td><b>$i</b>"
#            }
#            putshtml $fout "</tr>"

#            foreach "lc isstrengths combs" $lcases {
#                putshtml $fout "<tr><td>$lc"
#                if { $isstrengths } {
#                    putshtml $fout "<td>s"
#                } else { putshtml $fout "<td>no" }
#                set facs ""
#                foreach i $lsimple { lappend facs 0.0 }
#                foreach "fac namel" [split $combs ,] {
#                    set idx [lsearch $lsimple $namel]
#                    if { $idx != -1 } {
#                        set facs [lreplace $facs $idx $idx $fac]
#                    }
#                }
#                foreach i $facs { putshtml $fout "<td>[format %g $i]" }
#            }
#            putshtml $fout "</tr>"
#            putshtml $fout "</table>"
#        }

	putshtml $fout "</body>\n</html>"
	close $fout
	set dir [file join [GiveProjectDir] images]
	if { [file isdir $dir] } {
	    file delete -force $dir
	}
	file mkdir $dir
	file copy [file join $ramdir images sym-a.gif] $dir
	file copy [file join $ramdir images sym-b.gif] $dir
	file copy [file join $ramdir images sym-d.gif] $dir
	file copy [file join $ramdir images sym-e.gif] $dir
	file copy [file join $ramdir images sym-f.gif] $dir
	file copy [file join $ramdir images sym-g.gif] $dir
	file copy [file join $ramdir images sym-h.gif] $dir

	WarnWinReport "Created report '$name'" $base
    }
}

proc WarnWinReport { text w } {

    set ww $w.__WarnWin
    set retval [tk_dialogRAM  $ww Warning $text warning 0 OK "View report"]
    if { $retval == 1 } {
	ReportPrefs::ViewReportHtmlFile $w
    }
}

# Convierte el cdigo pseudo-html que devuelve ReturnHtmlFromText en texto
# para el editor.
proc PutHtmlInText { w text { clear yes } } {

    set state [$w cget -state]
    $w conf -state normal
    if { $clear == "yes" } {
	$w del 1.0 end
    }
    # Eliminamos/Sustitumos las etiquetas elementales de texto
    regsub -all </p><p> $text \n text
    regsub -all <p> $text {} text
    regsub -all </p> $text {} text
    # Comprobamos si hay alguna tag
    if { ![regexp -indices {<([^>]*)>} $text tag tagname] } {
	$w ins end $text 
	$w conf -state $state
	return
    }
    set taglevel 0 
    while { $text!="" } {
	# Se define el bloque actual sobre el que se aplicarn las tags
	if { ![regexp -indices {<([^>]*)>} $text tag] } {
	    set ind [string length $text]
	} else { 
	    set ind [expr [lindex $tag 0]-1]
	}
	# Se inserta el bloque y se asignan las tags activas
	set ini [$w index insert]
	$w ins end [string range $text 0 $ind]
	for { set i 1 } { $i <= $taglevel } { incr i } {
	    $w tag add $tagarray($i) $ini "end - 1 chars"
	}
	# Se define el nuevo tag
	set tagname [string range $text [expr [lindex $tag 0]+1] \
		[expr [lindex $tag 1]-1]]
	if { ![regexp {/} $tagname] } {
	    incr taglevel
	    set tagarray($taglevel) $tagname
	} else {
	    set tagname [string range $tagname 1 end]
	    if { $tagname==$tagarray($taglevel) } {
		incr taglevel -1 
	    } else { 
		for { set i 1 } { $i < $taglevel } { incr i } {
		    if { $tagname==$tagarray($i) } {
		        set tagarray($i) $tagarray($taglevel)
		        incr taglevel -1 
		        break 
		    }
		}
	    }
	}
	set text [string range $text [expr [lindex $tag 1]+1] end]
    }
    $w conf -state $state
}

# Convierte el texto del editor en un cdigo pseudo-html que se guarda en
# una variable para uso interno
proc ReturnHtmlFromText { w } {

    set text ""
    foreach "key val idx" [$w dump -tag -text 1.0 end] {
	switch $key {
	    text { 
		if { $val != "\n" } {
		    append text $val 
		}
	    }
	    tagon { if { $val!="sel" } { append text <$val> } }
	    tagoff { if { $val!="sel" } { append text </$val> } }
	}
    }
#    set text "<p>$text</p>"
    regsub -all \n $text </p><p> text
    return $text
}

# Convierte el texto del editor en un cdigo pseudo-html que se guarda en
# una variable para uso interno. Por otra parte, el visor interno de html 
# est bastante limitado y se han incluido varios controles para que todo funcione
proc ReturnBestHtmlFromText { w } {

    set text ""
    set taglevel 0
    foreach "key val idx" [$w dump -tag -text 1.0 end] {
	switch $key {
	    text { 
		if { [regexp {\n} $val] } {
		    set taglist "" 
		    for { set i 1 } { $i <= $taglevel } { incr i } {
		        append taglist </$tagarray($i)>
		    }
		    append taglist "</p><p>"
		    for { set i 1 } { $i <= $taglevel } { incr i } {
		        append taglist <$tagarray($i)>
		    }
		    regsub -all {\n} $val $taglist val
		}
		append text $val 
	    }
	    tagon { 
		if { $val!="sel" } { 
		    for { set i 1 } { $i <= $taglevel } { incr i } {
		        append text </$tagarray($i)>
		    }
		    incr taglevel
		    set tagarray($taglevel) $val
		    for { set i 1 } { $i <= $taglevel } { incr i } {
		        append text <$tagarray($i)>
		    }
		} 
	    }
	    tagoff { 
		if { $val!="sel" } {
		    for { set i $taglevel } { $i >= 1 } { incr i -1 } {
		        if { $val==$tagarray($i) } {
		            break 
		        }
		    }
		    for { set j $taglevel } { $j >= $i } { incr j -1 } {
		        append text </$tagarray($j)>
		    }
		    for { set j $i } { $j < $taglevel } { incr j } {
		        set tagarray($j) $tagarray([expr $j+1])
		        append text <$tagarray($j)>
		    }
		    incr taglevel -1 
		}
	    }
	}
    }
#    set text "<p>$text</p>"
    # Se eliminan los ltimos saltos de lnea
    while { [string compare [string range $text end-6 end] "</p><p>"]==0 } {
	set text [string range $text 0 end-7]
    }
    return $text
}

# Editor de texto bsico con algunos smbolos
proc EnterText { w tvar {title "Text editor"} } {
    global tkPriv tcl_platform ProblemTypePriv

    toplevel $w
    wm title $w $title

    if { $tcl_platform(platform) == "windows" } {
	wm transient $w [winfo toplevel [winfo parent $w]]
    }

    frame $w.f -bd 2 -relief groove

    frame $w.f.buts 

    button $w.f.buts.a -height 20 -width 18 -image $ReportPrefs::syma -command "\
	    $w.f.t insert insert a sym"
    button $w.f.buts.b -height 20 -width 18 -image $ReportPrefs::symb -command "\
	    $w.f.t insert insert b sym" 
    button $w.f.buts.d -height 20 -width 18 -image $ReportPrefs::symd -command "\
	    $w.f.t insert insert d sym"
    button $w.f.buts.e -height 20 -width 18 -image $ReportPrefs::syme -command "\
	    $w.f.t insert insert e sym"
    button $w.f.buts.g -height 20 -width 18 -image $ReportPrefs::symg -command "\
	    $w.f.t insert insert g sym"
    button $w.f.buts.f -height 20 -width 18 -image $ReportPrefs::symf -command "\
	    $w.f.t insert insert f sym" 
    button $w.f.buts.h -height 20 -width 18 -image $ReportPrefs::symh -command "\
	    $w.f.t insert insert h sym"  
    button $w.f.buts.i -height 20 -width 18 -image $ReportPrefs::symmm -command "\
	    $w.f.t insert insert  nor"  
    button $w.f.buts.j -height 20 -width 18 -image $ReportPrefs::sym12 -command "\
	    $w.f.t insert insert  nor"   
    button $w.f.buts.k -height 20 -width 18 -image $ReportPrefs::sym14 -command "\
	    $w.f.t insert insert  nor"
    button $w.f.buts.l -height 20 -width 18 -image $ReportPrefs::sym34 -command "\
	    $w.f.t insert insert  nor"
    button $w.f.buts.sup -height 20 -width 18 -image $ReportPrefs::supF -command "\
	    addtag $w.f.t sup"
    button $w.f.buts.sub -height 20 -width 18 -image $ReportPrefs::subF -command "\
	    addtag $w.f.t sub" 
    button $w.f.buts.nor -height 20 -width 18 -image $ReportPrefs::norF -command "\
	    remtag $w.f.t sub; remtag $w.f.t sup;"

    proc addtag { w tag } {
	set range [$w tag prevrange sel end]
	if {$range!="" } { 
	    eval $w tag add $tag $range
	}
    }
    proc remtag { w tag } {
	set range [$w tag prevrange sel end]
	if {$range!="" } { 
	    eval $w tag remove $tag $range
	}
    }

    pack $w.f.buts.a $w.f.buts.b $w.f.buts.d $w.f.buts.e $w.f.buts.g \
	    $w.f.buts.f $w.f.buts.h $w.f.buts.i $w.f.buts.j $w.f.buts.l \
	    $w.f.buts.k $w.f.buts.sup $w.f.buts.sub $w.f.buts.nor -side left

    text $w.f.t -xscroll "$w.f.hscr set" -yscroll "$w.f.vscr set" \
	    -width 60    
    scrollbar $w.f.vscr -orient vertical -comm "$w.f.t yview"
    scrollbar $w.f.hscr -orient horizontal -comm "$w.f.t xview"

    $w.f.t tag configure nor -font NormalFont
    $w.f.t tag configure sym -font SymbolFont
    $w.f.t tag configure sup -offset 4p
    $w.f.t tag configure sub -offset -3p
    $w.f.t tag configure und -underline on

    PutHtmlInText $w.f.t [set $tvar] yes

    bind $w.f.t <KeyPress> {
	if { [regexp {[a-zA-Z]} %A] } {
	    catch {
		if {[%W compare sel.first <= insert]
		&& [%W compare sel.last >= insert]} {
		    %W delete sel.first sel.last
		}
	    }
	    %W insert insert %A ""
	    break 
	}
    }

    grid $w.f.buts  -row 1 -column 1 -sticky w -pady $ReportPrefs::FramesSeparation -padx 5 -columnspan 2
    grid $w.f.t -row 2 -column 1  -padx 2 -sticky nsew
    grid $w.f.vscr -row 2 -column 2 -sticky ns
    grid $w.f.hscr -row 3 -column 1 -sticky ew -padx 2 
    grid columnconf $w.f 1 -weight 1
    grid rowconf $w.f 2 -weight 1

    frame $w.dbuts
    button $w.ok -text OK -width 5 -command "set tkPriv(ed_button) ok" -und 0
    button $w.clear -text Clear -width 5 -command "$w.f.t del 1.0 end" -und 1
    button $w.cancel -text Cancel -width 5 -command "set tkPriv(ed_button) cancel" -und 0

    wm protocol $w WM_DELETE_WINDOW "tkButtonInvoke $w.cancel"
    bind $w.ok <Return> "tkButtonInvoke $w.ok"
    bind $w <Escape> "tkButtonInvoke $w.cancel"
    bind $w.f.t <Alt-o> "tkButtonInvoke $w.ok"
    bind $w.f.t <Alt-l> "tkButtonInvoke $w.clear"
    bind $w.f.t <Alt-c> "tkButtonInvoke $w.cancel"

    grid $w.f -row 1 -column 1  -pady $ReportPrefs::FramesSeparation -sticky ewns \
	    -padx 2
    grid $w.dbuts -row 2 -column 1
    grid $w.ok -in $w.dbuts -row 2 -column 1 -sticky e -pady 3 -padx 2
    grid $w.clear -in $w.dbuts -row 2 -column 2 -pady 2 -sticky w -padx 2
    grid $w.cancel -in $w.dbuts -row 2 -column 3 -pady 2 -sticky w -padx 2

    grid columnconf $w 1 -weight 1
    grid rowconf $w 1 -weight 1

    wm withdraw $w
    update idletasks

    set pare [winfo toplevel [winfo parent $w]]
    set x [expr [winfo x $pare]+[winfo width $pare ]/2- [winfo reqwidth $w]/2]
    set y [expr [winfo y $pare]+[winfo height $pare ]/2- [winfo reqheight $w]]
    if { $x < 0 } { set x 0 }
    if { $y < 0 } { set y 0 }
    WmGidGeom $w +$x+$y
    update
    wm deiconify $w

    set oldFocus [focus]
    tkwait visibility $w
    set oldGrab [grab current $w]
    if {$oldGrab != ""} {
	set grabStatus [grab status $oldGrab]
    }
    grab $w
    focus $w.f.t
    after 100 catch [list "focus -force $w.f.e"]

    while 1 {
	tkwait variable tkPriv(ed_button)

	set retval ""
	if { $tkPriv(ed_button) == "ok" } {
	    set $tvar [ReturnBestHtmlFromText $w.f.t]
	    #WarnWinText ---$ReportPrefs::reportdescription---
	    break
	} else { break }
    }
    
    if { $oldFocus == "" || [catch {focus $oldFocus}] } {
	if { [winfo exists .gid] } {
	    focus [focus -lastfor .gid]
	}
    }

    destroy $w
    if {$oldGrab != ""} {
	if {$grabStatus == "global"} {
	    catch { grab -global $oldGrab }
	} else {
	    catch { grab $oldGrab }
	}
    }

    return $retval
}

###################################################
# UTILIDADES DE CREACIN DE GRFICOS Y TIME TABLE
###################################################

proc FCUpdateGraphCurrent { w } {
    global itim forcesfile

    upvar #0 [winfo name $w] data

    ReadFCGraph $forcesfile

    $data(fram).f1.e1 delete 0 end
    $data(fram).f1.e1 ins end [lindex $itim 0]
    $data(fram).f1.e2 delete 0 end
    $data(fram).f1.e2 ins end [lindex $itim end]

    FCDrawGraph $w $data(fram) $data(boun)
}

proc FCDrawGraphCurrent { w } {
    global ftype iset

    upvar #0 [winfo name $w] data
    FCDrawGraph $w $data(fram) $data(boun)
}

proc InitFCGraph { file } {
    global itim PFx PFy PFz PMx PMy PMz 
    global VFx VFy VFz VMx VMy VMz 
    global iset sets forcetypes ftype

    # Inicializa
    set forcetypes [list "PFx" "PFy" "PFz" "MFx" "MFy" "MFz" \
		         "VFx" "VFy" "VFz" "MVFx" "MVFy" "MVFz"]
    set ftype [lindex $forcetypes 0]
    # Lee Datos
    ReadFCGraph $file
    # Acaba
    set iset [lindex $sets 0]
#    if { ![info exists iset] } {
#        set iset [lindex $sets 0]
#    } elseif { [lsearch $forcetypes $iset] == -1 } {
#        set iset [lindex $sets 0]
#    }
}

proc ReadFCGraph { file } {
    global itim PFx PFy PFz PMx PMy PMz 
    global VFx VFy VFz VMx VMy VMz 
    global iset sets forcetypes ftype

    # Se lee el archivo de fuerzas
    set fd [open $file r]
#    set bb "Nothing at all"
    while { ![eof $fd] } {
	gets $fd aa
	if { [regexp {[0-9]} $aa ] } {
	    if { [llength $aa] < 13 } {
		close $fd
		return
	    }
	    lappend bb $aa
	}
    } 
    close $fd

    set sets "" 
    set itim "" 
    for { set ir 0 } { $ir < [llength $bb] } { incr ir} {  
	set listb [lindex $bb [expr $ir]] 
	lappend itim [lindex $listb 0]
	for { set i 1 } { $i < [llength $listb] } { incr i 13} {
	    set thisset [lindex $listb [expr $i]]
	    if { $ir == 0 } { 
		lappend sets $thisset
		set PFx($thisset) ""
		set PFy($thisset) ""
		set PFz($thisset) ""
		set PMx($thisset) ""
		set PMy($thisset) ""
		set PMz($thisset) ""
		set VFx($thisset) ""
		set VFy($thisset) ""
		set VFz($thisset) ""
		set VMx($thisset) ""
		set VMy($thisset) ""
		set VMz($thisset) ""
	    }
	    lappend PFx($thisset) [lindex $listb [expr $i+1]]
	    lappend PFy($thisset) [lindex $listb [expr $i+2]] 
	    lappend PFz($thisset) [lindex $listb [expr $i+3]]
	    lappend PMx($thisset) [lindex $listb [expr $i+4]]
	    lappend PMy($thisset) [lindex $listb [expr $i+5]]
	    lappend PMz($thisset) [lindex $listb [expr $i+6]]
	    lappend VFx($thisset) [lindex $listb [expr $i+7]]
	    lappend VFy($thisset) [lindex $listb [expr $i+8]]
	    lappend VFz($thisset) [lindex $listb [expr $i+9]]
	    lappend VMx($thisset) [lindex $listb [expr $i+10]]
	    lappend VMy($thisset) [lindex $listb [expr $i+11]]
	    lappend VMz($thisset) [lindex $listb [expr $i+12]]
	}
    }
}

proc FCDrawGraph { w frame bound } {
    global itim PFx PFy PFz PMx PMy PMz 
    global VFx VFy VFz VMx VMy VMz
    global ftype iset
   
    upvar #0 [winfo name $w] data

    set data(fram) $frame
    set data(boun) $bound

    if { ![winfo exists $frame.c] } { return }

    set c $frame.c
    $c delete curve
    $c delete axestext

    # definition of window size has to be improved
   # set ydist [$c cget -height]
   # set xdist [$c cget -width]
    set ydist [expr [winfo height $c]-50]
    set xdist [expr [winfo width  $c]-125]
    if { $ydist < 200 } { set ydist 200 } 
    if { $xdist < 300 } { set xdist 300 } 

    switch $ftype {
	PFx { set listb $PFx($bound) }
	PFy { set listb $PFy($bound) }
	PFz { set listb $PFz($bound) }
	MFx { set listb $PMx($bound) }
	MFy { set listb $PMy($bound) }
	MFz { set listb $PMz($bound) }
	VFx { set listb $VFx($bound) }
	VFy { set listb $VFy($bound) }
	VFz { set listb $VFz($bound) }
	MVFx { set listb $VMx($bound) }
	MVFy { set listb $VMy($bound) }
	MVFz { set listb $VMz($bound) }
	default {
	   WarnWin "Error found reading data in Forces Graph $ftype" 
	   return 
	}
    }

    # Calculate limits of Ox axis
    set inittim [lindex $itim 0]
    set endttim [lindex $itim end]
    set initim [$frame.f1.e1 get]
    if { [catch { set initim [expr double($initim)] }] } {
	set initim $inittim
    }
    if { $initim < $inittim } { set initim $inittim }
    if { $initim > $endttim } { set initim $inittim }
    set endtim [$frame.f1.e2 get]
    if { [catch { set endtim [expr double($endtim)] }] } {
	set endtim $endttim
    }
    if { $endtim > $endttim } { set endtim $endttim }
    if { $endtim < $inittim } { set endtim $endttim }

    # Calculate basic list
    set numpoints [llength $listb]  
    set nnumpoints 200
    if { $numpoints == 1 } {
	set ypoin [lindex $listb 0]
	$c create text 10 10 -anchor nw -justify left \
		-text "Only one value found: $ftype = $ypoin" -font NormalFont -tags axestext
	return
    }
    set init 0
    set fini 0
    set listx ""
    set listy ""
    for { set i 0 } { $i < $numpoints } { incr i } {
	set ypoin [lindex $listb $i]
	set xpoin [lindex $itim  $i]
	if { ($xpoin >= $initim) && ($xpoin <= $endtim) } {
	    if { $init == 0 } {
		set init 1
		if { $i > 0 } {
		    lappend listy [lindex $listb [expr $i-1]]   
		    lappend listx [lindex $itim  [expr $i-1]]
		} else {
		    lappend listy $ypoin   
		    lappend listx $xpoin
		}
	    }
	    lappend listy $ypoin
	    lappend listx $xpoin
	    set fini $i
	}
    }
    if { $fini < [expr $numpoints-1] } { incr fini }
    lappend listy [lindex $listb $fini]  
    lappend listx [lindex $itim  $fini]


    # Create vectors
    set xlist ""
    set ylist ""
    set init 1   
    set listlen [llength $listy] 
    set inctim [expr double($endtim - $initim)/double($nnumpoints)]
    for { set i 0 } { $i < $nnumpoints } { incr i } {
	set xpoin [expr $initim + double($i*$inctim)]
	set ypoin [lindex $listy end]
	for {set j $init } { $j < $listlen } { incr j } {
	    set bx [lindex $listx $j]
	    if {$bx == $xpoin } {
		set ypoin [lindex $listy $j]
		set init $j
		break
	    } elseif { $bx > $xpoin } {
		set ax [lindex $listx [expr $j-1]] 
		set ay [lindex $listy [expr $j-1]]
		set by [lindex $listy $j]
		set ypoin [expr double($ay+($xpoin-$ax)*($by-$ay)/double($bx-$ax))]
		set init $j
		break
	    }
	}
	lappend xlist $xpoin
	lappend ylist $ypoin
    }

    # Calculate limits of Oy axis
    set ynummax 0
    set ynummin 0
    for {set i 0 } { $i < $nnumpoints } { incr i} {
	set yval [lindex $ylist $i]
	if { $i == 0 || $yval > $ynummax } {
	    set ynummax $yval
	}
	if { $i == 0 || $yval < $ynummin } {
	    set ynummin $yval
	}
    }
    if { $ynummax == $ynummin } { 
      $c create text 10 10 -anchor nw -justify left \
	    -text "Constant value found: $ftype = $ynummin" -font NormalFont -tags axestext
      return 
    }
    if { $ynummax == 0 } { set ynummax 1 }
    if { $ynummin == 0 } { set ynummin 1 }

    # Units text
    set factor [expr int(log10(0.5*(abs($ynummax)+abs($ynummin))+.5)-1)]
    if {($ftype=="PFx")||($ftype=="PFy")||($ftype=="PFz")|| \
	($ftype=="VFx")||($ftype=="VFy")||($ftype=="VFz")} {
	set units_text "Force"
    } else {
	set units_text "Momentum"
    } 
    if { $factor == 0 } { 
	append units_text
    } else { 
	append units_text " X 10E" $factor
    }      
    set factor  [expr pow( 10.0, -$factor)]
    set tfactor [expr int(log10($endtim)+.5)-1]
    if { $tfactor == 0 } { 
	append time_text "Time"
    } elseif { $tfactor == -1 } { 
	set tfactor 0
	append time_text "Time"
    } else { 
	append time_text "Time X 10E" $tfactor
    }      
    set tfactor [expr pow( 10.0, -$tfactor)]

    # Mide la longitud de las etiquetas de los ejes
#    set textwidth [expr [font measure NormalFont $ynummax]+1]
    set textwidth [font metrics NormalFont -linespace]
    set xm [expr int($textwidth*6.0)]
    set textheight [font metrics NormalFont -linespace]
    set ym [expr int($textheight*1.5)]

    # Draw graph axes
    set ymax [expr $ym+$ydist]
    set xmax [expr $xm+$xdist]
    $c create line $xm $ym $xm [expr $ymax-$ym] [expr $xmax-$xm] \
	    [expr $ymax-$ym]  -tags axestext
    set innumpoints 8
    for {set i 0 } { $i < $innumpoints } { incr i } {
	set xpoin [expr double($initim+$i/double($innumpoints-1)*($endtim-$initim))]
	set xval [expr $xm+$i/double($innumpoints-1)*($xmax-2*$xm)]
	set xtictext [format "%2.2lf" [expr double($xpoin*$tfactor)]]
      # Draw Ox tics
	$c create line $xval [expr $ymax-$ym+2] $xval [expr $ymax-$ym] \
		-tags axestext
	$c create text $xval [expr $ymax-$ym+2] -anchor n -justify center \
		-text $xtictext -font NormalFont -tags axestext

	set ypoin [expr double($ynummin+$i/double($innumpoints-1)*($ynummax-$ynummin))]
	set yval [expr $ymax-$ym-$i/double($innumpoints-1)*($ymax-2*$ym)]
	set ytictext [format "%2.2lf" [expr double($ypoin*$factor)]]
      # draw Oy tics
	$c create line [expr $xm-2] $yval $xm $yval -tags axestext
	$c create text [expr $xm-3] $yval -anchor e -justify right \
	    -text $ytictext -font NormalFont -tags axestext
    }
    $c create text 5 5 -anchor nw -justify left \
	    -text $units_text -font NormalFont -tags axestext
    set textwidth [font measure NormalFont 0.0]
    $c create text [expr $xmax-$xm+$textwidth+5] [expr $ymax-$ym] \
	    -anchor nw -justify left \
	    -text $time_text -font NormalFont -tags axestext

    # draw Ox tics
    set xfact [expr ($xmax-2.0*$xm)/double($nnumpoints)]
    set yfact [expr ($ymax-2.0*$ym)/double($ynummax-$ynummin)]

    # draw graph
#    set lastyval [expr $ymax-$ym]
    set lastyval [expr $ymax-$ym-([lindex $ylist 0]-$ynummin)*$yfact]
    for { set i 1 } { $i < $nnumpoints } { incr i } {
	set yval [expr $ymax-$ym-([lindex $ylist $i]-$ynummin)*$yfact]
#        $c create line [expr $i*$xfact+$xm] $lastyval \
#                [expr $i*$xfact+$xm] $yval\
#                [expr ($i+1)*$xfact+$xm] $yval -tags curve
	$c create line [expr $i*$xfact+$xm] $lastyval \
		[expr ($i+1)*$xfact+$xm] $yval -tags curve
	set lastyval $yval
    }

  # Abre una ventana adicional y vuelca list
  #   toplevel $w.t
  #   pack [text $w.t.t] -fill both -expand yes
  #   $w.t.t ins end $list
}

proc FCCreate { w fr } {
    global itim ftype

    canvas $fr.c -bg white -relief ridge -bd 2

    grid $fr.c -sticky nsew -row 1 -column 1

    trace vdelete ftype w "FCDrawGraphCurrent $w ;#"
 
    frame $fr.f1
    label $fr.f1.l1 -text "Time: From"
    entry $fr.f1.e1 -relief sunken -width 5
    $fr.f1.e1 ins end [lindex $itim 0]
    label $fr.f1.l2 -text " To"
    entry $fr.f1.e2 -relief sunken -width 5
    $fr.f1.e2 ins end [lindex $itim end]
    label $fr.f1.l3 -text "."
    grid $fr.f1.l1 -row 1 -column 1
    grid $fr.f1.e1 -sticky ew -row 1 -column 2
    grid $fr.f1.l2  -row 1 -column 3
    grid $fr.f1.e2 -sticky ew -row 1 -column 4
    grid $fr.f1.l3 -row 1 -column 5
    grid columnconf $fr.f1 2 -weight 1
    grid columnconf $fr.f1 4 -weight 1

    frame $fr.type
    label $fr.type.l -anchor w -text "Forces on:"

    tk_optionMenu $fr.type.m ftype "PFx" "PFy" "PFz" "MFx" "MFy" "MFz" \
		         "VFx" "VFy" "VFz" "MVFx" "MVFy" "MVFz"

    grid $fr.type.l -row 1 -column 1
    grid $fr.type.m -row 1 -column 2
    grid $fr.f1 -sticky ew -row 2 -column 1
    grid $fr.type -sticky w  -row 4 -column 1
    grid columnconf $fr 1 -weight 1
    grid rowconf $fr 1 -weight 1

    bind $fr.f1.e1 <Return> "FCDrawGraphCurrent $w"
    bind $fr.f1.e2 <Return> "FCDrawGraphCurrent $w"
    trace var ftype w "FCDrawGraphCurrent $w ;#"
    bind $fr.c <Configure> "FCDrawGraphCurrent $w"
}

proc ForcesData { { w .fordat } } {
    global itim PFx PFy PFz PMx PMy PMz 
    global VFx VFy VFz VMx VMy VMz 
    global sets iset forcetypes ftype forcesfile

    # Control de existencia del archivo de datos  
    set forcesfile ""
    set aa [.central.s info Project]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
    set ProjectName [file root $ProjectName]
    }
    set basename [file tail $ProjectName]
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set file [file join $directory $basename.flavia.for]

    if { ![file exists $file] } {
      catch { destroy $w }
	tk_dialogRAM .gid.tempwin {Error window} "There are no force data for this model" \
		error 0 OK
	return
    } 
    set fd [open $file r]
    set bb "" 
    while { ![eof $fd] } { 
	gets $fd bb
	set bblen [llength $bb]
	if { $bblen>0 && $bblen<13 } {
	    close $fd
	    catch { destroy $w }
	    tk_dialogRAM .gid.tempwin {Error window} "Forces data not found in file" \
		    error 0 OK
	    return
	} elseif { $bblen>0 } {
	    break
	}
    }
    if {$bb == ""} { 
	close $fd
	catch { destroy $w }
	tk_dialogRAM .gid.tempwin {Error window} "Forces file is empty" \
		error 0 OK
	    return
    }
    set forcesfile $file

    # Aqui comienza todo
    InitWindow $w "Forces Graph" PostForcesDataWindowGeom ""
    wm withdraw $w

    # Llama a InitFCGraph para leer los datos
    InitFCGraph $file

    frame $w.buts
    button $w.buts.ap -text "Apply Limits" -command "FCDrawGraphCurrent $w"
    button $w.buts.ac -text Actualize -command "FCUpdateGraphCurrent $w"
    button $w.buts.cl -text Close -command "destroy $w"
    pack $w.buts.ap $w.buts.ac $w.buts.cl -side left -padx 5 -ipadx 5 -pady 5 

    frame $w.f
    grid $w.buts -row 1 -column 0
    grid $w.f -row 0 -column 0 -sticky nsew
    grid rowconfigure $w.f 0 -weight 1
    grid columnconfigure $w.f 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1

    # Da nombre a los grficos de datos (extensin pref = iset)
    # y llama a FCDrawGraph para la creacion de las curvas
    set func "optionbar $w.f.c"
    set inum 0
    foreach qq $sets {
	set pref [string tolower $qq]
	  set holder [frame $w.f.aa$inum]
	 set pref [string toupper \
		  [string range $pref 0 0]][string range $pref 1 end]
	lappend func "\"$pref\" $holder \"FCDrawGraph $w $holder $qq \""
	   FCCreate $w $holder
	incr inum
    }
    eval $func

    pack $w.f.c -fill both -expand yes
    update idletasks
    wm deicon $w

    upvar #0 [winfo name $w] data
}

proc OpenTimeTableWindow { } {

    set title "Time Table"
    set w .gid.timetable

    InitWindow $w $title PostTimeTableWindowGeom

    #text $w.t -xscrollcommand "$w.scrollbar#1 set" \
    #                -yscrollcommand "$w.scrollbar#2 set" -font FixedFont

    text $w.t -yscrollcommand "$w.scrollbar#2 set" -font FixedFont

    scrollbar $w.scrollbar#2 -command "$w.t yview" -orient v
    #scrollbar $w.scrollbar#1 -command "$w.t xview" -orient h
    button $w.close -text Close -command "destroy $w"
    focus $w.close
    grid $w.t -row 1 -column 1 -sticky nesw
    grid $w.scrollbar#2 -row 1 -column 2 -sticky ns
    #grid $w.scrollbar#1 -row 2 -column 1 -sticky ew
    grid $w.close -row 3 -column 1 -rowspan 2 -pady 5
    grid rowconfigure $w 1 -weight 1 
    grid columnconfigure $w 1 -weight 1 

    # Determina el nombre del archivo
    set aa [.central.s info Project]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
    set ProjectName [file root $ProjectName]
    }
    set basename [file tail $ProjectName]

    if { $ProjectName == "UNNAMED" } {
	$w.t insert end "It is necessary to calculate to view these results"
	return
    }
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set file [file join $directory $basename.flavia.tim]

    if { ![file exists $file] } {
	$w.t insert end "There are no results for this model"
	return
    }
    set fd [open $file r]
    set bb ""
    while { ![eof $fd] } {
	gets $fd aa
	if { [regexp {[0-9]} $aa ] } {
	    append bb $aa\n
	}
    }
    if { $bb == "" } { set bb "Nothing at All" }

    $w.t insert end $bb

    bind $w <Destroy> "catch [list close $fd]"
}

proc IntegrateWindow { {w .gid.integrate} } {
    global ProblemTypePriv ProgramName

    set ProblemTypePriv(currentgraph) ""
    if { [info procs InitWindow] != "" } {
	InitWindow $w "Integrate & Graphs" PostIntegrateWindowGeom IntegrateWindow
    } else {
	toplevel $w
    }

    menu $w.mm1 -type menubar 
    $w conf -menu $w.mm1
    $w.mm1 add cascade -label "View" -menu $w.mm1.m1 -underline 0
    menu $w.mm1.m1
    $w.mm1.m1 add command -label "Select section" -underline 0 -command "IntegrateSelect $w"
    $w.mm1.m1 add separator
    $w.mm1.m1 add command -label "Integrals" -underline 0 -state disabled
    $w.mm1.m1 add separator
    set str { {"Axial force" Nt' Nn' Ntn'} \
	    {"Momentus" Mt' Mn' Mtn' } \
	    {"Shear" Qt' Qn'}}
    set icount 1
    foreach i $str {
	$w.mm1.m1 add cascade -label [lindex $i 0] -underline 0 -menu $w.mm1.m1.m$icount
	menu $w.mm1.m1.m$icount
	foreach j [lrange $i 1 end] {
	    $w.mm1.m1.m$icount add command -label $j -state disabled
	}
	incr icount
    }
    
    $w.mm1.m1 add separator
    $w.mm1.m1 add command -label "Close" -underline 0 -command "destroy $w"

    $w.mm1 add cascade -label "Edit" -menu $w.mm1.m2 -underline 0
    menu $w.mm1.m2
    $w.mm1.m2 add command -label "Copy" -underline 0 -state disabled

    pack [canvas $w.c -relief sunken -bd 2 -bg white -width 400 -height 300] -fill both -expand 1

    frame $w.f 
    label $w.f.l -image [imagefromram intstrengths.gif] -relief groove -bd 2
    frame $w.f.f
    label $w.f.f.l1 -textvar ProblemTypePriv(firstsectionpointL)
    label $w.f.f.l2 -textvar ProblemTypePriv(secondsectionpointL)
    label $w.f.f.l3 -textvar ProblemTypePriv(L)
    button $w.f.f.b1 -text View -width 5 -command "IntViewSection 1"
    button $w.f.f.b2 -text View -width 5 -command "IntViewSection 2"

    grid $w.f.f.l1 -row 1 -column 1 -sticky w -padx 3 -pady 3
    grid $w.f.f.b1 -row 1 -column 2 -sticky w -padx 3 -pady 3
    grid $w.f.f.l2 -row 2 -column 1 -sticky w -padx 3 -pady 3
    grid $w.f.f.b2 -row 2 -column 2 -sticky w -padx 3 -pady 3
    grid $w.f.f.l3 -row 3 -column 1 -sticky w

    set wid [expr [font measure NormalFont "0"]*40]
    text $w.f.t -relief sunken -bd 2 -yscroll "$w.f.sc set" \
	    -tabs "$wid"
    scrollbar $w.f.sc -orient vertical -comm "$w.f.t yview"
    bind $w.f.t <Configure> "CheckScrollbarGrid $w.f.t $w.f.sc"
    bind $w.f.t <KeyPress> "break"

    grid $w.f.f -row 1 -column 1 -padx 3 -pady 3 -sticky w
    grid $w.f.l -row 1 -column 2 -padx 3 -pady 3 -columnspan 2
    grid $w.f.t -row 2 -column 1 -padx 3 -pady 3 -columnspan 2 -sticky ewns
    grid $w.f.sc  -row 2 -column 3 -padx 0 -pady 3 -sticky ns
    grid rowconf $w.f 2 -weight 1
    grid columnconf $w.f 1 -weight 1

    pack $w.f  -fill both -expand 1
    pack forget $w.f

    bind $w.c <Configure> "IntDrawGraphR $w"
}
###################################################
# UTILIDAD DE LECTURA DE SUPERFICIE LIBRE
###################################################

proc ReadFreeSurfaceFromPrevious { {w .gid} } {
    set filename [Browser-ramR project read $w {Read free surface}] 
    if { $filename == "" } { return }
    set fileid [OpenFile "flavia.sat" $filename]
    if { $fileid =="" } {
	tk_dialogRAM $w.tmpwin {Error window} \
		"Cannot open sat file in $filename" \
		error 0 OK 
	return 
    }
    CreateFreeSurfaceFromPrevious $fileid
}

proc CreateFreeSurfaceFromPrevious { fileid } {
    # Cambiamos el cursor y desactivamos la ventana grfica
    GraphicsOFF
    # Enviamos todas la entidades hacia atrs
    .central.s process layer SendToBack Volumes 1: escape
    .central.s process layer SendToBack Surfaces 1: escape
    .central.s process layer SendToBack Lines 1: escape
    .central.s process layer SendToBack Points 1: escape
    # Leemos los puntos
    set readcontrol 0
    while { ![eof $fileid] } {
	set input [gets $fileid]
	if { [regexp {Frees} $input] } { 
	    set readcontrol 1
	    .central.s process escape escape escape escape Geometry Create Point
	    while { ![regexp {end frees} $input] } {
		set input [gets $fileid]
		.central.s process $input
	    } 
	}
    } 
    .central.s process escape escape escape escape
    if { $readcontrol==0 } {
	GraphicsON
	tk_dialogRAM .gid.tmpwin {Error window} \
		"Cannot find free surface data in file" \
		error 0 OK
    } else {
    # Creamos la superficie
	.central.s process escape escape escape Geometry Create NurbsSurface\
		ByPoints 1: escape
    # Borramos los puntos
	.central.s process escape escape escape escape Geometry Delete \
		point 1: escape
    }
    # Traemos todas la entidades hacia delante
    .central.s process layer BringToFrontAll escape
    # Cambiamos el cursor y activamos la ventana grfica
    GraphicsON
}

###################################################
# UTILIDADES MANEJO DE UNIDADES
###################################################

proc ConvertVelocityUnitsToSI { system } {
    switch $system {
	"m/s"  { return 1.0 }
	"knot" { return 0.5144 }
	"cm/s" { return 1e-2 }
	"mm/s" { return 1e-3 }
	"mach" { return 331.46 }
    }
    WarnWin "Error, using an unknown magnitude '$system' for the velocity units"
    return 1.0
}

proc ConvertTimeUnitsToSI { system } {
    switch $system {
	"s"    { return 1.0 }
	"cs"   { return 1e-2 }
	"ms"   { return 1e-3 }
	"min"  { return 60.0 }
	"hour" { return 3600.0 }
    }
    WarnWin "Error, using an unknown magnitude '$system' for the time units"
    return 1.0
}

proc ConvertLengthUnitsToSI { system } {
    switch $system {
	"m"  { return 1.0 }
	"mm" { return 1e-3 }
	"cm" { return 1e-2 }
    }
    WarnWin "Error, using an unknown magnitude '$system' for the length units"
    return 1.0 
}

###################################################
# UTILIDADES GENRICAS PARA USO CON GiD
###################################################
#
# Lee un archivo en el directorio dado y devuelve su indicador de lectura
#
proc OpenFile { ext dir } {

    # Comprueba los datos
    set ProjectName $dir
    if { [file extension $ProjectName] == ".gid" } {
	set ProjectName [file root $ProjectName]
    }
    if { $ProjectName == "UNNAMED" } { 
	return ""
    }
    set basename [file tail $ProjectName]
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set file [file join $directory $basename.$ext]
    if { ![file readable $file] } {
	return ""
    }
    return [open $file r]
#    set read ""
#    if { ![eof $fd] } {
#        gets $fd read
#    }
#    if {$read == ""} {
#        tk_dialogRAM .gid.tmpwin {Error window} \
#                "Sink and Trim Data file $basename.flavia.$ext is empty" error 0 OK 
#        return 0
#    }
#    return 1
}

#
# Copia un archivo desde el directorio inicial al directorio final
# Si enddir es nulo, utiliza el directorio actual
proc CopyFile { ext inidir {enddir ""}} {

    # Comprueba los datos
    set ProjectName $inidir
    if { [file extension $ProjectName] == ".gid" } {
	set ProjectName [file root $ProjectName]
    }
    if { $ProjectName == "UNNAMED" } { 
	return 0
    }
    set basename [file tail $ProjectName]
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set file [file join $directory $basename.$ext]
    if { ![file readable $file] } {
	return 0
    }
    # Busca el directorio actual
    if { $enddir == "" } {
	set info [.central.s info Project]
	set enddir [lindex $info 1]
	if { $enddir == "UNNAMED" } {
	    return 0
	}
	if { [file extension $enddir] != ".gid" } {
	    set enddir $enddir.gid
	}
	if { [file pathtype $enddir] == "relative" } {
	    set enddir [file join [pwd] $enddir]
	}
    }
    # Copia el archivo
    file copy -force $file $enddir
    return $enddir
}
# 
# Devuelve la capa a la que pertenece una entidad 
#    type: Points/Lines/Surfaces/Volumes/Nodes/Elements
#
proc GiveLayer { type number } {
    set ret ""
    if { ![catch {
	set retval [.central.s info list_entities $type $number]
    }] } {
	regexp -linestop -nocase {Layer: *(.*)} $retval {} ret
    }
    return $ret
} 
#
# Se crea una nueva capa. Si ya existe una capa y (ent == 1) con ese nombre se borra todo lo que 
# haya en esa la capa y se activa como capa a usar. 
#
proc CreateLayer { layer_name { ent 0 } } { 
    set layer_list [.central.s info layers]
    foreach layer [lrange $layer_name 0 end] {
	if {[lsearch -exact $layer_list $layer] == -1} {
	    .central.s process escape escape escape escape utilities layer new $layer
	} else {
	    if { $ent == 1 } {
		DeleteLayer $layer 1
		if { ![ExistsLayer $layer] } {
		    .central.s process escape escape escape escape utilities layer new $layer
		}
	    }
	    .central.s process escape escape escape escape utilities layer touse $layer
	}
    }
}
#
# Se elimina una capa y su contenido (si ent == 1).
#
proc DeleteLayer { layer_name { ent 0 } } {
    set layer_list [.central.s info layers]
    set ent_type {list volume surface line point}
    if { $ent == 1 } {
	foreach type [lrange $ent_type 0 end] {
	    foreach layer [lrange $layer_name 0 end] {
		if {[lsearch -exact $layer_list $layer] != -1} {
		    .central.s process escape escape escape escape Geometry \
		            delete $type layer:$layer escape
		}
	    }
	}
    }
    foreach layer [lrange $layer_name 0 end] {
	if {[lsearch -exact $layer_list $layer] != -1} {
	    .central.s process escape escape escape escape utilities layer delete $layer
	}
    }
}
#
# Se mueve el contenido de una capa a otra. La vaca se activa.
#
proc MoveToLayer {layer_ini layer_fin} {
    set layer_list [.central.s info layers]
    if {[lsearch -exact $layer_list $layer_fin] == -1} {
	if {[lsearch -exact $layer_list $layer_ini] == -1} { return }
	.central.s process escape escape escape escape utilities layer new $layer_fin
    } 
    if {[lsearch -exact $layer_list $layer_ini] == -1} { 
	.central.s process escape escape escape escape utilities layer new $layer_ini
    } else {
#   Error en GiD: lo correcto sera  utilities layer entities $layer_fin all layer:$layer_ini
	.central.s process escape escape escape escape utilities layer entities \
		$layer_fin points layer:$layer_ini
	.central.s process escape escape escape escape utilities layer entities \
		$layer_fin lines layer:$layer_ini        
	.central.s process escape escape escape escape utilities layer entities \
		$layer_fin surfaces layer:$layer_ini
	.central.s process escape escape escape escape utilities layer entities \
		$layer_fin volumes layer:$layer_ini
	.central.s process escape escape escape escape utilities layer touse $layer_ini
    }
}
#
# Se introducen en una capa las entidades de menor orden pertenencientes a las que ya estn en la capa.
#
proc MoveLowerToLayer {layer_name} { 
    set layer_list [.central.s info layers]
    foreach layer [lrange $layer_name 0 end] {
	if {[lsearch -exact $layer_list $layer] != -1} {
	    .central.s process escape escape escape escape utilities layer entities $layer \
		    LowerEntities volumes layer:$layer
	    .central.s process escape escape escape escape utilities layer entities $layer \
		    LowerEntities surfaces layer:$layer
	    .central.s process escape escape escape escape utilities layer entities $layer \
		    LowerEntities lines layer:$layer    
	}
    }
}
#
# Se activa una capa. Si no existe se crea. 
#
proc ToUseLayer {layer_name} {
    set layer_list [.central.s info layers]
    if {[lsearch -exact $layer_list $layer_name] == -1} {
	.central.s process escape escape escape escape utilities layer new $layer_name
    } else {
	.central.s process escape escape escape escape utilities layer touse $layer_name
    }
}
#
# Comprueba si existe una capa
#
proc ExistsLayer {layer_name} {
    if { $layer_name=="" } { return 0 }
    set layer_list [.central.s info layers]
    if {[lsearch -exact $layer_list $layer_name] == -1} {
	return 0
    } else {
	return 1
    }
}
#
# Comprueba si existen entidades (geomtricas) en una capa o varias
#
proc IsLayerEmpty {layer_name {entities "all"} } {
    set layer_list [.central.s info layers]
    set entities_list ""
    foreach layer [lrange $layer_name 0 end] {
	if {[lsearch -exact $layer_list $layer] != -1} {
	    if { $entities == "all" } {
		append entities_list [.central.s info layers -entities points   $layer_name]
		append entities_list [.central.s info layers -entities lines    $layer_name]
		append entities_list [.central.s info layers -entities surfaces $layer_name]
		append entities_list [.central.s info layers -entities volumes  $layer_name]
		if { $entities_list != "" } { return 0 }
	    } else { 
		foreach entity [lrange $entities 0 end] {
		    set entities_list [.central.s info layers -entities $entity $layer_name]
		    if { $entities_list != "" } { return 0 }
		}
	    }
	}
    }
    return 1
}
#
#  Enva todas las entidades de una capa hacia atrs
#
proc SendAllToBack { {layer "all"} } {
    if { $layer=="all" } {
	.central.s process escape escape escape utilities layer SendToBack Volumes 1: escape
	.central.s process escape escape escape utilities layer SendToBack Surfaces 1: escape
	.central.s process escape escape escape utilities layer SendToBack Lines 1: escape
	.central.s process escape escape escape utilities layer SendToBack Points 1: escape
    } else {
	.central.s process escape escape escape utilities layer SendToBack Volumes $layer escape
	.central.s process escape escape escape utilities layer SendToBack Surfaces $layer escape
	.central.s process escape escape escape utilities layer SendToBack Lines $layer escape
	.central.s process escape escape escape utilities layer SendToBack Points $layer escape
    }
}
#
#  Trae todas las entidades hacia delante
#
proc BringAllToFront { } { 
    set layer_list [.central.s info layers]
    foreach layer [lrange $layer_name 0 end] {
	.central.s process escape escape escape utilities layers bringtofront $layer
    }
}
#
# Devuelve las caractersticas del paraleleppedo de contorno de una capa o varias
#
proc LayerLength { {layer_name "all"} {type "D"} } {
    if { $layer_name == "all" || $layer_name == "" } { 
	set layer_name [.central.s info layers]
    }
    set points [lindex [eval .central.s info layers -bbox $layer_name] 0]
    set x1 [expr double([lindex $points 0])]
    set y1 [expr double([lindex $points 1])]
    set z1 [expr double([lindex $points 2])]
    set x2 [expr double([lindex $points 3])]
    set y2 [expr double([lindex $points 4])]
    set z2 [expr double([lindex $points 5])]
    set xc [expr 0.5*($x1+$x2)]
    set yc [expr 0.5*($y1+$y2)]
    set zc [expr 0.5*($z1+$z2)]
    switch $type {
	X  { return [expr abs($x1-$x2)] }
	Y  { return [expr abs($y1-$y2)] }
	Z  { return [expr abs($z1-$z2)] }        
	XD { return [list $x1 [expr abs($x1-$x2)]] }
	YD { return [list $y1 [expr abs($y1-$y2)]] }
	ZD { return [list $z1 [expr abs($z1-$z2)]] }
	D  { return [expr sqrt(($x1-$x2)*($x1-$x2)+\
		($y1-$y2)*($y1-$y2)+($z1-$z2)*($z1-$z2))] }
	C  { return [list $xc $yc $zc] }
	XC { return $xc }
	YC { return $yc }
	ZC { return $zc }
	MINX {
	    if { $x1>$x2 } { return $x2 }
	    return $x1
	}
	MINY {
	    if { $y1>$y2 } { return $y2 }
	    return $y1
	}
	MINZ {
	    if { $z1>$z2 } { return $z2 }
	    return $z1
	}
	MAXX {
	    if { $x1<$x2 } { return $x2 }
	    return $x1
	}
	MAXY {
	    if { $y1<$y2 } { return $y2 }
	    return $y1
	}
	MAXZ {
	    if { $z1<$z2 } { return $z2 }
	    return $z1
	}
    }
    return [list [expr abs($x1-$x2)] [expr abs($y1-$y2)] \
	    [expr abs($z1-$z2)]]
}
#
# Se asignan tamaos a todas las entidades de una capa.
#
proc AssignSizeLayer {layer_name size} {
    if { [ExistsLayer $layer_name] } {
	.central.s process escape escape escape escape Meshing AssignSizes Points $size layer:$layer_name
	.central.s process escape escape escape escape Meshing AssignSizes Lines $size layer:$layer_name
	 .central.s process escape escape escape escape Meshing AssignSizes Surfaces $size layer:$layer_name
	.central.s process escape escape escape escape Meshing AssignSizes Volumes $size layer:$layer_name
	.central.s process escape escape escape escape
    }
} 
#
# Se asignan tamaos para mallado a distintas entidades
#
proc AssignSizePoints {size points} {
    .central.s process escape escape escape escape Meshing \
	    AssignSizes Points $size $points escape
}
proc AssignSizeLinesAndLower {size lines} {
    .central.s process escape escape escape escape Meshing \
	    AssignSizes Lines $size $lines escape escape escape 
    foreach line [lrange $lines 0 end] {
	set retval [.central.s info list_entities lines $line] 
	set points [regexp -linestop -all -inline {Points:([ 0-9]*)} $retval]
	for { set i 1 } { $i < [llength $points] } { incr i 2 } {
	    AssignSizePoints $size [lindex $points $i]
	}
    }
} 
proc AssignSizeSurfacesAndLower {size surfaces} {
    .central.s process escape escape escape escape Meshing \
	    AssignSizes Surfaces $size $surfaces escape escape escape 
    foreach surface [lrange $surfaces 0 end] {
	set retval [.central.s info list_entities surfaces $surface] 
	set lines [regexp -linestop -all -inline {Line:([ 0-9]*)} $retval]
	for { set i 1 } { $i < [llength $lines] } { incr i 2 } {
	    AssignSizeLinesAndLower $size [lindex $lines $i]
	}
    }
} 
proc AssignSizeVolumesAndLower {size volumes} {
    .central.s process escape escape escape escape Meshing \
	    AssignSizes Volumes $size $volumes escape escape escape 
    foreach volume [lrange $volumes 0 end] {
	set retval [.central.s info list_entities volumes $volume] 
	set surfaces [regexp -linestop -all -inline {Surface:([ 0-9]*)} $retval]
	for { set i 1 } { $i < [llength $surfaces] } { incr i 2 } {
	    AssignSizeSurfacesAndLower $size [lindex $surfaces $i]
	}
    }
} 
#
# Busca una linea (en una capa) que est limitada por los 2 puntos cuyos ndices son los dados
#
proc SearchLine {point1 point2 {layer ""} } {
    if { [ExistsLayer $layer] } {
	set lines [.central.s info list_entities lines layer:$layer]
    } else {
	set lines [.central.s info list_entities lines 1:2147483647]
    }
    set lines [regexp -linestop -all -inline {Num: ([0-9]*)} $lines]
    if { [llength $lines]<2 } { return "" }
    for { set i 1 } { $i < [llength $lines] } { incr i 2 } {
	set line [lindex $lines $i]
	if { $line > 0 } {
	    set retval [.central.s info list_entities lines $line] 
	    set points [lindex [regexp -linestop -inline {Points: ([ 0-9]*)} $retval] 1] 
	    if { [lsearch $points $point1]!=-1 && [lsearch $points $point2]!=-1 } {
		return $line
	    }
	}
    }
    return ""
}
#
# Devuelve todas las lineas de una capa
#
proc GiveLines { {layer ""} } {
    if { [ExistsLayer $layer] } {
	set lines [.central.s info list_entities lines layer:$layer]
    } else {
	set lines [.central.s info list_entities lines 1:2147483647]
    }
    set lines [regexp -linestop -all -inline {Num: ([0-9]*)} $lines]
    if { [llength $lines]<2 } { return "" } 
    set ret ""
    for { set i 1 } { $i < [llength $lines] } { incr i 2 } {
	lappend ret [lindex $lines $i]
    }
    return $ret
}
#
# Devuelve todas las superfcies de una capa
#
proc GiveSurfaces { {layer ""} } {
    if { [ExistsLayer $layer] } {
	set surfaces [.central.s info list_entities surfaces layer:$layer]
    } else {
	set surfaces [.central.s info list_entities surfaces 1:2147483647]
    }
    set surfaces [regexp -linestop -all -inline {Num: ([0-9]*)} $surfaces]
    set ret ""
    if { [llength $surfaces]<2 } { return "" } 
    set ret ""
    for { set i 1 } { $i < [llength $surfaces] } { incr i 2 } {
	lappend ret [lindex $surfaces $i]
    }
    return $ret
}
#
# Devuelve todos los volmenes de una capa
#
proc GiveVolumes { {layer ""} } {
    if { [ExistsLayer $layer] } {
	set volumes [.central.s info list_entities volumes layer:$layer]
    } else {
	set volumes [.central.s info list_entities volumes 1:2147483647]
    }
    set volumes [regexp -linestop -all -inline {Num: ([0-9]*)} $volumes]
    set ret ""
    if { [llength $volumes]<2 } { return "" } 
    set ret ""
    for { set i 1 } { $i < [llength $volumes] } { incr i 2 } {
	lappend ret [lindex $volumes $i]
    }
    return $ret
}
#
# Busca una linea (cualquiera) en una capa
#
proc GiveOneLine { {layer ""} } {
    if { [ExistsLayer $layer] } {
	set lines [.central.s info list_entities lines layer:$layer]
    } else {
	set lines [.central.s info list_entities lines 1:2147483647]
    }
    set lines [regexp -linestop -all -inline {Num: ([0-9]*)} $lines]
    if { [llength $lines]>1 } {
	return [lindex $lines 1]
    }
    return ""
}
#
# Busca una superficie (cualquiera) en una capa
#
proc GiveOneSurface { {layer ""} } {
    if { [ExistsLayer $layer] } {
	set surfaces [.central.s info list_entities surfaces layer:$layer]
    } else {
	set surfaces [.central.s info list_entities surfaces 1:2147483647]
    }
    set surfaces [regexp -linestop -all -inline {Num: ([0-9]*)} $surfaces]
    if { [llength $surfaces]>1 } {
	return [lindex $surfaces 1]
    }
    return ""
}
#
# Calcula la Distancia entre dos puntos
#
proc Distance { p1 p2 } {
    set x1 [expr double([lindex $p1 0])]
    set y1 [expr double([lindex $p1 1])]
    set z1 [expr double([lindex $p1 2])]
    set x2 [expr double([lindex $p2 0])]
    set y2 [expr double([lindex $p2 1])]
    set z2 [expr double([lindex $p2 2])]
    set dist [expr sqrt(($x2-$x1)*($x2-$x1)+($y2-$y1)*($y2-$y1)+($z2-$z1)*($z2-$z1))]
    return $dist
}
#
# Busca los puntos (en una capa) que estn en una esfera que se define por un punto y un radio
#
proc SearchPointInSphere { center radius {layer ""} } {
    if { [ExistsLayer $layer] } {
	set points [.central.s info list_entities points layer:$layer]
    } else {
	set points [.central.s info list_entities points 1:2147483647]
    }
    set points [regexp -linestop -all -inline {Num: ([0-9]*)} $points] 
    set foundpoints ""        
    set x1 [expr double([lindex $center 0])]
    set y1 [expr double([lindex $center 1])]
    set z1 [expr double([lindex $center 2])]
    for { set i 1 } { $i < [llength $points] } { incr i 2 } {
	set pntidx [lindex $points $i]
	set point [lindex [.central.s info Coordinates $pntidx] 0]
	set xA [expr double([lindex $point 0])]
	set yA [expr double([lindex $point 1])]
	set zA [expr double([lindex $point 2])]
	set dist [expr sqrt(($xA-$x1)*($xA-$x1)+($yA-$y1)*($yA-$y1)+($zA-$z1)*($zA-$z1))]
	if { $dist <= $radius } {
	    lappend foundpoints $pntidx
	}
    }
    return $foundpoints
}
#
# Busca los puntos (en una capa) que estn en un cilindro OZ que se define por un punto, 
# un radio y una altura
#
proc SearchPointInOZCylinder { center radius layer {height -1}} {
    if { [ExistsLayer $layer] } {
	set points [.central.s info list_entities points layer:$layer]
    } else {
	set points [.central.s info list_entities points 1:2147483647]
    }
    set points [regexp -linestop -all -inline {Num: ([0-9]*)} $points]
    set foundpoints ""        
    set x1 [expr double([lindex $center 0])]
    set y1 [expr double([lindex $center 1])]
    set z1 [expr double([lindex $center 2])]
    for { set i 1 } { $i < [llength $points] } { incr i 2 } {
	set pntidx [lindex $points $i]
	set point [lindex [.central.s info Coordinates $pntidx] 0]
	set xA [expr double([lindex $point 0])]
	set yA [expr double([lindex $point 1])]
	set zA [expr double([lindex $point 2])]
	set dist [expr sqrt(($xA-$x1)*($xA-$x1)+($yA-$y1)*($yA-$y1))]
	set zdst [expr abs($z1-$zA)]
	if { $dist<=$radius && $height < 0.0 } {
	    lappend foundpoints $pntidx
	} elseif { $dist<=$radius && $zdst<=$height } {
	    lappend foundpoints $pntidx
	}
    }
    return $foundpoints
}
#
# Busca los puntos (en una capa) que estn en la caja que se define por los dos puntos 
# y una tolerancia
#
proc SearchPointInBox {point1 point2 tol {layer ""} } {
    if { [ExistsLayer $layer] } {
	set points [.central.s info list_entities points layer:$layer]
    } else {
	set points [.central.s info list_entities points 1:2147483647]
    }
    set points [regexp -linestop -all -inline {Num: ([0-9]*)} $points] 
    set foundpoints ""        
    set x1 [expr double([lindex $point1 0])] 
    set y1 [expr double([lindex $point1 1])]
    set z1 [expr double([lindex $point1 2])] 
    set x2 [expr double([lindex $point2 0])] 
    set y2 [expr double([lindex $point2 1])] 
    set z2 [expr double([lindex $point2 2])] 
    if { $x1 > $x2 } { set tmp $x1; set x1 $x2; set x2 $tmp; }
    if { $y1 > $y2 } { set tmp $y1; set y1 $y2; set y2 $tmp; }
    if { $z1 > $z2 } { set tmp $z1; set z1 $z2; set z2 $tmp; }
    set x1 [expr $x1-$tol]; set x2 [expr $x1+$tol];
    set y1 [expr $y1-$tol]; set y2 [expr $y1+$tol];
    set z1 [expr $z1-$tol]; set z2 [expr $z1+$tol];
    for { set i 1 } { $i < [llength $points] } { incr i 2 } {
	set pntidx [lindex $points $i]
	set point [lindex [.central.s info Coordinates $pntidx] 0]
	set xA [expr double([lindex $point 0])]
	set yA [expr double([lindex $point 1])]
	set zA [expr double([lindex $point 2])]
	if { $xA>=$x1 && $yA>=$y1 && $zA>=$z1 && $xA<=$x2 && $yA<=$y2 && $zA<=$z2 } {
	    lappend foundpoints $pntidx
	}
    }
    return $foundpoints
}
#
# Busca lneas (en una capa) cuyos puntos extremos estn en la caja que se define por los dos puntos 
# y una tolerancia
#
proc SearchLineInBox {point1 point2 tol {layer ""} } {
    if { [ExistsLayer $layer] } {
	set lines [.central.s info list_entities lines layer:$layer]
    } else {
	set lines [.central.s info list_entities lines 1:2147483647]
    }    
    set x1 [expr double([lindex $point1 0])] 
    set y1 [expr double([lindex $point1 1])]
    set z1 [expr double([lindex $point1 2])] 
    set x2 [expr double([lindex $point2 0])] 
    set y2 [expr double([lindex $point2 1])] 
    set z2 [expr double([lindex $point2 2])] 
    if { $x1 > $x2 } { set tmp $x1; set x1 $x2; set x2 $tmp; }
    if { $y1 > $y2 } { set tmp $y1; set y1 $y2; set y2 $tmp; }
    if { $z1 > $z2 } { set tmp $z1; set z1 $z2; set z2 $tmp; }
    set x1 [expr $x1-$tol]; set x2 [expr $x2+$tol];
    set y1 [expr $y1-$tol]; set y2 [expr $y2+$tol];
    set z1 [expr $z1-$tol]; set z2 [expr $z2+$tol];
    set foundlines ""
    set lines [regexp -linestop -all -inline {Num: ([0-9]*)} $lines]
    for { set i 1 } { $i < [llength $lines] } { incr i 2 } {
	set line [lindex $lines $i]
	if { $line > 0 } {
	    set retval [.central.s info list_entities lines $line] 
	    set points [lindex [regexp -linestop -inline {Points: ([ 0-9]*)} $retval] 1]
	    set pointA [lindex [.central.s info Coordinates [lindex $points 0]] 0]
	    set pointB [lindex [.central.s info Coordinates [lindex $points 1]] 0]
	    set xA [expr double([lindex $pointA 0])]
	    set yA [expr double([lindex $pointA 1])]
	    set zA [expr double([lindex $pointA 2])] 
	    set xB [expr double([lindex $pointB 0])]
	    set yB [expr double([lindex $pointB 1])]
	    set zB [expr double([lindex $pointB 2])]
	    if { $xA>=$x1 && $xB>=$x1 && $yA>=$y1 && $yB>=$y1 && $zA>=$z1 && $zB>=$z1 && \
		    $xA<=$x2 && $xB<=$x2 && $yA<=$y2 && $yB<=$y2 && $zA<=$z2 && $zB<=$z2 } {
		lappend foundlines $line
	    }
	}
    }
    return $foundlines
}
#
# Busca lneas (en una capa) cuyos puntos extremos estn en la caja que se define por los dos puntos 
# y una tolerancia
#
proc SearchLineInOYPlane {OYplane tol {layer ""} } {
    if { [ExistsLayer $layer] } {
	set lines [.central.s info list_entities lines layer:$layer]
    } else {
	set lines [.central.s info list_entities lines 1:2147483647]
    }    
    set y1 [expr double([lindex $OYplane 1])]; set y2 [expr double([lindex $OYplane 1])];
    if { $y1 > $y2 } { set tmp $y1; set y1 $y2; set y2 $tmp; }
    set y1 [expr $y1-$tol]; set y2 [expr $y2+$tol];
    set foundlines ""
    set lines [regexp -linestop -all -inline {Num: ([0-9]*)} $lines]
    for { set i 1 } { $i < [llength $lines] } { incr i 2 } {
	set line [lindex $lines $i]
	if { $line > 0 } {
	    set retval [.central.s info list_entities lines $line] 
	    set points [lindex [regexp -linestop -inline {Points: ([ 0-9]*)} $retval] 1]
	    set pointA [lindex [.central.s info Coordinates [lindex $points 0]] 0]
	    set pointB [lindex [.central.s info Coordinates [lindex $points 1]] 0]
	    set yA [expr double([lindex $pointA 1])]; set yB [expr double([lindex $pointB 1])];
	    if { $yA>=$y1 && $yB>=$y1 && $yA<=$y2 && $yB<=$y2 } {
		lappend foundlines $line
	    }
	}
    }
    return $foundlines
}
#
# Se calcula un vector normalizado, a partir de dos ndices de puntos
#
proc NormVector { pnt1 pnt2 } {
    set pointA [lindex [.central.s info Coordinates $pnt1] 0]
    set pointB [lindex [.central.s info Coordinates $pnt2] 0]
    set x [expr [expr double([lindex $pointB 0])]-[lindex $pointA 0]]
    set y [expr [expr double([lindex $pointB 1])]-[lindex $pointA 1]]
    set z [expr [expr double([lindex $pointB 2])]-[lindex $pointA 2]]
    set norm [expr sqrt($x*$x+$y*$y+$z*$z)]
    if { $norm == 0 } { return "" }
    set x [expr $x/$norm]
    set y [expr $y/$norm]
    set z [expr $z/$norm]
    return "$x $y $z"
}
#
# Se crea una lista con todos los puntos de una lista de lneas (se excluyen los repetidos)
#
proc ListPointsFromLines { lines } {
    set ret_list ""
    for { set i 0 } { $i < [llength $lines] } { incr i } {
	set line [lindex [lindex $lines $i] 0]
	set retval [.central.s info list_entities lines $line] 
	set points [regexp -linestop -all -inline {Points:([ 0-9]*)} $retval]
	for { set j 1 } { $j < [llength $points] } { incr j 2 } {
	    set pnt1 [lindex [lindex $points $j] 0]
	    set pnt2 [lindex [lindex $points $j] 1]
	    if { [lsearch $ret_list $pnt1 ]==-1 } { lappend ret_list $pnt1 }
	    if { [lsearch $ret_list $pnt2 ]==-1 } { lappend ret_list $pnt2 }
	}
    } 
    return $ret_list
}
#
# Se asignan tamaos a todas las entidades de una capa.
#
proc AssignMeshCriteriaLayer {layer_name {ms Mesh}} {
    if { [ExistsLayer $layer_name] } {
	.central.s process escape escape escape escape Meshing MeshCriteria $ms Points layer:$layer_name
	.central.s process escape escape escape escape Meshing MeshCriteria $ms Lines layer:$layer_name
	 .central.s process escape escape escape escape Meshing MeshCriteria $ms Surfaces layer:$layer_name
	.central.s process escape escape escape escape Meshing MeshCriteria $ms Volumes layer:$layer_name
	.central.s process escape escape escape escape
    }
}  
#
# Se asigna una condicin a todas las entidades de una capa. Para ello asigna los valores pertinentes a los campos.
#
proc AssignConditionToLayer {layer_name cond { value "" }} {
    if { [ExistsLayer $layer_name] } {
	if { $value != "" } {
	    .central.s process escape escape escape escape Data Conditions AssignCond $cond change
	     foreach ivalue [lrange $value 0 end] {
		.central.s process $ivalue
	    }
	    .central.s process layer:$layer_name escape
	} else {
	    .central.s process escape escape escape escape Data Conditions AssignCond \
		    $cond layer:$layer_name escape
	}
    }
} 
#
# Se asigna un material a una capa.
#
proc AssignMaterialToLayer {layer_name material entity} {
    if { [ExistsLayer $layer_name] && [ExistsMaterial $material] } {
	.central.s process escape escape escape escape Data Materials AssignMaterial \
		$material $entity layer:$layer_name escape
    }
}  
#
# Se desasignan todas las condiciones de contorno.
#
proc UnAssignConditions {} {
    .central.s process escape escape escape escape Data Conditions UnAssign Yes escape
}  
#
# Se desasignan todos los materiales
#
proc UnAssignMaterials {} {
    .central.s process escape escape escape escape Data Materials UnAssign Yes escape
} 
#
# Comprueba si existe un material
#
proc ExistsMaterial { mat } {
    if { $mat=="" } { return 0 }
    set mats_list [.central.s info materials]
    if {[lsearch -exact $mats_list $mat] == -1} {
	return 0
    } else {
	return 1
    }
}  
#
# Se crea un nuevo material (eliminado el antiguo si existe) y se 
# editan algunos campos
#
proc CreateMaterial { mat newmat {field ""} {value ""} } {
    if { ![ExistsMaterial $mat] } { return } 
    if { [ExistsMaterial $newmat] } { 
	.central.s process escape escape escape escape data \
		materials deletematerial $newmat escape
    } 
    # lee los datos del material
    set input [.central.s info materials $mat]
    set NumFields [lindex $input 0]
    set NameList ""
    set ValueList ""
    for { set i 0 } { $i < $NumFields } { incr i 1 } {
	lappend NameList [lindex $input [expr $i*2+1]]
	lappend ValueList [lindex $input [expr $i*2+2]]
    }
    # cambia los datos del material
    if { $value != "" } {
	foreach ifield [lrange $field 0 end] {
	    set idxold [lsearch -glob $NameList $ifield*]
	    set idxnew [lsearch -exact $field $ifield]
	    if { $idxold!=-1 && $idxnew!=-1 } {
		set NewValue [lindex $value $idxnew] 
	       #set OldValue [lindex $ValueList $idxold]
		set ValueList [lreplace $ValueList $idxold $idxold $NewValue]
	    } 
	}
	set output "" 
	foreach i $ValueList {
	    append output "$i "
	}
	.central.s process escape escape escape escape data \
		materials newmaterial $mat $newmat $output
    } else {
	.central.s process escape escape escape escape data \
		materials newmaterial $mat $newmat $input
    }
}  
#
# Se cambian valores de los datos del problema
#
proc EditProblemData { field value } {
    set NumFields [llength $field]
     for { set i 0 } { $i < $NumFields } { incr i 1 } {
	 set ifield [lindex $field $i]
	 set ivalue [lindex $value $i]
	.central.s process escape escape escape escape Data ProblemData -SingleField- \
		$ifield $ivalue escape escape escape escape 
    } 
} 
#
# Se dibuja una linea dados los ndices de los puntos existentes
#
proc DrawLineByPoints { pntA pntB } {
    .central.s process escape escape escape escape geometry create line $pntA old
    .central.s process $pntB old escape
}
#
# Se dibuja una linea dados los ndices de los puntos existentes
#
proc DrawLineByIndex { pntA pntB } {
    .central.s process escape escape escape escape geometry create \
	line join $pntA $pntB escape
}
#
# Lee una imagen de un archivo
#
proc imagefromtdyn { name } {
    global ProblemTypePriv
    if { ![info exist ProblemTypePriv(image-$name)] } {
	set ProblemTypePriv(image-$name) [image create photo -file \
		[file join $ProblemTypePriv(problemtypedir) images $name]]
    }
    return $ProblemTypePriv(image-$name)
}
#
# Deshabilita la ventana grfica de GiD y pone el cursor en espera
#
proc GraphicsOFF { } {
    .gid conf -cursor watch
    .central.s waitstate 1
    update 
    .central.s disable windows 1
    .central.s disable graphics 1
}
#
# Habilita la ventana grfica de GiD y pone el cursor en activo
#
proc GraphicsON { } {
    .central.s disable windows 0
    .central.s disable graphics 0
    .central.s process escape escape escape zoom frame escape  
    .gid conf -cursor ""
    .central.s waitstate 0
}

proc RemoveMenuOptionIfExists {menu_name option_name prepost} { 
    global MenuNames MenuEntries MenuCommands MenuAcceler
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
    
    if {$prepost!="PRE" && $prepost!="POST" && $prepost!="PREPOST"} {  
	return -code error "Wrong arg. Must be PRE, POST or PREPOST."
    }
    
    if {$prepost=="PRE" || $prepost=="PREPOST"} {
	set ipos [lsearch $MenuNames $menu_name]
	if { $ipos != -1 } {
	    set jpos [lsearch $MenuEntries($ipos) $option_name]
	    if { $jpos != -1 } {
		set MenuEntries($ipos)  [lreplace $MenuEntries($ipos) $jpos  $jpos]
		set MenuCommands($ipos) [lreplace $MenuCommands($ipos) $jpos $jpos]
		if {[info exists MenuAcceler($ipos)] && [llength $MenuAcceler($ipos)] > $jpos} {
		    set MenuAcceler($ipos) [lreplace $MenuAcceler($ipos) $jpos $jpos]
		}
	    } 
	}
    }
    if {$prepost=="POST" || $prepost=="PREPOST"} {
	set ipos [lsearch $MenuNamesP $menu_name]
	if { $ipos != -1 } {
	    set jpos [lsearch $MenuEntriesP($ipos) $option_name]
	    if { $jpos != -1 } {
		set MenuEntriesP($ipos)  [lreplace $MenuEntriesP($ipos) $jpos  $jpos]
		set MenuCommandsP($ipos) [lreplace $MenuCommandsP($ipos) $jpos $jpos]
		if {[info exists MenuAccelerP($ipos)] && [llength $MenuAccelerP($ipos)] > $jpos} {
		    set MenuAccelerP($ipos) [lreplace $MenuAccelerP($ipos) $jpos $jpos]
		}
	    } 
	}
    }
}
#
# Devuelve una lista de valores, partiendo de la inicial "list" pero saltando 
# los elementos cada "step" valores y comenzando en el elemento "inicio
#
proc lstep { list step {inicio 0} } {
    set iend [llength $list]
    set newlist ""
    for { set i $inicio } { $i <= $iend } { incr i $step } {
	lappend newlist [lindex $list $i] 
    }
    return $newlist
} 

