#tdynwizard.tcl  -*- TCL -*- Created: JGE Jan-2002, Modified: JGE Feb-2002

proc OpenTipsWizardWindow { } {
    global TipsWizPriv ProblemTypePriv
 
    # create the wizard widget
    set wizwin .gid.tipswizard
    if { [winfo exists $wizwin] } {
	$wizwin show
	return
    }
    catch { unset TipsWizPriv }

    set dir $ProblemTypePriv(problemtypedir)
    set width 400
    set height 250
    set x [expr [winfo screenwidth .]/2-$width/2]
    set y [expr [winfo screenheight .]/2-$height/2]
    set geometry  ${width}x${height}+${x}+${y}
    tkwizard::tkwizard $wizwin -icondir "$dir/images/tips.gif" \
	    -title "Tip of the day" -geom $geometry \
	    -finishtext "" -canceltext "Close" -resize

    # create the tips
    proc setTipShow { } {
	global ProblemTypePriv TipsWizPriv
	set filename [GiveTdynDefaultsFile]
	WriteVarTdynDefaults showtips $TipsWizPriv(show)
    }

    set TipsWizPriv(show) [IsVarOnTdynDefaults showtips 1]
    bind $wizwin <<WizCancel>> {setTipShow}
    set TipsWizPriv(text) [list \
	    "Find some on-line tutorials in Help>Tutorials. They will\
	    guide you in the geometry creation and meshing processes" \
	    "Find some on-line tutorials which will guide you\
	    in the Tdyn analysis process in Help>Tdyn tutorials" \
	    "Create easily reports of your analyses by usign the utility\
	    available in Utilities>Create Report" \
	    "Follow the icons in the Tdyn toolbar downwards to define\
	    all the data, meshing and perform and analysis" \
	    "Define materials data by functions. This can be comfortably\
	    done with the Functions editor, accessible by pressing the\
	    button \"fx\" of the material window." \
	    "Functions can use any of the variable data calculated within\
	    Tdyn (temperature, velocity, pressure, ...). It is also possible\
	    to calcule its Cartesian derivatives." \
            "Define new results by functions. This can be comfortably\
	    done with the Functions editor, accessible by pressing the\
	    button \"fx\" of the problem data window." \
            "Select results to be written through the label window Write\
            Results of the PROBLEM data window."]

    proc ShowTip { w idx } {
	global TipsWizPriv
	frame $w.fr -borderwidth 1 -relief flat
	label $w.fr.lb -wraplength 240 -justify left -text \
		[lindex $TipsWizPriv(text) $idx]
	checkbutton $w.fr.b1 -text "Show tips at start up" -relief flat \
		-variable TipsWizPriv(show)
	grid $w.fr.lb -row 0 -column 0 -sticky nsew
 	grid $w.fr.b1 -row 1 -column 0 -sticky sw
	grid $w.fr -row 0 -column 0 -sticky nsew
	grid columnconfigure $w.fr 0 -weight 1
	grid rowconfigure    $w.fr 0 -weight 1
	grid columnconfigure $w 0 -weight 1
	grid rowconfigure    $w 0 -weight 1 
	grid conf $w -rowspan 4
    }

    # define wizard steps
    for { set i 0 } { $i < [llength $TipsWizPriv(text)] } { incr i } {
	set command1 {set w [$this widget clientArea]}
	set command2 {$this stepconfigure -title "Did you know ..." -subtitle ""}
	set command3 {ShowTip $w}
	append command3 " $i"
	$wizwin step Tip$i -title "Tip of the Day" \
		-layout advanced "$command1; $command2; $command3;"
    }

    # show the wizard
    $wizwin showRandom

}
