!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
TDYN_2D; ! TDYN PROBLEM TYPE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
OutputUnits:   Length=*gendata(Output_Length_units), 
               Time  =*gendata(Output_Time_units), 
               Mass  =*gendata(Output_Mass_units);
InternalUnits: Length=*gendata(Internal_Length_units), 
               Time  =*gendata(Internal_Time_units), 
               Mass  =*gendata(Internal_Mass_units);
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ProblemDefinition;
GeneralData:  Number_of_Steps = *gendata(Number_of_Steps), Output_Step = *gendata(Output_Step), Output_Start = *gendata(Output_Start),
              Time_increment = "*gendata(Time_increment);" *gendata(Time_increment_Units), Max_Iterations = *gendata(Max_Iterations),
              NewRunVelocities = *gendata(Velocities_List), StepsNewRunVelocities = *gendata(Additional_Steps),
              Initial_Steps = *gendata(Initial_Steps), Start_Up_Control = *gendata(Start_Up_Control)*\
*if(strcmp(gendata(Restart),"On")==0) 
, Restart*\
*endif 
*if(strcmp(gendata(Wall_Law_Type),"FixTau")==0) 
, OldLawOfTheWall*\
*endif 
*if(strcmp(gendata(Wall_Law_VFor),"On")==0) 
, GiveWallLawForces*\
*endif 
;
PhysicalData: *\
*if(strcmp(gendata(Give_Gravity),"Yes")==0) 
, Gravity = *gendata(GravityOX) *gendata(GravityOY) *gendata(GravityOZ) *gendata(Gravity_Units)*\
*endif 
*if(strcmp(gendata(Give_Pressure_Origin),"Yes")==0) 
, Pres_Origin = *gendata(Pressure_Origin_OX) *gendata(Pressure_Origin_OY) *gendata(Pressure_Origin_OZ) *gendata(Geometry_Units) *\
*endif 
;
WriteResultsData: *\
*if(gendata(Initial_Data,int)!=0) 
 Initial*\
*endif 
*if(gendata(Velocity,int)!=0) 
 Velocity*\
*endif
*if(gendata(Velocity_Stress_Tensor,int)!=0)
 VelocityStress*\
*endif
*if(gendata(Pressure,int)!=0)
 Pressure*\
*endif
*if(gendata(Pressure_Gradient,int)!=0)
 GradPressure*\
*endif
*if(gendata(Temperature,int)!=0)
 Temperature*\
*endif
*if(gendata(Temperature_Gradient,int)!=0)
 GradTemperature*\
*endif
*if(gendata(Solid_Density,int)!=0)
 SolidDensity*\
*endif
*if(gendata(Species_Concentration,int)!=0)
 Concentration*\
*endif
*if(gendata(Wave_Elevation,int)!=0)
 Beta*\
*endif
*if(gendata(Wave_Elevation_Vector,int)!=0)
 BetaVector*\
*endif
*if(gendata(Density,int)!=0)
 Density*\
*endif
*if(gendata(Viscosity,int)!=0)
 Viscosity*\
*endif
*if(gendata(Compressibility_factor,int)!=0)
 CompressFactor*\
*endif
*if(gendata(Wall_Law_Traction,int)!=0)
 WallLawTau*\
*endif
*if(gendata(Tau_Parameter,int)!=0)
 TauParameter*\
*endif
*if(gendata(Distance,int)!=0)
 Distance*\
*endif
*if(gendata(Vorticity,int)!=0)
 Vorticity*\
*endif
*if(gendata(Eddy_Viscosity,int)!=0)
 EddyViscosity*\
*endif
*if(gendata(EddyKin_Energy,int)!=0)
 EddyKinEnergy*\
*endif
*if(gendata(Epsilon,int)!=0)
 Epsilon*\
*endif
*if(gendata(Omega,int)!=0)
 Omega*\
*endif
*if(gendata(Tau_Eddy,int)!=0)
 KTau*\
*endif
*if(gendata(Mesh_Deformation,int)!=0)
 MeshDeformation*\
*endif
*if(gendata(UserDefinedF1,int)!=0)
 UserDefFluid1*\
*endif
*if(gendata(UserDefinedF2,int)!=0)
 UserDefFluid2*\
*endif
*if(gendata(UserDefinedF3,int)!=0)
 UserDefFluid3*\
*endif
*if(gendata(UserDefinedS1,int)!=0)
 UserDefSolid1*\
*endif
*if(gendata(UserDefinedS2,int)!=0)
 UserDefSolid2*\
*endif
*if(gendata(UserDefinedS3,int)!=0)
 UserDefSolid3*\
*endif
;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   Nodes, CoordinateUnits=*gendata(Geometry_Units);	
*loop nodes
*format " %i %lf %lf %lf"
  *Nodesnum  *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
*set var ElemType = 1
*set var NumTypes = 6
*set var nnodetri = 3
*set var nnodequa = 4
*set var nnodelin = 2
*if(isQuadratic)
*if(nnode==7||nnode==9)
*set var nnodetri = 7
*set var nnodequa = 9
*else
*set var nnodetri = 6
*set var nnodequa = 8
*endif
*set var nnodelin = 3
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*if(strcmp(gendata(Solve_Fluid),"Yes")==0) 
 FluidDefinition: Integration_Scheme = *gendata(FTime_Integration)*\
*if(strcmp(gendata(Solve_FluidFlow_in_Fluid),"Yes")==0) 
, Solve_NavierStokes, MinTauV_Ratio = *gendata(StabTauV_MinRatio), MinTauP_Ratio = *gendata(StabTauP_MinRatio), Velocity_Smoothing = *gendata(Velocity_Control_Level)*\
*if(strcmp(gendata(Turbulence_Model),"Smagorinsky")==0) 
, Solve_Smagorinsky*\
*elseif(strcmp(gendata(Turbulence_Model),"Mixing_Length")==0)
, Solve_Mixing_Length*\
*elseif(strcmp(gendata(Turbulence_Model),"Kinetic_Energy")==0)
, Solve_Kinetic_Energy*\
*elseif(strcmp(gendata(Turbulence_Model),"K_Energy_Two_Layers")==0)
, Solve_Kinetic_Energy_2L*\
*elseif(strcmp(gendata(Turbulence_Model),"K_KT")==0)
, Solve_K_KT*\
*elseif(strcmp(gendata(Turbulence_Model),"K_Omega")==0)
, Solve_K_Omega*\
*elseif(strcmp(gendata(Turbulence_Model),"K_E_High_Reynolds")==0)
, Solve_K_Epsilon*\
*elseif(strcmp(gendata(Turbulence_Model),"K_E_Lam_Bremhorst")==0)
, Solve_K_Epsilon_LB*\
*elseif(strcmp(gendata(Turbulence_Model),"K_E_Launder_Sharma")==0)
, Solve_K_Epsilon_LS*\
*elseif(strcmp(gendata(Turbulence_Model),"K_E_Two_Layers")==0)
, Solve_K_Epsilon_2L*\
*elseif(strcmp(gendata(Turbulence_Model),"Spalart_Allmaras")==0)
, Solve_Spalart_Allmaras*\
*elseif(strcmp(gendata(Turbulence_Model),"K_Omega_SST")==0)
, Solve_K_Omega_SST*\
*endif 
*if(strcmp(gendata(Fix_Turbulence_On_Bodies),"Yes")==0) 
, FixTurbulenceOnBodies *\
*endif
, Turbulence_Smoothing = *gendata(Turbulence_Control_Level), EddyKEnergy_Production_Limit = *gendata(EddyKEnergy_Production_Limit), Epsilon_Production_Limit = *gendata(Epsilon_Production_Limit), Epsilon_Reaction_Limit = *gendata(Epsilon_Reaction_Limit), Omega_Production_Limit = *gendata(Omega_Production_Limit), Omega_Reaction_Limit = *gendata(Omega_Reaction_Limit), EddyViscoT_Production_Limit = *gendata(EddyViscoT_Production_Limit), EddyViscoT_Reaction_Limit = *gendata(EddyViscoT_Reaction_Limit), TVscMinimum = *gendata(TVisco_Min_Ratio), TVscMaximum = *gendata(TVisco_Max_Ratio), KenrMinimum = *gendata(KEnergy_Min_Ratio), KenrMaximum = *gendata(KEnergy_Max_Ratio), EpslMinimum = *gendata(Epsilon_Min_Ratio), EpslMaximum = *gendata(Epsilon_Max_Ratio), OmegMinimum = *gendata(Omega_Min_Ratio), OmegMaximum = *gendata(Omega_Max_Ratio), KtauMinimum = *gendata(K_Tau_Min_Ratio), KtauMaximum = *gendata(K_Tau_Max_Ratio), NS_AdvecStab_*gendata(Velocity_Advect_Stabilisation), NS_PressStab_*gendata(Pressure_Stabilisation), TB_AdvecStab_*gendata(Turbulence_Advect_Stabilisation), SteadyNorm = *gendata(FLUIDSOLVER_Steady_State_Norm), AdvectionNorm = *gendata(Advection_Norm), Control_Increment = *gendata(FLUIDSOLVER_Increment_Control)*\ 
*if(strcmp(gendata(Fix_Turbulence_On_Bodies),"Yes")==0) 
, FixTurbulenceOnBodies *\
*endif 
*if(strcmp(gendata(Use_Total_Pressure),"Yes")==0) 
, Total_Pressure *\
*endif 
*endif 
*if(strcmp(gendata(Solve_Temperature_in_Fluid),"Yes")==0)
, Solve_Temperature, Temperature_Smoothing = *gendata(Temperature_Control_Level), TM_AdvecStab_*gendata(Temperature_Advect_Stabilisation),*\
*endif
*if(strcmp(gendata(Solve_Pseudoconcentration_in_Fluid),"Yes")==0)
, Solve_Pseudoconcentration*\
*endif
*if(strcmp(gendata(Solve_Compressibility_in_Fluid),"Yes")==0)
, Solve_Compressibility*\
*endif
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0)
, Solve_PhiProblems*\
*endif
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0)
, Solve_Concentration*\
*endif
*if(strcmp(gendata(Solve_MeshDeformation_in_Fluid),"Yes")==0)
, Solve_Mesh_Deformation, MeshDeformationType = *gendata(Fluid_Mesh_Deformation)*\
*endif
;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*7+1
 NewSpecDefinition: Index = *iphi, Name = "*gendata(Species_Names,*iphi)", MaxLimit = *gendata(Advect_Solverdata,*coun), MinLimit = *gendata(Advect_Solverdata,*operation(coun+1)), Convergence_Norm = *gendata(Advect_Solverdata,*operation(coun+2)), InnerIterations = *gendata(Advect_Solverdata,*operation(coun+3)), AdvecStab_*gendata(Advect_Solverdata,*operation(coun+4)), Phi_Smoothing = *gendata(Advect_Solverdata,*operation(coun+5)), Boundary_Units = [*gendata(Advect_Solverdata,*operation(coun+6))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*7+1
 NewPhiDefinition: Index = *iphi, Name = "*gendata(URVariables_Names,*iphi)", MaxLimit = *gendata(URSolver_Solverdata,*coun), MinLimit = *gendata(URSolver_Solverdata,*operation(coun+1)), Convergence_Norm = *gendata(URSolver_Solverdata,*operation(coun+2)), InnerIterations = *gendata(URSolver_Solverdata,*operation(coun+3)), AdvecStab_*gendata(URSolver_Solverdata,*operation(coun+4)), Phi_Smoothing = *gendata(URSolver_Solverdata,*operation(coun+5)), Boundary_Units = [*gendata(URSolver_Solverdata,*operation(coun+6))];
*end
*endif 
InitialDataFunctions;
    Function VelocityX = "*gendata(Initial_VelocityX);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(Initial_VelocityY);" *gendata(Boundary_Velocity_Units);
    Function Pressure = "*gendata(Initial_Pressure);"  *gendata(Boundary_Pressure_Units);
    Function EddyKineticEnergy = "*gendata(Initial_EddyKEner);" *gendata(Boundary_Kenr_Units);
    Function EddyLength = "*gendata(Initial_EddyLength);" *gendata(Boundary_Elen_Units);
    Function Temperature = "*gendata(Initial_Temperature);" *gendata(Boundary_Temperature_Units);
EndInitialDataFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesInitialData *iphi = "*gendata(Advect_Initdata,*operation(2*(iphi-1)+1));" [*gendata(Advect_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableInitialData *iphi = "*gendata(URSolver_Initdata,*operation(2*(iphi-1)+1));" [*gendata(URSolver_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
ConditionalFunctions;
    Function VelocityX = "*gendata(VelocityX_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(VelocityY_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function Pressure  = "*gendata(Pressure_FuncCond);"  *gendata(Boundary_Pressure_Units);
EndConditionalFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesConditional *iphi = "*gendata(Advect_Initdata,*operation(2*(iphi-1)+2));" [*gendata(Advect_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableConditional *iphi = "*gendata(URSolver_Initdata,*operation(2*(iphi-1)+2));" [*gendata(URSolver_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
*if(strcmp(gendata(Solve_MeshDeformation_in_Fluid),"Yes")==0) 
 MeshDeformationFunctions: 
    MeshDeformationX = "*gendata(Fluid_Deformation_X);" *gendata(Geometry_Units),
    MeshDeformationY = "*gendata(Fluid_Deformation_Y);" *gendata(Geometry_Units),
    MeshDeformationZ = "*gendata(Fluid_Deformation_Z);" *gendata(Geometry_Units);
*endif 
*if(strcmp(gendata(UserIntegralF1),"0")!=0 || strcmp(gendata(UserIntegralS2),"0")!=0 || strcmp(gendata(UserIntegralS3),"0")!=0) 
IntegralFunctions:
    Integral1 = "*gendata(UserIntegralF1);" [],
    Integral2 = "*gendata(UserIntegralF2);" [],
    Integral3 = "*gendata(UserIntegralF3);" [];
*endif 
*if(gendata(UserDefinedF1,int)!=0 || gendata(UserDefinedF2,int)!=0 || gendata(UserDefinedF3,int)!=0) 
 CustomisedResultsFunctions;
*if(gendata(UserDefinedF1,int)!=0)
    CustomRes = "*gendata(FluidFunction1);", Name = "*gendata(FluidFunction1_Name)";
*endif
*if(gendata(UserDefinedF2,int)!=0)
    CustomRes = "*gendata(FluidFunction2);", Name = "*gendata(FluidFunction2_Name)";
*endif
*if(gendata(UserDefinedF3,int)!=0)
    CustomRes = "*gendata(FluidFunction3);", Name = "*gendata(FluidFunction3_Name)";
*endif
 EndCustomisedResultsFunctions;
*endif 
 NonSymmetric "Fluid 1st Solver": Solver = *gendata(FSolver_NonSymmetric), Tolerance = *gendata(NS1_Tolerance), Max_Iter = *gendata(NS1_MaxIter), Preconditioner = *gendata(NS1_Preconditioner);
 Symmetric "Fluid 2nd Solver": Solver = *gendata(FSolver_Symmetric), Tolerance = *gendata(NS2_Tolerance), Max_Iter = *gendata(NS2_MaxIter), Preconditioner = *gendata(NS2_Preconditioner);
  ElmSets;
*set var MatNumber = 1
*loop Materials 
*if(strcmp(MatProp(Type),"Fluid")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==2 || ElemType==3)
*set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
Set *MatNumber:  Type = Fluid, Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
        SpeciesProperties;
*set var spes = Matprop(Species_Properties,INT)/5
*set var coun = 1
*set var ucoun = 1
*for(im=1;im<=spes;im=im+1) 
           F1 = "*Matprop(Species_Properties,*coun);" [],*\
*set var coun=coun+1
 F2 = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F3 = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F4 = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\ 
*set var coun=coun+1
*set var ucoun=ucoun+1
 F5 = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun);
*set var coun=coun+1
*set var ucoun=ucoun+1
*end 
        EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
        VariablesProperties;
*set var phis = Matprop(Variables_Properties,INT)/5
*set var coun = 1
*set var ucoun = 1
*for(im=1;im<=phis;im=im+1) 
           F1t = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F1c = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F2 = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F3 = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F4 = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun);
*set var coun=coun+1
*set var ucoun=ucoun+1
*end 
        EndVariablesProperties;
*endif 
                  PhysicalPropertiesFunctions;  ! Data fields given as functions
                    Function AccelerationX = "*MatProp(AccOX_Field);"  *MatProp(Acceleration_Units);
                    Function AccelerationY = "*MatProp(AccOY_Field);"  *MatProp(Acceleration_Units);
                    Function HeatSource = "*MatProp(Heat_Source_Field);" *MatProp(Heat_Source_Units);
                    Function Viscosity = "*MatProp(Viscosity);" *MatProp(Viscosity_Units);
                    Function Density = "*MatProp(Density);" *MatProp(Density_Units);
                    Function Compressibility = "*MatProp(Compressibility);" *MatProp(Compressibility_Units);
                    Function SpecificHeat = "*MatProp(Specific_Heat_Cp);"  *MatProp(Cp_Units);
                    Function Conductivity = "*MatProp(Thermal_Conductivity_k);" *MatProp(k_Units); 
                    Function Floatability = "*MatProp(Floatability);" [];                                 
                    Function HeatSourceReaction = "*MatProp(Heat_Reaction_Field);" *MatProp(Heat_Reaction_Units); 
                  EndPhysicalPropertiesFunctions;
                Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif 
*end 
*if(WriteTitle==0) 
                      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"Fluid_Body")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==1)
*set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = WBody,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,
                      Center_of_Gravity: GOX = "*MatProp(Centre_of_Gravity_X);" *gendata(Geometry_Units), GOY = "*MatProp(Centre_of_Gravity_Y);" *gendata(Geometry_Units), GOZ = "0.0;" *gendata(Geometry_Units), Mass = *MatProp(Body_Mass) *MatProp(Body_Mass_Units),
                      Radii_of_Gyration = 1.0 1.0 *MatProp(Radius_of_Gyration_Z) *MatProp(Radii_of_Gyration_Units),
                      KD_Units = 1 *MatProp(KD_Units), KR_Units = 1 *MatProp(KR_Units), Springs =*\
*for(im=1;im<=Matprop(Springs,INT);im=im+1) 
 *Matprop(Springs,*im)*\
*end 
                              *\
*if((strcmp(MatProp(Displacement_OX),"Yes")==0)) 
Displacement_OX, *\
*endif
*if((strcmp(MatProp(Displacement_OY),"Yes")==0)) 
Displacement_OY, *\
*endif
*if((strcmp(MatProp(Rotation_OZ),"Yes")==0)) 
Rotation_OZ, *\
*endif
*if(MatProp(Sharp_Angle,real)>0)
, Sharp_Angle = *MatProp(Sharp_Angle) *MatProp(Angle_Units) *\
*endif
*if(MatProp(Fix_Angle,real)>0)
, Line_Fix_Angle = *MatProp(Fix_Angle) *MatProp(Angle_Units) *\
*endif
*if((strcmp(MatProp(BoundType),"RoughWall")==0))
, RoughWall, Delta = *MatProp(Delta) *MatProp(Delta_Units), Roughness = *MatProp(Roughness) *MatProp(Roughness_Units) *\ 
*elseif((strcmp(MatProp(BoundType),"DeltaWall")==0))
, DeltaWall, Delta = *MatProp(Delta) *MatProp(Delta_Units) *\
*elseif((strcmp(MatProp(BoundType),"YplusWall")==0))
, YplusWall, Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"Cw_U2Wall")==0))
, Cw_U2Wall, Cw = *MatProp(Cw), *\
*elseif((strcmp(MatProp(BoundType),"ITTC_Wall")==0))
, ITTC_Wall, Cw = *MatProp(Cw), Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"User_Wall")==0))
, User_Wall, User_U_t = "*MatProp(FTau_Field);", User_Ken = "*MatProp(Kenr_Field);", User_Len = "*MatProp(ELen_Field);" *\
*elseif((strcmp(MatProp(BoundType),"InvisWall")==0))
, InvisWall *\
*elseif((strcmp(MatProp(BoundType),"V_fixWall")==0))
, V_fixWall *\
*elseif((strcmp(MatProp(BoundType),"None_Wall")==0))
, None_Wall *\
*elseif((strcmp(MatProp(BoundType),"OutFBound")==0))
, OutFBound *\
*endif
; 
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Fluid),"Yes")==0) 
        SpeciesProperties;
*set var spes = Matprop(Species_Properties,INT)/2
*set var coun = 1
*for(im=1;im<=spes;im=im+1) 
           Flux_Spc = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*coun),*\
*set var coun=coun+1
 Reac_Spc = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*coun);
*set var coun=coun+1
*end 
        EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Fluid),"Yes")==0) 
        VariablesProperties;
*set var phis = Matprop(Variables_Properties,INT)/2
*set var coun = 1
*for(im=1;im<=phis;im=im+1) 
           Flux_Phi = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*coun),*\
*set var coun=coun+1
 Reac_Phi = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*coun);
*set var coun=coun+1
*end 
        EndVariablesProperties;
*endif 
                      PhysicalPropertiesFunctions;  ! Data fields given as functions
                       Function HeatFlux = "*MatProp(Heat_Flux);" *MatProp(Heat_Flux_Units);
                       Function HeatFluxReaction = "*MatProp(Reactive_Heat_Flux);" *MatProp(Reactive_Heat_Flux_Units);
                     EndPhysicalPropertiesFunctions;
                      Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif 
		*ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif 
*end 
*if(WriteTitle==0) 
                      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"FreeS")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1) 
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif 
*if(ElemType==1)
*set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = FreeS,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,

                       Charact_Length = *MatProp(Length) *MatProp(Length_units), Damping_length = *MatProp(Damping_length), 
                       Damping_factor = *MatProp(Damping_factor), Time_factor = *MatProp(Time_factor), Time_ratio = *MatProp(Step_factor),
                       MinTau_Ratio = *MatProp(StabTau_MinRatio), Integration_Scheme = *MatProp(Time_Integration), Beta_Smoothing = *MatProp(Control_Level)*\
                       MaxValue = *MatProp(Maximum_Value), MinValue = *MatProp(Minimum_Value), FS_AdvecStab_*MatProp(Advect_Stabilisation)*\
*if(strcmp(MatProp(CrossWind_Diffusion),"On")==0) 
, CrossWind_Diffusion*\
*endif 
;
               Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif 
*end 
*if(WriteTitle==0) 
                      end elements;
*endif 
*endif 
*end 
*endif 
*end 
  EndElmSets;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  Boundary;
   BoundaryUnits: Length=*gendata(Boundary_Length_units), 
                  Time  =*gendata(Boundary_Time_units), 
                  Mass  =*gendata(Boundary_Mass_units);
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Coordinate Planes Symmetry
*if((strcmp(gendata(Xplane_Symmetry_in_Fluid),"Yes")==0))
   Xplane_VSym *gendata(Xplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
*if((strcmp(gendata(Yplane_Symmetry_in_Fluid),"Yes")==0))
   Yplane_VSym *gendata(Yplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!  Fix Pressure Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Pressure         *nodes
*add Cond Surface_Fix_Pressure *nodes	
*add Cond Line_Fix_Pressure    *nodes	
*add Cond Point_Fix_Pressure   *nodes
*loop nodes *OnlyInCond
*format " Node %i :Pres = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Direction  !!!!!!!!!!!!!!!
*set Cond Line_Fix_Velocity_Direction *nodes 
*add Cond Point_Fix_Velocity_Direction *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(1) *LocalAxesDef(4) 0.00000;
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(2) *LocalAxesDef(5) 0.00000;
*else
 Node *NodesNum : LVel *LocalAxesDef(3) *LocalAxesDef(6) 0.00000;
*endif
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Velocity         *nodes *or(1,int) *or(3,int)
*add Cond Surface_Fix_Velocity *nodes *or(1,int) *or(3,int)
*Add Cond Line_Fix_Velocity    *nodes *or(1,int) *or(3,int)
*Add Cond Point_Fix_Velocity   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Velc  %.5lf %.5lf 0.00000 , Fix %i %i 1;"
  *NodesNum *cond(2) *cond(4) *cond(1) *cond(3)
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Component  !!!!!!!!!!!!!!!
*set Cond Line_Fix_Velocity_Component *nodes 
*add Cond Point_Fix_Velocity_Component *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(1) *LocalAxesDef(4) 0.00000, lVl = *cond(3);
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(2) *LocalAxesDef(5) 0.00000, lVl = *cond(3);
*else
 Node *NodesNum : Norm *LocalAxesDef(3) *LocalAxesDef(6) 0.00000, lVl = *cond(3);
*endif
*end
!!!!!!!!!!!!!!!     Fix_Null_Gradient    !!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!     Remove_Velocity      !!!!!!!!!!!!!!!
*set Cond Point_Remove_Velocity_Conditions *nodes
*loop nodes *OnlyInCond
*if(fabs(cond(real,1)))
*format " Node %i, Delt;"
  *NodesNum
*endif
*end
!!!!!!!!!!!!!!!     Velocity Field       !!!!!!!!!!!!!!!
*set Cond Velocity_Field          *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int)
*add Cond Surface_Velocity_Field  *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int)
*Add Cond Line_Velocity_Field     *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int)
*Add Cond Point_Velocity_Field    *nodes
*loop nodes *OnlyInCond
*format " Node %i : TVel %i %i 1 %i %i 0;"
  *NodesNum *cond(1) *cond(2) *cond(3) *cond(4)
*end
!!!!!!!!!!!!!!!   Conditional Velocity   !!!!!!!!!!!!!!!
*set Cond Conditional_Velocity          *nodes
*add Cond Surface_Conditional_Velocity  *nodes
*Add Cond Line_Conditional_Velocity     *nodes
*Add Cond Point_Conditional_Velocity    *nodes
*loop nodes *OnlyInCond
 Node *NodesNum : CondVel;
*end
!!!!!!!!!!!!!!!     Pressure Field       !!!!!!!!!!!!!!!
*set Cond Pressure_Field         *nodes *or(1,int) *or(2,int)
*add Cond Surface_Pressure_Field *nodes *or(1,int) *or(2,int)
*Add Cond Line_Pressure_Field    *nodes *or(1,int) *or(2,int)
*Add Cond Point_Pressure_Field   *nodes
*loop nodes *OnlyInCond
*format " Node %i : TPres %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!  Conditional    !!!!!!!!!!!!!!
*set Cond  Conditional_Pressure        *nodes
*add Cond Surface_Conditional_Pressure *nodes
*add Cond Line_Conditional_Pressure    *nodes
*add Cond Point_Conditional_Pressure   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondPres;
*end
!!!!!!!!!!!!!!!     Fix Temperature      !!!!!!!!!!!!!!!
*set Cond Fix_Temperature         *nodes
*add Cond Surface_Fix_Temperature *nodes		
*Add Cond Line_Fix_Temperature    *nodes	
*Add Cond Point_Fix_Temperature   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Temp = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!    Temperature Field     !!!!!!!!!!!!!!!
*set Cond  Temperature_Field        *nodes *or(1,int) *or(2,int)
*add Cond Surface_Temperature_Field *nodes *or(1,int) *or(2,int)
*add Cond Line_Temperature_Field    *nodes *or(1,int) *or(2,int)
*add Cond Point_Temperature_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : TTemp %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!  Conditional Temperature   !!!!!!!!!!!!!!
*set Cond  Conditional_Temperature        *nodes
*add Cond Surface_Conditional_Temperature *nodes
*add Cond Line_Conditional_Temperature    *nodes
*add Cond Point_Conditional_Temperature   *nodes 
*loop nodes *OnlyInCond
  Node *NodesNum : CondTemp;
*end
!!!!!!!!!!!!!!!    Fix Concentration     !!!!!!!!!!!!!!!
*set Cond Fix_Concentration         *nodes
*add Cond Surface_Fix_Concentration *nodes		
*Add Cond Line_Fix_Concentration    *nodes	
*Add Cond Point_Fix_Concentration   *nodes
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, Conc = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!   Concentration Field    !!!!!!!!!!!!!!!
*set Cond  Concentration_Field        *nodes *or(2,int) *or(3,int)
*add Cond Surface_Concentration_Field *nodes *or(2,int) *or(3,int)
*add Cond Line_Concentration_Field    *nodes *or(2,int) *or(3,int)
*add Cond Point_Concentration_Field   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, TConc %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!! Conditional Concentration  !!!!!!!!!!!!!!
*set Cond  Conditional_Concentration        *nodes
*add Cond Surface_Conditional_Concentration *nodes
*add Cond Line_Conditional_Concentration    *nodes
*add Cond Point_Conditional_Concentration   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondConc;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!     Fix PhiVariable      !!!!!!!!!!!!!!!
*set Cond Fix_Variable         *nodes
*add Cond Surface_Fix_Variable *nodes		
*Add Cond Line_Fix_Variable    *nodes	
*Add Cond Point_Fix_Variable   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, Phi = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!    PhiVariable Field     !!!!!!!!!!!!!!!
*set Cond  Variable_Field        *nodes *or(2,int) *or(3,int)
*add Cond Surface_Variable_Field *nodes *or(2,int) *or(3,int)
*add Cond Line_Variable_Field    *nodes *or(2,int) *or(3,int)
*add Cond Point_Variable_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, TPhi %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!!     Conditional Phi        !!!!!!!!!!!!!!
*set Cond  Conditional_Variable        *nodes
*add Cond Surface_Conditional_Variable *nodes
*add Cond Line_Conditional_Variable    *nodes
*add Cond Point_Conditional_Variable   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondPhi;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!      Fix Turbulence      !!!!!!!!!!!!!!!
*set Cond  Fix_Turbulence         *nodes *or(1,int)
*add Cond Surface_Fix_Turbulence *nodes *or(1,int)
*add Cond Line_Fix_Turbulence    *nodes *or(1,int)
*add Cond Point_Fix_Turbulence   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Turb %i;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!! Fix_Mesh_Deformation_Condition !!!!!!!!!!!!
*set Cond Fix_Mesh_Deformation         *nodes
*add Cond Surface_Fix_Mesh_Deformation *nodes
*Add Cond Line_Fix_Mesh_Deformation    *nodes
*Add Cond Point_Fix_Mesh_Deformation   *nodes
*loop nodes *OnlyInCond
    Node *NodesNum : DMesh  *cond(1);
*end
   EndBoundary;
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*if(strcmp(gendata(Solve_Solid),"Yes")==0) 
 SolidDefinition: Integration_Scheme = *gendata(STime_Integration)*\
*if(strcmp(gendata(Solve_FluidFlow_in_Solid),"Yes")==0) 
, Solve_Stokes, MinTauV_Ratio = *gendata(StabTauV_MinRatio), MinTauP_Ratio = *gendata(StabTauP_MinRatio), Velocity_Smoothing = *gendata(Velocity_Control_Level),  NS_AdvecStab_*gendata(Velocity_Advect_Stabilisation), NS_PressStab_*gendata(Pressure_Stabilisation), TB_AdvecStab_*gendata(Turbulence_Advect_Stabilisation), SteadyNorm = *gendata(FLUIDSOLVER_Steady_State_Norm), Control_Increment = *gendata(FLUIDSOLVER_Increment_Control)*\
*if(strcmp(gendata(Use_Total_Pressure),"Yes")==0) 
, Total_Pressure *\
*endif 
*endif 
*if(strcmp(gendata(Solve_Temperature_in_Solid),"Yes")==0)
, Solve_Temperature, Temperature_Smoothing = *gendata(Temperature_Control_Level), TM_AdvecStab_*gendata(Temperature_Advect_Stabilisation),*\
*endif
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0)
, Solve_PhiProblems*\
*endif
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0)
, Solve_Concentration*\
*endif
*if(strcmp(gendata(Solve_MeshDeformation_in_Solid),"Yes")==0)
, Solve_Mesh_Deformation, MeshDeformationType = *gendata(Solid_Mesh_Deformation)*\
*endif
;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*7+1
 NewSpecDefinition: Index = *iphi, Name = "*gendata(Species_Names,*iphi)", MaxLimit = *gendata(Advect_Solverdata,*coun), MinLimit = *gendata(Advect_Solverdata,*operation(coun+1)), Convergence_Norm = *gendata(Advect_Solverdata,*operation(coun+2)), InnerIterations = *gendata(Advect_Solverdata,*operation(coun+3)), AdvecStab_*gendata(Advect_Solverdata,*operation(coun+4)), Phi_Smoothing = *gendata(Advect_Solverdata,*operation(coun+5)), Boundary_Units = [*gendata(Advect_Solverdata,*operation(coun+6))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
*set var coun = (iphi-1)*7+1
 NewPhiDefinition: Index = *iphi, Name = "*gendata(URVariables_Names,*iphi)", MaxLimit = *gendata(URSolver_Solverdata,*coun), MinLimit = *gendata(URSolver_Solverdata,*operation(coun+1)), Convergence_Norm = *gendata(URSolver_Solverdata,*operation(coun+2)), InnerIterations = *gendata(URSolver_Solverdata,*operation(coun+3)), AdvecStab_*gendata(URSolver_Solverdata,*operation(coun+4)), Phi_Smoothing = *gendata(URSolver_Solverdata,*operation(coun+5)), Boundary_Units = [*gendata(URSolver_Solverdata,*operation(coun+6))];
*end
*endif 
InitialDataFunctions;
    Function VelocityX = "*gendata(Initial_VelocityX);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(Initial_VelocityY);" *gendata(Boundary_Velocity_Units);
    Function Pressure = "*gendata(Initial_Pressure);"  *gendata(Boundary_Pressure_Units);
    Function EddyKineticEnergy = "*gendata(Initial_EddyKEner);" *gendata(Boundary_Kenr_Units);
    Function EddyLength = "*gendata(Initial_EddyLength);" *gendata(Boundary_Elen_Units);
    Function Temperature = "*gendata(Initial_Temperature);" *gendata(Boundary_Temperature_Units);
EndInitialDataFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesInitialData *iphi = "*gendata(Advect_Initdata,*operation(2*(iphi-1)+1));" [*gendata(Advect_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
     VariableInitialData *iphi = "*gendata(URSolver_Initdata,*operation(2*(iphi-1)+1));" [*gendata(URSolver_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
ConditionalFunctions;
    Function VelocityX = "*gendata(VelocityX_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function VelocityY = "*gendata(VelocityY_FuncCond);" *gendata(Boundary_Velocity_Units);
    Function Pressure  = "*gendata(Pressure_FuncCond);"  *gendata(Boundary_Pressure_Units);
EndConditionalFunctions;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
*set var phis = gendata(Species_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    SpeciesConditional *iphi = "*gendata(Advect_Initdata,*operation(2*(iphi-1)+2));" [*gendata(Advect_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
*set var phis = gendata(URVariables_Names,int)
*for(iphi=1;iphi<=phis;iphi=iphi+1)
    VariableConditional *iphi = "*gendata(URSolver_Initdata,*operation(2*(iphi-1)+2));" [*gendata(URSolver_Solverdata,*operation((iphi-1)*7+7))];
*end
*endif 
*if(strcmp(gendata(Solve_MeshDeformation_in_Solid),"Yes")==0) 
 MeshDeformationFunctions: 
    MeshDeformationX = "*gendata(Solid_Deformation_X);" *gendata(Geometry_Units),
    MeshDeformationY = "*gendata(Solid_Deformation_Y);" *gendata(Geometry_Units),
    MeshDeformationZ = "*gendata(Solid_Deformation_Z);" *gendata(Geometry_Units);
*endif 
*if(strcmp(gendata(UserIntegralS1),"0")!=0 || strcmp(gendata(UserIntegralS2),"0")!=0 || strcmp(gendata(UserIntegralS3),"0")!=0) 
IntegralFunctions:
    Integral1 = "*gendata(UserIntegralS1);" [],
    Integral2 = "*gendata(UserIntegralS2);" [],
    Integral3 = "*gendata(UserIntegralS3);" [];
*endif 
*if(gendata(UserDefinedS1,int)!=0 || gendata(UserDefinedS2,int)!=0 || gendata(UserDefinedS3,int)!=0) 
 CustomisedResultsFunctions;
*if(gendata(UserDefinedS1,int)!=0)
    CustomRes = "*gendata(SolidFunction1);", Name = "*gendata(SolidFunction1_Name)";
*endif
*if(gendata(UserDefinedS2,int)!=0)
    CustomRes = "*gendata(SolidFunction2);", Name = "*gendata(SolidFunction2_Name)";
*endif
*if(gendata(UserDefinedS3,int)!=0)
    CustomRes = "*gendata(SolidFunction3);", Name = "*gendata(SolidFunction3_Name)";
*endif
 EndCustomisedResultsFunctions;
*endif 
 NonSymmetric "Solid 1st Solver": Solver = *gendata(SSolver_Symmetric), Tolerance = *gendata(S_Tolerance), Max_Iter = *gendata(S_MaxIter), Preconditioner = *gendata(S_Preconditioner);
 Symmetric "Solid 2nd Solver": Solver = *gendata(SSolver_Symmetric), Tolerance = *gendata(S_Tolerance), Max_Iter = *gendata(S_MaxIter), Preconditioner = *gendata(S_Preconditioner);
  ElmSets;
*set var MatNumber = 1
*loop Materials 
*if(strcmp(MatProp(Type),"Solid")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==2 || ElemType==3)
*set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
Set *MatNumber:  Type = Solid, Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode;
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
        SpeciesProperties;
*set var spes = Matprop(Species_Properties,INT)/6
*set var coun = 1
*set var ucoun = 1
*for(im=1;im<=spes;im=im+1) 
           F1 = "*Matprop(Species_Properties,*coun);" [],*\
*set var coun=coun+1
 F2xx = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\
*set var coun=coun+1
 F2xy = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\
*set var coun=coun+1
 F2yy = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F3 = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F4 = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*ucoun); 
*set var coun=coun+1
*set var ucoun=ucoun+1
*end 
        EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
        VariablesProperties;
*set var phis = Matprop(Variables_Properties,INT)/6
*set var coun = 1
*set var ucoun = 1
*for(im=1;im<=phis;im=im+1) 
           F1 = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F2xx = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
 F2xy = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
 F2yy = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F3 = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun),*\
*set var coun=coun+1
*set var ucoun=ucoun+1
 F4 = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*ucoun);
*set var coun=coun+1
*set var ucoun=ucoun+1
*end 
        EndVariablesProperties;
*endif 
                  PhysicalPropertiesFunctions;  ! Data fields given as functions
                    Function AccelerationX = "*MatProp(AccOX_Field);"  *MatProp(Acceleration_Units);
                    Function AccelerationY = "*MatProp(AccOY_Field);"  *MatProp(Acceleration_Units);
                    Function HeatSource = "*MatProp(Heat_Source_Field);" *MatProp(Heat_Source_Units);
                    Function Viscosity = "*MatProp(Fluid_Viscosity);" *MatProp(Fluid_Viscosity_Units);
                    Function Density = "*MatProp(Fluid_Density);" *MatProp(Fluid_Density_Units);
                    Function SolidDensity = "*MatProp(Density);" *MatProp(Density_Units);
                    Function SpecificHeat = "*MatProp(Specific_Heat_C);"  *MatProp(C_Units);
                    Function ConductivityXX = "*MatProp(Thermal_Conductivity_k11);" *MatProp(k_Units); 
                    Function ConductivityXY = "*MatProp(Thermal_Conductivity_k12);" *MatProp(k_Units); 
                    Function ConductivityYY = "*MatProp(Thermal_Conductivity_k22);" *MatProp(k_Units); 
                    Function Floatability = "*MatProp(Floatability);" [];                                 
                    Function HeatSourceReaction = "*MatProp(Heat_Reaction_Field);" *MatProp(Heat_Reaction_Units); 
                  EndPhysicalPropertiesFunctions;
                Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif 
*end 
*if(WriteTitle==0) 
                      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"Solid_Body")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1)
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif
*if(ElemType==1)
*set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = WBody,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,
                      Center_of_Gravity: GOX = "*MatProp(Centre_of_Gravity_X);" *gendata(Geometry_Units), GOY = "*MatProp(Centre_of_Gravity_Y);" *gendata(Geometry_Units), GOZ = "0.0;" *gendata(Geometry_Units), Mass = *MatProp(Body_Mass) *MatProp(Body_Mass_Units),
                      Radii_of_Gyration = 1.0 1.0 *MatProp(Radius_of_Gyration_Z) *MatProp(Radii_of_Gyration_Units),
                      KD_Units = 1 *MatProp(KD_Units), KR_Units = 1 *MatProp(KR_Units), Springs =*\
*for(im=1;im<=Matprop(Springs,INT);im=im+1) 
 *Matprop(Springs,*im)*\
*end 
                              *\
*if((strcmp(MatProp(Displacement_OX),"Yes")==0)) 
Displacement_OX, *\
*endif
*if((strcmp(MatProp(Displacement_OY),"Yes")==0)) 
Displacement_OY, *\
*endif
*if((strcmp(MatProp(Rotation_OZ),"Yes")==0)) 
Rotation_OZ, *\
*endif
*if(MatProp(Sharp_Angle,real)>0)
, Sharp_Angle = *MatProp(Sharp_Angle) *MatProp(Angle_Units) *\
*endif
*if(MatProp(Fix_Angle,real)>0)
, Line_Fix_Angle = *MatProp(Fix_Angle) *MatProp(Angle_Units) *\
*endif
*if((strcmp(MatProp(BoundType),"RoughWall")==0))
, RoughWall, Delta = *MatProp(Delta) *MatProp(Delta_Units), Roughness = *MatProp(Roughness) *MatProp(Roughness_Units) *\ 
*elseif((strcmp(MatProp(BoundType),"DeltaWall")==0))
, DeltaWall, Delta = *MatProp(Delta) *MatProp(Delta_Units) *\
*elseif((strcmp(MatProp(BoundType),"YplusWall")==0))
, YplusWall, Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"Cw_U2Wall")==0))
, Cw_U2Wall, Cw = *MatProp(Cw), *\
*elseif((strcmp(MatProp(BoundType),"ITTC_Wall")==0))
, ITTC_Wall, Cw = *MatProp(Cw), Yplus = *MatProp(Yplus) *\
*elseif((strcmp(MatProp(BoundType),"User_Wall")==0))
, User_Wall, User_U_t = "*MatProp(FTau_Field);", User_Ken = "*MatProp(Kenr_Field);", User_Len = "*MatProp(ELen_Field);" *\
*elseif((strcmp(MatProp(BoundType),"InvisWall")==0))
, InvisWall *\
*elseif((strcmp(MatProp(BoundType),"V_fixWall")==0))
, V_fixWall *\
*elseif((strcmp(MatProp(BoundType),"None_Wall")==0))
, None_Wall *\
*elseif((strcmp(MatProp(BoundType),"OutFBound")==0))
, OutFBound *\
*endif
; 
*if(strcmp(gendata(Solve_SpeciesConcentration_in_Solid),"Yes")==0) 
        SpeciesProperties;
*set var spes = Matprop(Species_Properties,INT)/2
*set var coun = 1
*for(im=1;im<=spes;im=im+1) 
           Flux_Spc = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*coun),*\
*set var coun=coun+1
 Reac_Spc = "*Matprop(Species_Properties,*coun);" *Matprop(Spc_Units,*coun);
*set var coun=coun+1
*end 
        EndSpeciesProperties;
*endif 
*if(strcmp(gendata(Solve_PhiProblems_in_Solid),"Yes")==0) 
        VariablesProperties;
*set var phis = Matprop(Variables_Properties,INT)/2
*set var coun = 1
*for(im=1;im<=phis;im=im+1) 
           Flux_Phi = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*coun),*\
*set var coun=coun+1
 Reac_Phi = "*Matprop(Variables_Properties,*coun);" *Matprop(URV_Units,*coun);
*set var coun=coun+1
*end 
        EndVariablesProperties;
*endif 
                      PhysicalPropertiesFunctions;  ! Data fields given as functions
                       Function HeatFlux = "*MatProp(Heat_Flux);" *MatProp(Heat_Flux_Units);
                       Function HeatFluxReaction = "*MatProp(Reactive_Heat_Flux);" *MatProp(Reactive_Heat_Flux_Units);
                     EndPhysicalPropertiesFunctions;
                      Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif 
		*ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif 
*end 
*if(WriteTitle==0) 
                      end elements;
*endif 
*endif 
*end 
*elseif(strcmp(MatProp(Type),"FreeS")==0) 
*for(ElemType=1;ElemType<=NumTypes;ElemType=ElemType+1) 
*if(ElemType==1) 
*set Elems(Linear)
*elseif(ElemType==2)
*set Elems(Triangle)
*elseif(ElemType==3)
*set Elems(Quadrilateral)
*elseif(ElemType==4)
*set Elems(Tetrahedra)
*elseif(ElemType==5)
*set Elems(Hexahedra)
*elseif(ElemType==6)
*set Elems(Prisma)
*endif 
*if(ElemType==1)
set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems 
*if(ElemsMat(int)==MatNum(int)) 
*if(WriteTitle==1) 
    Set *MatNumber:   Type = FreeS,  Name = "*MatProp(0)", ElmType = *ElemsTypeName, NNode = *ElemsNnode,

                       Charact_Length = *MatProp(Length) *MatProp(Length_units), Damping_length = *MatProp(Damping_length), 
                       Damping_factor = *MatProp(Damping_factor), Time_factor = *MatProp(Time_factor), Time_ratio = *MatProp(Step_factor),
                       MinTau_Ratio = *MatProp(StabTau_MinRatio), Integration_Scheme = *MatProp(Time_Integration), Beta_Smoothing = *MatProp(Control_Level)*\
                       MaxValue = *MatProp(Maximum_Value), MinValue = *MatProp(Minimum_Value), FS_AdvecStab_*MatProp(Advect_Stabilisation)*\
*if(strcmp(MatProp(CrossWind_Diffusion),"On")==0) 
, CrossWind_Diffusion*\
*endif 
;
               Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif 
 *ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif 
*end 
*if(WriteTitle==0) 
                      end elements;
*endif 
*endif 
*end 
*endif 
*end 
  EndElmSets;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  Boundary;
   BoundaryUnits: Length=*gendata(Boundary_Length_units), 
                  Time  =*gendata(Boundary_Time_units), 
                  Mass  =*gendata(Boundary_Mass_units);
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Coordinate Planes Symmetry
*if((strcmp(gendata(Xplane_Symmetry_in_Fluid),"Yes")==0))
   Xplane_VSym *gendata(Xplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
*if((strcmp(gendata(Yplane_Symmetry_in_Fluid),"Yes")==0))
   Yplane_VSym *gendata(Yplane_Symmetry_Position) *gendata(Geometry_Units);
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!  Fix Pressure Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Pressure         *nodes
*add Cond Surface_Fix_Pressure *nodes	
*add Cond Line_Fix_Pressure    *nodes	
*add Cond Point_Fix_Pressure   *nodes
*loop nodes *OnlyInCond
*format "    Node %i :Pres = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Direction  !!!!!!!!!!!!!!!
*set Cond Line_Fix_Velocity_Direction *nodes 
*add Cond Point_Fix_Velocity_Direction *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(1) *LocalAxesDef(4) 0.00000;
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : LVel *LocalAxesDef(2) *LocalAxesDef(5) 0.00000;
*else
 Node *NodesNum : LVel *LocalAxesDef(3) *LocalAxesDef(6) 0.00000;
*endif
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Condition  !!!!!!!!!!!!!!!
*set Cond Fix_Velocity         *nodes *or(1,int) *or(3,int)
*add Cond Surface_Fix_Velocity *nodes *or(1,int) *or(3,int)
*Add Cond Line_Fix_Velocity    *nodes *or(1,int) *or(3,int)
*Add Cond Point_Fix_Velocity   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Velc  %.5lf %.5lf 0.00000 , Fix %i %i 1;"
  *NodesNum *cond(2) *cond(4) *cond(1) *cond(3)
*end
!!!!!!!!!!!!!!!  Fix_Velocity_Component  !!!!!!!!!!!!!!!
*set Cond Line_Fix_Velocity_Component *nodes 
*add Cond Point_Fix_Velocity_Component *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(1) *LocalAxesDef(4) 0.00000, lVl = *cond(3);
*elseif(strcmp(cond(2),"Y_Axis")==0)
 Node *NodesNum : Norm *LocalAxesDef(2) *LocalAxesDef(5) 0.00000, lVl = *cond(3);
*else
 Node *NodesNum : Norm *LocalAxesDef(3) *LocalAxesDef(6) 0.00000, lVl = *cond(3);
*endif
*end
!!!!!!!!!!!!!!!     Fix_Null_Gradient    !!!!!!!!!!!!!!!
*set Cond Line_Fix_Null_Gradient *nodes 
*add Cond Point_Fix_Null_Gradient *nodes 
*loop nodes *OnlyInCond
*if(strcmp(cond(2),"X_Axis")==0)
*format "    Node %i : DSymm %lf %* %* %lf 0.00000 %* %* %* %* %*"
*elseif(strcmp(cond(2),"Y_Axis")==0)
*format "    Node %i : DSymm %* %lf %* %* %lf 0.00000 %* %* %* %*"
*else
*format "    Node %i : DSymm %* %* %lf %* %* %lf 0.00000 %* %* %*"
*endif
  *NodesNum  *LocalAxesDef;
*end
!!!!!!!!!!!!!!!     Remove_Velocity      !!!!!!!!!!!!!!!
*set Cond Point_Remove_Velocity_Conditions *nodes
*loop nodes *OnlyInCond
*if(fabs(cond(real,1)))
*format "    Node %i, Delt;"
  *NodesNum
*endif
*end
!!!!!!!!!!!!!!!     Velocity Field       !!!!!!!!!!!!!!!
*set Cond Velocity_Field          *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int)
*add Cond Surface_Velocity_Field  *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int)
*Add Cond Line_Velocity_Field     *nodes *or(1,int) *or(2,int) *or(3,int) *or(4,int)
*Add Cond Point_Velocity_Field    *nodes
*loop nodes *OnlyInCond
*format "    Node %i : TVel %i %i 1 %i %i 0;"
  *NodesNum *cond(1) *cond(2) *cond(3) *cond(4)
*end
!!!!!!!!!!!!!!!   Conditional Velocity   !!!!!!!!!!!!!!!
*set Cond Conditional_Velocity          *nodes
*add Cond Surface_Conditional_Velocity  *nodes
*Add Cond Line_Conditional_Velocity     *nodes
*Add Cond Point_Conditional_Velocity    *nodes
*loop nodes *OnlyInCond
 Node *NodesNum : CondVel;
*end
!!!!!!!!!!!!!!!     Pressure Field       !!!!!!!!!!!!!!!
*set Cond Pressure_Field         *nodes *or(1,int) *or(2,int)
*add Cond Surface_Pressure_Field *nodes *or(1,int) *or(2,int)
*Add Cond Line_Pressure_Field    *nodes *or(1,int) *or(2,int)
*Add Cond Point_Pressure_Field   *nodes
*loop nodes *OnlyInCond
*format " Node %i : TPres %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!  Conditional    !!!!!!!!!!!!!!
*set Cond  Conditional_Pressure        *nodes
*add Cond Surface_Conditional_Pressure *nodes
*add Cond Line_Conditional_Pressure    *nodes
*add Cond Point_Conditional_Pressure   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondPres;
*end
!!!!!!!!!!!!!!!     Fix Temperature      !!!!!!!!!!!!!!!
*set Cond Fix_Temperature         *nodes
*add Cond Surface_Fix_Temperature *nodes		
*Add Cond Line_Fix_Temperature    *nodes	
*Add Cond Point_Fix_Temperature   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Temp = %lf"
  *Nodesnum  *cond(1);
*end
!!!!!!!!!!!!!!!    Temperature Field     !!!!!!!!!!!!!!!
*set Cond  Temperature_Field        *nodes *or(1,int) *or(2,int)
*add Cond Surface_Temperature_Field *nodes *or(1,int) *or(2,int)
*add Cond Line_Temperature_Field    *nodes *or(1,int) *or(2,int)
*add Cond Point_Temperature_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : TTemp %i %i;"
  *NodesNum *cond(1) *cond(2)
*end
!!!!!!!!!!!!!!  Conditional Temperature   !!!!!!!!!!!!!!
*set Cond  Conditional_Temperature        *nodes
*add Cond Surface_Conditional_Temperature *nodes
*add Cond Line_Conditional_Temperature    *nodes
*add Cond Point_Conditional_Temperature   *nodes 
*loop nodes *OnlyInCond
 Node *NodesNum : CondTemp;
*end
!!!!!!!!!!!!!!!    Fix Concentration     !!!!!!!!!!!!!!!
*set Cond Fix_Concentration         *nodes
*add Cond Surface_Fix_Concentration *nodes		
*Add Cond Line_Fix_Concentration    *nodes	
*Add Cond Point_Fix_Concentration   *nodes
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, Conc = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!   Concentration Field    !!!!!!!!!!!!!!!
*set Cond  Concentration_Field        *nodes *or(2,int) *or(3,int)
*add Cond Surface_Concentration_Field *nodes *or(2,int) *or(3,int)
*add Cond Line_Concentration_Field    *nodes *or(2,int) *or(3,int)
*add Cond Point_Concentration_Field   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, TConc %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!! Conditional Concentration  !!!!!!!!!!!!!!
*set Cond  Conditional_Concentration        *nodes
*add Cond Surface_Conditional_Concentration *nodes
*add Cond Line_Conditional_Concentration    *nodes
*add Cond Point_Conditional_Concentration   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondConc;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!     Fix PhiVariable      !!!!!!!!!!!!!!!
*set Cond Fix_Variable         *nodes
*add Cond Surface_Fix_Variable *nodes		
*Add Cond Line_Fix_Variable    *nodes	
*Add Cond Point_Fix_Variable   *nodes
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, Phi = %lf"
  *Nodesnum  *cond(1) *cond(2);
*end
!!!!!!!!!!!!!!!    PhiVariable Field     !!!!!!!!!!!!!!!
*set Cond  Variable_Field        *nodes *or(2,int) *or(3,int)
*add Cond Surface_Variable_Field *nodes *or(2,int) *or(3,int)
*add Cond Line_Variable_Field    *nodes *or(2,int) *or(3,int)
*add Cond Point_Variable_Field   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Index = %i, TPhi %i %i;"
  *NodesNum *cond(1) *cond(2) *cond(3)
*end
!!!!!!!!!!!!!!     Conditional Phi        !!!!!!!!!!!!!!
*set Cond  Conditional_Variable        *nodes
*add Cond Surface_Conditional_Variable *nodes
*add Cond Line_Conditional_Variable    *nodes
*add Cond Point_Conditional_Variable   *nodes 
*loop nodes *OnlyInCond
*format " Node %i : Index = %i, CondPhi;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!!!!!      Fix Turbulence      !!!!!!!!!!!!!!!
*set Cond  Fix_Turbulence         *nodes *or(1,int)
*add Cond Surface_Fix_Turbulence *nodes *or(1,int)
*add Cond Line_Fix_Turbulence    *nodes *or(1,int)
*add Cond Point_Fix_Turbulence   *nodes 
*loop nodes *OnlyInCond
*format "    Node %i : Turb %i;"
  *NodesNum *cond(1)
*end
!!!!!!!!!!!! Fix_Mesh_Deformation_Condition !!!!!!!!!!!!
*set Cond Fix_Mesh_Deformation         *nodes
*add Cond Surface_Fix_Mesh_Deformation *nodes
*Add Cond Line_Fix_Mesh_Deformation    *nodes
*Add Cond Point_Fix_Mesh_Deformation   *nodes
*loop nodes *OnlyInCond
    Node *NodesNum : DMesh  *cond(1);
*end
   EndBoundary;
*endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 TotalDefinition: VC_Inner_Iterations = *gendata(Velocity_Inner_Iterations), PR_Inner_Iterations = *gendata(Pressure_Inner_Iterations), TB_Inner_Iterations = *gendata(Turbulence_Inner_Iterations), TM_Inner_Iterations = *gendata(Temperature_Inner_Iterations);
ToleranceData: VelConvergenceNorm = *gendata(Velocity_Norm), PreConvergenceNorm = *gendata(Pressure_Norm), 
               TemConvergenceNorm = *gendata(Temperature_Norm), BetConvergenceNorm = *gendata(WaveElevation_Norm);
  ElmSets;
*set var MatNumber = 1
*loop Materials
*if(strcmp(MatProp(Type),"Interf")==0)
*set Elems(Linear)
*set var WriteTitle = 1
*set var ElemNumber = 1
*loop Elems
*if(ElemsMat(int)==MatNum(int))
*if(WriteTitle==1)
    Set *MatNumber:   Type = Interface,  Name = "IL_*MatProp(0)",  ElmType = Linear, NNode = *nnodelin*\
*if(strcmp(Matprop(Switch),"Off")==0)
;
*else
, Rest_Tem = "*Matprop(Thermal_Resistance);" *Matprop(Thermal_Reactive_Units);
*endif
        SpeciesProperties;
*set var spes = Matprop(Species_Properties,INT)/2
*set var coun = 1
*for(im=1;im<=spes;im=im+1)
           Rest_Spc = "*Matprop(Species_Properties,*coun);" *Matprop(Resistance_Spc_Units,*coun)*\
*set var coun=coun+1
*if(strcmp(Matprop(Species_Properties,*coun),"Off")==0)
, Off;
*else
;
*endif
*set var coun=coun+1
*end
        EndSpeciesProperties;
        VariablesProperties;
*set var phis = Matprop(Variables_Properties,INT)/2
*set var coun = 1
*for(im=1;im<=phis;im=im+1)
           Rest_Phi = "*Matprop(Variables_Properties,*coun);" *Matprop(Resistance_Phi_Units,*coun)*\
*set var coun=coun+1
*if(strcmp(Matprop(Variables_Properties,*coun),"Off")==0)
, Off;
*else
;
*endif
*set var coun=coun+1
*end
        EndVariablesProperties;
                      Elements;
*set var MatNumber = MatNumber + 1
*set var WriteTitle = 0
*endif
		*ElemNumber *elemsConec
*set var ElemNumber = ElemNumber + 1
*endif
*end
*if(WriteTitle==0)
                      end elements;
*endif
*endif
*end
  EndElmSets;
EndProblem;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


