# tdyn3d.tcl  -*- TCL -*-
#---------------------------------------------------------------------------
#This file is written in TCL lenguage 
#For more information about TCL look at: http://www.sunlabs.com/research/tcl/
#
#At least two procs must be in this file:
#
#    InitGIDProject dir - Will be called whenever a project is begun to be used.
#           where dir is the project's directory
#    EndGIDProject - Will be called whenever a project ends to be used.
#
#For more information about GID internals, check the program scripts.
#---------------------------------------------------------------------------

proc MyPreBitmaps { dir { type "DEFAULT INSIDELEFT"} } {
    global MyPreBitmapsNames MyPreBitmapsCommands MyPreBitmapsHelp ProgramName ProblemTypePriv

    set MyPreBitmapsNames(0) ""
    set MyPreBitmapsCommands(0) ""
    set MyPreBitmapsHelp(0) ""
    if { [IsVarOnTdynDefaults show_ransol 1] } { 
	lappend MyPreBitmapsNames(0) "images/compbox.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- OpenTdynWizardWindow]
	lappend MyPreBitmapsHelp(0) "Start Tdyn Wizard"

	lappend MyPreBitmapsNames(0) "---" 
	lappend MyPreBitmapsCommands(0) ""
	lappend MyPreBitmapsHelp(0) ""

	lappend MyPreBitmapsNames(0) "images/fluidconstraints.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenConditions "RANSOL"]
	lappend MyPreBitmapsHelp(0) "Open fluid conditions window"
    }
    if { [IsVarOnTdynDefaults show_heatrans 1] } { 
	lappend MyPreBitmapsNames(0) "images/fire.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenConditions "HEATRANS"]
	lappend MyPreBitmapsHelp(0) "Open temperature conditions window"
    }
    if { [IsVarOnTdynDefaults show_advect 1] } { 
	lappend MyPreBitmapsNames(0) "images/advect.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenConditions "ADVECT"]
	lappend MyPreBitmapsHelp(0) "Open species advection conditions window"
    }
    if { [IsVarOnTdynDefaults show_ursolver 1] } { 
	lappend MyPreBitmapsNames(0) "images/ursolver.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenConditions "URSOLVER"]
	lappend MyPreBitmapsHelp(0) "Open ursolver conditions window"
    } 
    if { [IsVarOnTdynDefaults show_naval 1] } { 
	lappend MyPreBitmapsNames(0) "images/wave.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenConditions "NAVAL"]
	lappend MyPreBitmapsHelp(0) "Open naval conditions window"
    }
    if { [IsVarOnTdynDefaults show_alemesh 1] } { 
	lappend MyPreBitmapsNames(0) "images/alemesh.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenConditions "ALEMESH"]
	lappend MyPreBitmapsHelp(0) "Open mesh deformation conditions window"
    }

    lappend MyPreBitmapsNames(0) "---" 
    lappend MyPreBitmapsCommands(0) ""
    lappend MyPreBitmapsHelp(0) ""

    if { [IsVarOnTdynDefaults show_fluid 1] } { 
	lappend MyPreBitmapsNames(0) "images/drop.gif" 
#        lappend MyPreBitmapsCommands(0) [list -np- GidOpenMaterials "MATERIALS_(FLUID)"]
	lappend MyPreBitmapsCommands(0) [list -np- materials::init "MATERIALS_(FLUID)"]
	lappend MyPreBitmapsHelp(0) "Open fluid materials window"
    }
    if { [IsVarOnTdynDefaults show_solid 1] } { 
	lappend MyPreBitmapsNames(0) "images/column.gif" 
#        lappend MyPreBitmapsCommands(0) [list -np- GidOpenMaterials "MATERIALS_(SOLID)"]
	lappend MyPreBitmapsCommands(0) [list -np- materials::init "MATERIALS_(SOLID)"]
	lappend MyPreBitmapsHelp(0) "Open solid materials window"
    }
    if { [IsVarOnTdynDefaults show_fluid 1] } { 
	lappend MyPreBitmapsNames(0) "images/fboundaries.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenMaterials "BOUNDARIES_(FLUID)"]
	lappend MyPreBitmapsHelp(0) "Open fluid boundaries window"
    }
    if { [IsVarOnTdynDefaults show_solid 1] } { 
	lappend MyPreBitmapsNames(0) "images/sboundaries.gif" 
	lappend MyPreBitmapsCommands(0) [list -np- GidOpenMaterials "BOUNDARIES_(SOLID)"]
	lappend MyPreBitmapsHelp(0) "Open solid boundaries window"
    }
    
    lappend MyPreBitmapsNames(0) "---" 
    lappend MyPreBitmapsCommands(0) ""
    lappend MyPreBitmapsHelp(0) ""

    lappend MyPreBitmapsNames(0) "images/initial.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- initdatwin::init .gid "all" ""]
    lappend MyPreBitmapsHelp(0) "Open initial and conditional data window"

    lappend MyPreBitmapsNames(0) "---" 
    lappend MyPreBitmapsCommands(0) ""
    lappend MyPreBitmapsHelp(0) ""

    lappend MyPreBitmapsNames(0) "images/prdata.gif" 
#    lappend MyPreBitmapsCommands(0) [list -np- GidOpenProblemData "PROBLEM"]
    lappend MyPreBitmapsCommands(0) [list -np- prbdatwin::init .gid "all" ""]
    lappend MyPreBitmapsHelp(0) "Open general data window"

    lappend MyPreBitmapsNames(0) "images/solvers.gif" 
#    lappend MyPreBitmapsCommands(0) [list -np- GidOpenProblemData "SOLVER"]
    lappend MyPreBitmapsCommands(0) [list -np- solvdatwin::init .gid "all" ""]
    lappend MyPreBitmapsHelp(0) "Open modules and solvers data window"

    lappend MyPreBitmapsNames(0) "images/units.gif" 
#    lappend MyPreBitmapsCommands(0) [list -np- GidOpenProblemData "UNITS"]
    lappend MyPreBitmapsCommands(0) [list -np- unitdatwin::init .gid "all" ""]
    lappend MyPreBitmapsHelp(0) "Open units window"

    lappend MyPreBitmapsNames(0) "---" 
    lappend MyPreBitmapsCommands(0) ""
    lappend MyPreBitmapsHelp(0) ""

    lappend MyPreBitmapsNames(0) "images/mesh.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- MeshingWindow]
    lappend MyPreBitmapsHelp(0) "Start meshing window"

    lappend MyPreBitmapsNames(0) "---" 
    lappend MyPreBitmapsCommands(0) ""
    lappend MyPreBitmapsHelp(0) ""

    lappend MyPreBitmapsNames(0) "images/calc.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- StartCalculate]
    lappend MyPreBitmapsHelp(0) "Launch calculation process"

    lappend MyPreBitmapsNames(0) "images/info.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- PWViewOutput]
    lappend MyPreBitmapsHelp(0) "View process info"

    lappend MyPreBitmapsNames(0) "images/loads.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- OpenForcesWindow]
    lappend MyPreBitmapsHelp(0) "View forces on bodies"

    lappend MyPreBitmapsNames(0) "images/graph.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- ForcesData]
    lappend MyPreBitmapsHelp(0) "Forces on bodies graphs"

    lappend MyPreBitmapsNames(0) "images/stop.gif" 
    lappend MyPreBitmapsCommands(0) [list Utilities CancelProcess]
    lappend MyPreBitmapsHelp(0) "Cancel calculation process"

    lappend MyPreBitmapsNames(0) "images/3d.gif" 
    lappend MyPreBitmapsCommands(0) [list -np- Splash $dir 0]
    lappend MyPreBitmapsHelp(0) "Tdyn 3D Interface"

    # prefix values:
    #          Pre        Only active in the preprocessor
    #          Post       Only active in the postprocessor
    #          PrePost    Active Always
    set prefix Pre
    set ProblemTypePriv(pretoolbarwin) [CreateOtherBitmaps MyPreBar "Tdyn pre toolbar" \
	    MyPreBitmapsNames MyPreBitmapsCommands \
	    MyPreBitmapsHelp $dir "MyPreBitmaps [list $dir]" $type $prefix]
    AddNewToolbar "$ProgramName prebar" ${prefix}MyBarWindowGeom "MyPreBitmaps [list $dir]"
}

proc MyPostBitmaps { dir { type "DEFAULT INSIDELEFT"} } {
    global MyPostBitmapsNames MyPostBitmapsCommands MyPostBitmapsHelp ProgramName ProblemTypePriv

    set MyPostBitmapsNames(0) "images/info.gif images/loads.gif images/graph.gif images/3d.gif"

    set MyPostBitmapsCommands(0) [list\
	    "-np- PWViewOutput" \
	    "-np- OpenForcesWindow" \
	    "-np- ForcesData" \
	    [list -np- Splash $dir 0] ]

    set MyPostBitmapsHelp(0) {  "View process info" "View forces on bodies" "Draw forces on bodies" \
	    "Tdyn 3D User Interface" }

    # prefix values:
    #          Pre        Only active in the preprocessor
    #          Post       Only active in the postprocessor
    #          PrePost    Active Always
    set prefix Post
    set ProblemTypePriv(posttoolbarwin) [CreateOtherBitmaps MyPostBar "Tdyn post toolbar" \
	    MyPostBitmapsNames MyPostBitmapsCommands \
	    MyPostBitmapsHelp $dir "MyPostBitmaps [list $dir]" $type $prefix]
    AddNewToolbar "$ProgramName postbar" ${prefix}MyBarWindowGeom "MyPostBitmaps [list $dir]"
}

proc EndMyBitmaps {} {
    global ProgramName ProblemTypePriv
    
    ReleaseToolbar "$ProgramName prebar"
    ReleaseToolbar "$ProgramName postbar"
    rename MyPreBitmaps ""
    rename MyPostBitmaps ""
    catch { destroy $ProblemTypePriv(pretoolbarwin) }
    catch { destroy $ProblemTypePriv(posttoolbarwin) } 
}

proc InitGIDProject { dir } {
    global MenuNames MenuEntries MenuCommands MenuAcceler
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
    global VersionNumber ProgramName ProblemTypePriv GidPriv
#
#   Check GiD Version
#
    set VersionRequired "7.3"
    set comp -1
    catch {
	set comp [GiDVersionCmp $VersionRequired]
    }
    if { $comp < 0 } {
	tk_dialogRAM .gid.tempwinw Warning \
		"Tdyn requires GiD $VersionRequired or later" error 0 OK
    }
#
#   Define name and version and open splash window
#
    set ProgramNameTmp Tdyn3D
    set VersionNumberTmp "4.4b"
    set NewProblemType "No"
    if { ![info exists ProgramName] } { 
	set ProgramName ""
    }
    if { ![info exists VersionNumber] } { 
	set VersionNumber ""
    }
    if { [string compare -nocase $ProgramName $ProgramNameTmp]!=0 || \
	    [string compare -nocase $VersionNumber $VersionNumberTmp]!=0 } {
	set ProgramName $ProgramNameTmp
	set VersionNumber $VersionNumberTmp
	catch { 
	    Splash $dir 
	    tkwait window .splash
	}
	set NewProblemType "Yes"
    }
#
#   Initialise variables
#
    catch { 
	unset ProblemTypePriv
	unset TdynWizPriv 
	unset TdynTutPriv
	 unset SATWizPriv
    }
    set ProblemTypePriv(problemtypedir) $dir
#
#   Ventana de Configuracin (se abre la primera vez)
#
    if { [IsVarOnTdynDefaults first_start 1] } {
	WriteVarTdynDefaults first_start 0
	ConfigureTdynWindow 0
	tkwait window .gid.tdynconf
	#   Meshing surfaces with Rsurf
	.central.s process escape escape escape escape Utilities Variables \
		Highqualitysmoothing 2 escape escape escape
	#   Meshing surfaces with smoothing
	.central.s process escape escape escape escape Utilities Variables \
		SurfaceMesher 1 escape escape escape
    }

#   Additional TCL Source Files
#
     if { [catch {
	source [file join $dir scripts tdynutils.tcl]
	source [file join $dir scripts helpviewer.tcl]
	source [file join $dir scripts tdynwizard.tcl]
	source [file join $dir scripts tkwizard.tcl]
	source [file join $dir scripts tkwidget.tcl]
	source [file join $dir scripts materials.tcl]
	source [file join $dir scripts mat.fluid.tcl]
	source [file join $dir scripts mat.solid.tcl]
	source [file join $dir scripts functioneditor.tcl]
	source [file join $dir scripts tkproc.tcl]
	source [file join $dir scripts interfaceutils.tcl]
	source [file join $dir scripts init.datwin.tcl]
	source [file join $dir scripts solv.datwin.tcl]
	source [file join $dir scripts prb.datwin.tcl]
	source [file join $dir scripts unt.datwin.tcl]
    } errormsg] } {
	WarnWin "Error found: Tdyn is not correctly installed.\n$errormsg."
	return
    }
#
#   Oculta Books de conditiones no aplicables
#
    if { ![IsVarOnTdynDefaults show_ransol 1] } { 
	GidShowBook conditions RANSOL 0
 #       GidShowTitleMat RANSOL 0
    }
    if { ![IsVarOnTdynDefaults show_heatrans 1] } { 
	GidShowBook conditions HEATRANS 0
    }
    if { ![IsVarOnTdynDefaults show_advect 1] } { 
	GidShowBook conditions ADVECT 0
    }
    if { ![IsVarOnTdynDefaults show_ursolver 1] } { 
	GidShowBook conditions URSOLVER 0
    }
    if { ![IsVarOnTdynDefaults show_alemesh 1] } { 
	GidShowBook conditions ALEMESH 0
    }
    if { ![IsVarOnTdynDefaults show_naval 1] } { 
	GidShowBook conditions NAVAL 0
    }
    if { ![IsVarOnTdynDefaults show_fluid 1] } { 
	GidShowBook materials MATERIALS_(FLUID) 0
    }
    if { ![IsVarOnTdynDefaults show_solid 1] } { 
	GidShowBook materials MATERIALS_(SOLID) 0
    }

#
#   Add new entries in Utilities Pulldown
#    
    set ipos [lsearch $MenuNames [_ {Utilities}]]
    if { $ipos != -1 } {
	lappend MenuEntries($ipos) ---
	lappend MenuCommands($ipos) "" 
	lappend MenuAcceler($ipos) "" ""

	lappend MenuEntries($ipos) [_ {Create Floating Line}]
	lappend MenuCommands($ipos) {-np- IntersectPlanarFreeSurface}
	lappend MenuAcceler($ipos) "" ""

	if { [IsVarOnTdynDefaults show_naval 1] } { 
	    lappend MenuEntries($ipos) [_ {Read Free Surface...}]
	    lappend MenuCommands($ipos) {-np- ReadFreeSurfaceFromPrevious}
	    lappend MenuAcceler($ipos) "" ""
	}

	lappend MenuEntries($ipos) ---
	lappend MenuCommands($ipos) "" 
	lappend MenuAcceler($ipos) "" ""

	lappend MenuEntries($ipos) [_ {Tdyn Wizard}]
	lappend MenuCommands($ipos) "" 
	lappend MenuAcceler($ipos) "" ""

	set jpos [lsearch $MenuEntries($ipos) [_ {Tdyn Wizard}]]
	if { $jpos != -1 } {
	    if { [IsVarOnTdynDefaults show_naval 1] } { 
		set MenuEntries($ipos,$jpos) [list [_ {Tdyn Wizard}] [_ {Sink&Trim Wizard}] \
		        [_ {Control Volume}] [_ {Define Data}] [_ {Generate Mesh}] ]
		set MenuCommands($ipos,$jpos) { {-np- OpenTdynWizardWindow} \
		        {-np- OpenSinkTrimWizardWindow} {-np- UseCreateCompBox} \
		        {-np- UseCreateDefData} {-np- UseGenerateMesh} }
	    } else {
		set MenuEntries($ipos,$jpos) [list [_ {Tdyn Wizard}] \
		        [_ {Control Volume}] [_ {Define Data}] [_ {Generate Mesh}] ]
		set MenuCommands($ipos,$jpos) { {-np- OpenTdynWizardWindow} \
		        {-np- UseCreateCompBox} {-np- UseCreateDefData} {-np- UseGenerateMesh} }
	    }
	}
 
	lappend MenuEntries($ipos) ---
	lappend MenuCommands($ipos) "" 
	lappend MenuAcceler($ipos) "" ""

	lappend MenuEntries($ipos) [_ {Create Report...}]
	lappend MenuCommands($ipos) {-np- UseCreateReportWindow}
	lappend MenuAcceler($ipos) "" ""
    }
    InsertMenuOption Utilities [_ {Tdyn Preferences...}] 3 ConfigureTdynWindow \
	    PRE insert
#
#   Add new entries in Help Preprocess Pulldown
#    
    set ipos [lsearch $MenuNames [_ {Help}]]
    if { $ipos != -1 } {
	set MenuEntries($ipos) [linsert $MenuEntries($ipos) 0 [_ {Tdyn tutorials}] \
		[_ {Tdyn help}]]
	set MenuCommands($ipos) [linsert $MenuCommands($ipos) 0 \
		[list -np- HelpWindow "CUSTOM_HELP_FILE" \
		[file join $dir tdyn3dtutorials tdyn3d_tutorials.html]] \
		[list -np- HelpWindow "CUSTOM_HELP_REFERENCE" \
		[file join $dir ../info tdynreference_toc.html]]]
	set MenuAcceler($ipos) [linsert $MenuAcceler($ipos) 0 "" ""]

	lappend MenuEntries($ipos) [_ {About Tdyn3D}]
	lappend MenuCommands($ipos) [list -np- Splash $dir 0]
	lappend MenuAcceler($ipos) ""

	lappend MenuEntries($ipos) "---"
	lappend MenuCommands($ipos) ""
	lappend MenuAcceler($ipos) ""

	lappend MenuEntries($ipos) [_ {Tip of the day...}]
	lappend MenuCommands($ipos) [list -np- OpenTipsWizardWindow]
	lappend MenuAcceler($ipos) ""
    }
#
#   Add new entries in Help Postprocess Pulldown
#    
    set ipos [lsearch $MenuNamesP [_ {Help}]]
    if { $ipos != -1 } {
	set MenuEntriesP($ipos) [linsert $MenuEntriesP($ipos) 0 [_ {Tdyn tutorials}] \
		[_ {Tdyn help}]]
	set MenuCommandsP($ipos) [linsert $MenuCommandsP($ipos) 0 \
		[list -np- HelpWindow "CUSTOM_HELP_FILE" \
		[file join $dir tdyn3dtutorials tdyn3d_tutorials.html]] \
		[list -np- HelpWindow "CUSTOM_HELP_REFERENCE" \
		[file join $dir ../info tdynreference_toc.html]]]
	set MenuAccelerP($ipos) [linsert $MenuAccelerP($ipos) 0 "" ""]

	lappend MenuEntriesP($ipos) [_ {About Tdyn3D}]
	lappend MenuCommandsP($ipos) [list -np- Splash $dir 0]
	lappend MenuAccelerP($ipos) ""

	lappend MenuEntriesP($ipos) "---"
	lappend MenuCommandsP($ipos) ""
	lappend MenuAccelerP($ipos) ""

	lappend MenuEntriesP($ipos) [_ {Tip of the day...}]
	lappend MenuCommandsP($ipos) [list -np- OpenTipsWizardWindow]
	lappend MenuAccelerP($ipos) ""
    }
#
#   Remove entries in Help menu
#
    catch {
	RemoveMenuOptionIfExists [_ {Help}] [_ {Customization Help}] PREPOST
	RemoveMenuOptionIfExists [_ {Help}] [_ {What is new}] PREPOST
	RemoveMenuOptionIfExists [_ {Help}] [_ {FAQ}] PREPOST 
	RemoveMenuOptionIfExists [_ {Help}] [_ {Visit GiD web}] PREPOST
    }
#
#   Change entries in Meshing menu
#
    set ipos [lsearch $MenuNames [_ {Meshing}]]
    if { $ipos != -1 } {
	set jpos [lsearch $MenuEntries($ipos) [_ {Generate...}]]
	if { $jpos != -1 } {
	    set MenuCommands($ipos) [lreplace $MenuCommands($ipos) $jpos $jpos "-np- MeshingWindow"]
	} 
    }
    catch {
	RemoveMenuOption [_ {Meshing}] [_ {Element type}]>[_ {Only points}] PRE
	RemoveMenuOption [_ {Meshing}] [_ {Element type}]>[_ {Linear}] PRE
	RemoveMenuOption [_ {Meshing}] [_ {Element type}]>[_ {Triangle}] PRE
	RemoveMenuOption [_ {Meshing}] [_ {Element type}]>[_ {Quadrilateral}] PRE
    }
#
#   Change entries in Data menu
#
    GidChangeDataLabel [_ {Data units}] ""
    GidChangeDataLabel [_ {Interval}] ""
    GidChangeDataLabel [_ {Conditions}] ""
    GidChangeDataLabel [_ {Materials}] ""
    GidChangeDataLabel [_ {Interval Data}] ""
    GidChangeDataLabel [_ {Problem Data}] ""

    GidAddUserDataOptionsMenu [_ {Conditions}] "TdynConditionsSubmenu %W" 2
    GidAddUserDataOptions "---" "" 3
    GidAddUserDataOptionsMenu [_ {Materials}] "TdynMaterialsSubmenu %W" 4
    GidAddUserDataOptionsMenu [_ {Boundaries}] "TdynBoundariesSubmenu %W" 5
    GidAddUserDataOptions "---" "" 6
    GidAddUserDataOptions     [_ {Initial Data}] {initdatwin::init .gid "all" ""} 7
    GidAddUserDataOptions "---" "" 8
    GidAddUserDataOptions     [_ {Problem Data}] {prbdatwin::init .gid "all" ""} 9
    GidAddUserDataOptions     [_ {Modules Data}] {solvdatwin::init .gid "all" ""} 10
    GidAddUserDataOptions     [_ {Units Data}] {unitdatwin::init .gid "all" ""} 11
    GidAddUserDataOptions "---" "" 12


#
#   Add a new entries in View results, Utilities  and Calculate menus
#
    set idx [lsearch $MenuNamesP [_ {View results}]]
    if { $idx != -1 } {
	lappend MenuEntriesP($idx) "---"
	lappend MenuCommandsP($idx) ""
	lappend MenuEntriesP($idx) [_ {Time Table}]
	lappend MenuCommandsP($idx) {-np- OpenTimeTableWindow} 

	lappend MenuEntriesP($idx) "---"
	lappend MenuCommandsP($idx) ""
	lappend MenuEntriesP($idx) [_ {Forces on Boundaries}]
	lappend MenuCommandsP($idx) "-np- OpenForcesWindow"
     
	lappend MenuEntriesP($idx) [_ {Forces Graph}]
	lappend MenuCommandsP($idx) "-np- ForcesData"
	lappend MenuAccelerP($idx) ""
    } else {
	WarnWin "Tdyn 3D version and GiD version not compatible."
    }

    set idx [lsearch $MenuNamesP [_ {Utilities}]]
    if { $idx != -1 } {
	lappend MenuEntriesP($idx) "---"
	lappend MenuCommandsP($idx) ""
	lappend MenuAccelerP($idx) ""
	lappend MenuEntriesP($idx) [_ {Create Report}]
	lappend MenuCommandsP($idx) {-np- UseCreateReportWindow} 
	lappend MenuAccelerP($idx) ""
    } else {
	WarnWin "Tdyn 3D version and GiD version not compatible."
    }

    set idx [lsearch $MenuNames [_ {Calculate}]]
    if { $idx != -1 } {
#        lappend MenuEntries($idx) "---"
#        lappend MenuCommands($idx) ""
#        lappend MenuEntries($idx) "CalcBatch Window"
#        lappend MenuCommands($idx) "-np- LoadCaseWindow"

	lappend MenuEntries($idx) "---"
	lappend MenuCommands($idx) ""
	lappend MenuEntries($idx) [_ {Forces on Boundaries}]
	lappend MenuCommands($idx) "-np- OpenForcesWindow"
     
	lappend MenuEntries($idx) [_ {Forces Graph}]
	lappend MenuCommands($idx) "-np- ForcesData"
	lappend MenuAcceler($idx) "" ""
    } else {
	WarnWin "Tdyn 3D version and GiD version not compatible."
    }
#
#   Creates Bitmaps Toolbars
#
    MyPreBitmaps $dir
    MyPostBitmaps $dir
#
#   Pass materials as sets to Postprocess
#
    set ProblemTypePriv(PropertyToPost) [.central.s info variables PropertyToPost]
    if { $ProblemTypePriv(PropertyToPost) != "Material" } {
	.central.s process escape escape escape escape Utilities Variables \
		PropertyToPost Material escape escape escape
    }
#
#   Meshing surfaces with smoothing
#
	.central.s process escape escape escape escape Utilities Variables \
		Highqualitysmoothing 1 escape escape escape
#
#   Create menus and define the title of the window
#
    global GidPriv
    set GidPriv(ProgName) $ProgramName
    ChangeWindowTitle

    UpdateMenus
#    CreateTopMenus
#
#   Open configure window
#
    if {[IsVarOnTdynDefaults isconfigured -1]==-1} {
#        WarnWin "Tdyn is not configured"
#        ConfigureTdyn
#        WriteVarTdynDefaults isconfigured 1
    }
#
#   Open a tip
#
    set TipsWizPriv(show) [IsVarOnTdynDefaults showtips 1]
    if { $TipsWizPriv(show)==1 &&  $NewProblemType=="Yes" } {
	OpenTipsWizardWindow
    }
}

proc InitGIDPostProcess {} {
}

#
#   Close menu bar and define the original title of the window
#
proc EndGIDProject {} {
    global ProblemTypePriv ProgramName GidPriv
    # Kill Bitmaps window
    EndMyBitmaps
    # Kill wizard windows (if exist)
    if { [winfo exists .gid.tdynwizard] } {
	destroy .gid.tdynwizard
	DestroyWindows
    }      
    # Kill tips windows (if exist)
    if { [winfo exists .gid.tipswizard] } {
	destroy .gid.tipswizard
    }
    # Kill rest of windows (if exist)
    set winlist [list .gid.tdynconf .gid.fluidmat .gid.solidmat .gid.tdw \
	    .gid.tiw]
    foreach winopen $winlist {
	if { [winfo exists $winopen] } {
	    destroy $winopen
	}      
    }
    # Delete memory
    catch {
	namespace delete initdatwin
	namespace delete solvdatwin
	namespace delete buttons
	namespace delete TUI_images
	namespace delete matfluid
	namespace delete matsolid
	namespace delete FEditor
	namespace delete HelpViewer
    } 
    # Define the original title of the window
    set GidPriv(ProgName) GiD
    ChangeWindowTitle ""
}

proc EndGIDPostprocess {} {
}


proc RemoveMenuOptionIfExists {menu_name option_name prepost} { 
    global MenuNames MenuEntries MenuCommands MenuAcceler
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
    
    if {$prepost!="PRE" && $prepost!="POST" && $prepost!="PREPOST"} {  
	return -code error "Wrong arg. Must be PRE, POST or PREPOST."
    }
    
    if {$prepost=="PRE" || $prepost=="PREPOST"} {
	set ipos [lsearch $MenuNames $menu_name]
	if { $ipos != -1 } {
	    set jpos [lsearch $MenuEntries($ipos) $option_name]
	    if { $jpos != -1 } {
		set MenuEntries($ipos)  [lreplace $MenuEntries($ipos) $jpos  $jpos]
		set MenuCommands($ipos) [lreplace $MenuCommands($ipos) $jpos $jpos]
		if {[info exists MenuAcceler($ipos)] && [llength $MenuAcceler($ipos)] > $jpos} {
		    set MenuAcceler($ipos) [lreplace $MenuAcceler($ipos) $jpos $jpos]
		}
	    } 
	}
    }
    if {$prepost=="POST" || $prepost=="PREPOST"} {
	set ipos [lsearch $MenuNamesP $menu_name]
	if { $ipos != -1 } {
	    set jpos [lsearch $MenuEntriesP($ipos) $option_name]
	    if { $jpos != -1 } {
		set MenuEntriesP($ipos)  [lreplace $MenuEntriesP($ipos) $jpos  $jpos]
		set MenuCommandsP($ipos) [lreplace $MenuCommandsP($ipos) $jpos $jpos]
		if {[info exists MenuAccelerP($ipos)] && [llength $MenuAccelerP($ipos)] > $jpos} {
		    set MenuAccelerP($ipos) [lreplace $MenuAccelerP($ipos) $jpos $jpos]
		}
	    } 
	}
    }
}

#
#  Submenus of Menu Data
#
proc TdynConditionsSubmenu { w } {
    $w del 0 end
    if { [IsVarOnTdynDefaults show_ransol 1] } { 
	$w add command -label [_ {Ransol}] -command [list GidOpenConditions RANSOL]
    }
    if { [IsVarOnTdynDefaults show_heatrans 1] } { 
	$w add command -label [_ {Heatrans}] -command [list GidOpenConditions HEATRANS]
    }
    if { [IsVarOnTdynDefaults show_advect 1] } { 
	$w add command -label [_ {Advect}] -command [list GidOpenConditions ADVECT]
    }
    if { [IsVarOnTdynDefaults show_ursolver 1] } { 
	$w add command -label [_ {Ursolver}] -command [list GidOpenConditions URSOLVER]
    } 
    if { [IsVarOnTdynDefaults show_naval 1] } { 
	$w add command -label [_ {Naval}] -command [list GidOpenConditions NAVAL]
    }
    if { [IsVarOnTdynDefaults show_alemesh 1] } { 
	$w add command -label [_ {Alemesh}] -command [list GidOpenConditions ALEMESH]
    }
    $w configure -postcommand ""
}
proc TdynMaterialsSubmenu { w } {
    $w del 0 end
    if { [IsVarOnTdynDefaults show_fluid 1] } { 
	$w add command -label [_ {Fluid}] -command "materials::init MATERIALS_(FLUID)"
    }
    if { [IsVarOnTdynDefaults show_solid 1] } { 
	$w add command -label [_ {Solid}] -command "materials::init MATERIALS_(SOLID)"
    }
    $w configure -postcommand ""
}
proc TdynBoundariesSubmenu { w } {
    $w del 0 end
    if { [IsVarOnTdynDefaults show_fluid 1] } {
	$w add command -label [_ {Fluid}] -command [list GidOpenMaterials "BOUNDARIES_(FLUID)"]
    }
    if { [IsVarOnTdynDefaults show_solid 1] } { 
	$w add command -label [_ {Solid}] -command [list GidOpenMaterials "BOUNDARIES_(SOLID)"]
    }
    $w configure -postcommand ""
}

#
#   Assign Mesh Criteria to Surfaces and Generate the Mesh
#
proc MeshingWindow {} {
    global ProblemTypePriv TdynWizPriv

    set w .gid.meshing
    if { [info procs InitWindow] != "" } {
	InitWindow $w "Generate mesh" PreMeshingWindowGeom ""
    } else {
	toplevel $w
    }
    set ProblemTypePriv(sizetransit) [.central.s info variable SizeTransitionsFactor]
    if { ![info exist ProblemTypePriv(meshingtype)] } {
	set ProblemTypePriv(meshingtype) meshall
    }
    if { ![info exist ProblemTypePriv(genesize)] } {
	set ProblemTypePriv(genesize) [format {%.3g} [expr 0.1*[LayerLength "" D]]]
    }

    frame $w.f0 -relief ridge -bd 2 
    label $w.f0.lb -text {Unstructured size transitions}
    button $w.f0.bt0 \
	    -command {set ProblemTypePriv(sizetransit) [expr $ProblemTypePriv(sizetransit)-0.1]} \
	    -disabledforeground grey60 -text -
    scale $w.f0.sc -highlightbackground black -label slower -orient h -to 1.0 \
	    -resolution 0.1 -variable ProblemTypePriv(sizetransit)
    button $w.f0.bt1 \
	    -command {set ProblemTypePriv(sizetransit) [expr $ProblemTypePriv(sizetransit)+0.1]} \
	    -disabledforeground grey60 -text +
    GidHelp "$w.f0" "It controls whether the transitions between "\
	    "different element sizes are slow or fast."

    grid $w.f0.lb -sticky we -row 0 -column 1
    grid $w.f0.bt0 $w.f0.sc $w.f0.bt1 -sticky w
    grid conf $w.f0.sc -sticky we -padx 0 -pady 2
    grid conf $w.f0.bt1 -sticky e
    grid columnconf $w.f0 1 -weight 1

    frame $w.f1 -relief ridge -bd 2
    radiobutton $w.f1.r1 -text "Mesh all surfaces" \
	    -var ProblemTypePriv(meshingtype) -value meshall
    radiobutton $w.f1.r2 -text "Mesh surfaces in active layers" \
	    -var ProblemTypePriv(meshingtype) -value meshlayers
    radiobutton $w.f1.r3 -text "Mesh using default options" \
	    -var ProblemTypePriv(meshingtype) -value meshdefault
    
    GidHelp "$w.f1" "Select what line entities will be meshed."

    grid $w.f1.r1 -sticky w
    grid $w.f1.r2 -sticky w
    grid $w.f1.r3 -sticky w
    grid columnconf $w.f1 0 -weight 1

    frame $w.f2 -relief ridge -bd 2
    label $w.f2.lg -text "Elements general size"
    entry $w.f2.eg -relief sunken -textvariable ProblemTypePriv(genesize) -width 2    
    GidHelp "$w.f2" "Insert a value for the global element size."

    grid $w.f2.lg $w.f2.eg -sticky w -padx 2 -pady 2
    grid conf $w.f2.eg -sticky we
    grid columnconf $w.f2 1 -weight 1

    grid $w.f2 -sticky we -padx 3 -pady 3
    grid $w.f1 -sticky we -padx 3 -pady 3
    grid $w.f0 -sticky we -padx 3 -pady 3

    frame $w.buts
    button $w.buts.gn -text Generate -command  "MeshingCriteria $w"
    button $w.buts.cn -text Cancel -command "destroy $w"
    button $w.buts.hp -image [imagefromtdyn questionarrow.gif] -command "PickHelp $w.buts.hp" \
	    -highlightthickness 0
    pack $w.buts.gn $w.buts.cn $w.buts.hp -side left -padx 5 -ipadx 5 -pady 5 

    wm protocol $w WM_DELETE_WINDOW "tkButtonInvoke $w.buts.cn"
    bind $w <Escape> "tkButtonInvoke $w.buts.cn"
    grid $w.buts -sticky s

    grid rowconfigure $w {0 1 2} -weight 1
    grid columnconfigure $w 0 -weight 1   
    wm geom $w ""
}

proc MeshingCriteria {w} {
    global ProblemTypePriv
    #   Controles iniciales
    if {![IsWord real+ $ProblemTypePriv(genesize) $w "In Elements general size field."] } {
	return 
    } else {
	if { $ProblemTypePriv(genesize) == 0.0 } {
	    tk_dialogRAM .gid.tempwin {Error window} "General size must be greater than 0.0." \
		    error 0 OK
	    return 
	}
	destroy $w
    }   
    #   Se desabilitan ventanas y grficos
    .central.s disable windows 1 
    .central.s disable graphinput 1 
    #   Se cancela la malla que pueda existir
    .central.s process escape escape escape escape Meshing CancelMesh Yes
    #   Se aplica la transicin de tamaos
    set ProblemTypePriv(oldsizetransit) [.central.s info variable SizeTransitionsFactor]
    .central.s process escape escape escape escape utilities variables \
	    SizeTransitionsFactor $ProblemTypePriv(sizetransit) escape escape
    #   Se definen las capas que se mallarn
    switch $ProblemTypePriv(meshingtype) {
	meshall {
	    .central.s process escape escape escape escape \
		    Meshing MeshCriteria Mesh Surfaces 1: escape
	}
	meshlayers  { 
	    set layers_on_list [.central.s info layers -on]
	    foreach curr_layer [lrange $layers_on_list 0 end] {
		.central.s process escape escape escape escape \
		        Meshing MeshCriteria Mesh Surfaces layer:$curr_layer escape
	    }
	
	}
    } 
    #   Se genera la malla
    .central.s disable windows 0
    .central.s process escape escape escape escape Meshing Generate $ProblemTypePriv(genesize)
    #   Se ha acabado todo
    .central.s process escape escape escape escape utilities variables \
	    SizeTransitionsFactor $ProblemTypePriv(oldsizetransit) escape escape
    .central.s disable graphinput 0
}    

#
#  Procedure to assign Mesh Criteria to Surfaces
#
proc AssignMeshCriteriaToSurfaces {} {

    set answer [tk_messageBox -message "Assign <Mesh criteria> to all Surfaces?" \
		    -title "Assign <Mesh criteria>"  -type yesnocancel -icon question]

    case $answer {
	yes {
		    .central.s process escape escape escape escape \
		    Meshing MeshCriteria Mesh Surfaces 1: escape
	}
	no  {
	}
	cancel return
    }
}

#
#   Start Calculation Proccess
#
proc StartCalculate {} {
    # Determina el nombre del archivo
    set aa [.central.s info Project]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
    set ProjectName [file root $ProjectName]
    }
    set basename [file tail $ProjectName]

#    if { $ProjectName == "UNNAMED" } {
#        $w.t insert end "It is necessary to save the project to calculate"
#        return
#    }
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set file [file join $directory $basename.flavia.res]

    if { [file exists $file] } {
	set answer [tk_messageBox -message "Results file exists. Do you want to overwrite it?" \
		    -title "Results file exists"  -type yesnocancel -icon question]

	case $answer {
	    yes {
		    .central.s process escape escape escape escape  Utilities Calculate escape
	    }
	    no  {
		return
	    }
	    cancel return
	}
    } else {
	.central.s process escape escape escape escape Utilities Calculate escape
    }
}

proc HelpOnTdyn3D { dir } {

    WarnWin [join [list "To obtain help for Tdyn 3D, check in directory:\n\t " \
	    "'[file dirname $dir]'\n for the user manual and tutorials (files *.pdf)"] ""]

}

proc Splash { dir { autodestroy 1 } } {
    global GIDDEFAULT VersionNumber ProgramName

    if { [.gid.central.s disable windows] } { return }

    if { [ winfo exist .splash]} {
	destroy .splash
	update
    }

    toplevel .splash
    wm withdraw .splash

    set im [image create photo -file [ file join $dir images/tdyn-open.gif]]
    set x [expr [winfo screenwidth .splash]/2-[image width $im]/2]
    set y [expr [winfo screenheight .splash]/2-[image height $im]/2]

    wm geom .splash +$x+$y
    wm transient .splash .gid
    wm overrideredirect .splash 1
    pack [label .splash.l -image $im -relief ridge -bd 2]
    
    label .splash.lv -text "$ProgramName: Ver. $VersionNumber" -relief sunken \
	    -bg #9ab6ce -font "times 14"
#    #9ab6ce #a5bed4
    # Place Version Number
#    place .splash.lv -x 20 -y 270
    place .splash.lv -x 35 -y 270
    bind .splash <1> "destroy .splash"
    bind .splash <KeyPress> "destroy .splash"
    grab .splash
    focus .splash
    update
    wm deiconify .splash
    raise .splash .gid
    update
    if { $autodestroy } {
	after 2000 "if { [ winfo exist .splash] } { 
	    destroy .splash
	}"
    }
}

proc OpenForcesWindow { } {

    set title "Forces on Boundaries"
    set w .gid.boundariespostforces

    InitWindow $w $title PostBoundForcesWindowGeom

    #text $w.t -xscrollcommand "$w.scrollbar#1 set" \
    #                -yscrollcommand "$w.scrollbar#2 set" -font FixedFont

    text $w.t -yscrollcommand "$w.scrollbar#2 set" -font FixedFont

    scrollbar $w.scrollbar#2 -command "$w.t yview" -orient v
    #scrollbar $w.scrollbar#1 -command "$w.t xview" -orient h
    button $w.close -text Close -command "destroy $w"
    focus $w.close
    grid $w.t -row 1 -column 1 -sticky nesw
    grid $w.scrollbar#2 -row 1 -column 2 -sticky ns
    #grid $w.scrollbar#1 -row 2 -column 1 -sticky ew
    grid $w.close -row 3 -column 1 -rowspan 2 -pady 5
    grid rowconfigure $w 1 -weight 1 
    grid columnconfigure $w 1 -weight 1 

    # Determina el nombre del archivo
    set aa [.central.s info Project]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
	set ProjectName [file root $ProjectName]
    }
    set basename [file tail $ProjectName]

    if { $ProjectName == "UNNAMED" } {
	$w.t insert end "It is necessary to calculate to view these results"
	return
    }
    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set file [file join $directory $basename.flavia.for]

    if { ![file exists $file] } {
	$w.t insert end "There are no results for this model"
	return
    }
    set fd [open $file r]
    set bb ""
    while { ![eof $fd] } {
	gets $fd bb
	set bblen [llength $bb]
	if { $bblen>0 && $bblen<13 } {
	    $w.t insert end "[llength $bb] Forces data not found in file"
	    close $fd
	    return
	}
    }
    if {$bb == ""} {
	$w.t insert end "Forces file is empty"
	close $fd
	return
    }

    set sets ""
    set itim [lindex $bb 0]
    for { set i 1 } { $i < [llength $bb] } { incr i 13} {
	set iset [lindex $bb $i]
	lappend sets $iset
	set Pforces($iset) [lrange $bb [expr $i+1] [expr $i+3]]
	set Pmomenta($iset) [lrange $bb [expr $i+4] [expr $i+6]]
	set Vforces($iset) [lrange $bb [expr $i+7] [expr $i+9]]
	set Vmomenta($iset) [lrange $bb [expr $i+10] [expr $i+12]]
    }
    foreach i $sets {
	$w.t insert end "$i: (Final step $itim)\n"
	$w.t insert end "Pressure Forces (PFx PFy PFz)\n"
	$w.t insert end $Pforces($i)\n
      $w.t insert end "Pressure Moments (PMx PMy PMz)\n"
	$w.t insert end $Pmomenta($i)\n
	$w.t insert end "Viscous Forces (VFx VFy VFz)\n"
	$w.t insert end $Vforces($i)\n        
      $w.t insert end "Viscous Moments (VMx VMy VMz)\n"
	$w.t insert end $Vmomenta($i)\n
      $w.t insert end "*****************************************\n"
    }
    $w.t insert end "*****************************************\n"
    $w.t insert end "Note: \n\tPressure Forces are calculated by integrating pressure on surface\n"
    $w.t insert end "\tViscous Forces are calculated by integrating viscous stresses on surface\n" 
    $w.t insert end "\tThree cartesian components of forces and moments are given in both cases\n" 
    $w.t insert end "\tUnits are OutPut Units defined by the user\n" 

#    close $fd

#    if { [catch { set fd [open $filename r] } ] } {
#        update idletasks
#        after 1000 PWViewOutputWin $filename $name [list $date] yes
#        return
#    }
#    PWViewOutputFill $w.t $fd

    bind $w <Destroy> "catch [list close $fd]"
}

#
#  Procedure to create Tdyn3D About window
#
proc AboutTdyn3D { dir { overw .gid } } {
    global GIDDEFAULT VersionNumber

    set ProgName "Tdyn 3D Interface for GiD"
    set GenText "Tdyn 3D Interface for GiD"
    set Developer "Tdyn 3D (C) COMPASS IS"
    set Company [ join {"COMPASS Ingeniera y Sistemas\n" "Barcelona\n" "(Spain)"} ""]
    set Version "Ver. $VersionNumber"
    set Adress "C/ Manuel Girona 61, bajos\ne-mail: info@compassis.com\nfax: +34-93-2041909"

    set im [image create photo -file [ file join $dir images/tdyn.gif]]
    
    toplevel .gid.pepe
    wm title .gid.pepe $ProgName

    wm geometry .gid.pepe +[expr [winfo x $overw]+[winfo width $overw]/2-400]+[ \
	    expr [winfo y $overw]+[winfo height $overw]/2-250]

    frame .gid.pepe.mainf -bd 2 -relief ridge

    frame .gid.pepe.mainf1 -bd 1 -relief ridge

    message .gid.pepe.l -justify center -text $ProgName -width 200 -font BigFont

    label .gid.pepe.l2 -text $GenText -justify center -wraplength 200
    label .gid.pepe.l23 -image $im -relief ridge -bd 2
    
    frame .gid.pepe.mainf2 -bd 1 -relief ridge

    label .gid.pepe.l25 -text $Developer -justify left
    label .gid.pepe.l27 -text $Company -wraplength 200
    label .gid.pepe.l30 -text $Adress -justify left
    label .gid.pepe.l3 -text $Version
    frame .gid.pepe.b
    button .gid.pepe.b.ok -text OK -command "destroy .gid.pepe" -padx 10
#    button .gid.pepe.b.more -text More -command "AddMoreWelcome"
    pack .gid.pepe.b.ok -padx 3 -side left -anchor center -pady 3
#    pack  .gid.pepe.l30 .gid.pepe.l27 .gid.pepe.l25 .gid.pepe.l23 .gid.pepe.l3 .gid.pepe.l2 \
#            .gid.pepe.l -in .gid.pepe.mainf -side bottom -pady 5 -fill x -expand yes

    pack .gid.pepe.l30 .gid.pepe.l27 .gid.pepe.l25 -in .gid.pepe.mainf2 -side bottom -pady 5 -fill both -expand yes
    pack .gid.pepe.l23 .gid.pepe.l3 .gid.pepe.l -in .gid.pepe.mainf1 -side bottom -pady 5 -fill both -expand yes

    pack .gid.pepe.mainf1 .gid.pepe.mainf2 -in .gid.pepe.mainf -side left -fill both -expand yes

    pack .gid.pepe.b -side bottom
    pack .gid.pepe.mainf -side top -expand yes -fill both

    tkwait visibility .gid.pepe
    grab  .gid.pepe 
    tkwait window .gid.pepe
}
####################################
#    Tdyn configuration window     #
####################################

proc ConfigureTdynWindow { {war 1} } {
    global ProblemTypePriv ProgramName
    set w .gid.tdynconf
  
    if { [info procs InitWindow] != "" } {
	InitWindow $w "Tdyn Preferences" PreTdynConfWindowGeom ""
    } else {
	toplevel $w
    }
    set domtitle [TitleFrame $w.f0 -relief ridge -bd 3\
	    -text [_ {Domain Selection}] -side left ]
    set domframe [$domtitle getframe]

    set ProblemTypePriv(show_fluid) [IsVarOnTdynDefaults show_fluid 1]
    checkbutton $domframe.c1 -text [_ {Activate Fluid Solver}] \
	    -var ProblemTypePriv(show_fluid)
    set ProblemTypePriv(show_solid) [IsVarOnTdynDefaults show_solid 1]
    checkbutton $domframe.c2 -text [_ {Activate Solid Solver}] \
	    -var ProblemTypePriv(show_solid)
    GidHelp "$w.f0" [_ {Select if you are going to use Tdyn to solve problems \
	    in one or two domains.\nYou can change these values in the future, \
	    selecting Utilities > Tdyn_Preferences.}]

    grid $domtitle -row 0 -column 0 -sticky wnes
    grid $domframe.c1 -row 0 -column 0 -sticky nw
    grid $domframe.c2 -row 1 -column 0 -sticky nw 

    set prbtitle [TitleFrame $w.f1 -relief ridge -bd 3\
	    -text [_ {Problem Selection}] -side left ]
    set prbframe [$prbtitle getframe]

    set ProblemTypePriv(show_ransol) [IsVarOnTdynDefaults show_ransol 1]
    checkbutton $prbframe.c1 -text [_ {Activate RANSOL Module}] \
	    -var ProblemTypePriv(show_ransol)
    set ProblemTypePriv(show_heatrans) [IsVarOnTdynDefaults show_heatrans 1]
    checkbutton $prbframe.c2 -text [_ {Activate HEATRANS Module}] \
	    -var ProblemTypePriv(show_heatrans)
    set ProblemTypePriv(show_advect) [IsVarOnTdynDefaults show_advect 1]
    checkbutton $prbframe.c3 -text [_ {Activate ADVECT Module}] \
	    -var ProblemTypePriv(show_advect)
    set ProblemTypePriv(show_ursolver) [IsVarOnTdynDefaults show_ursolver 1]
    checkbutton $prbframe.c4 -text [_ {Activate URSOLVER Module}] \
	    -var ProblemTypePriv(show_ursolver)
    set ProblemTypePriv(show_alemesh) [IsVarOnTdynDefaults show_alemesh 1]
    checkbutton $prbframe.c5 -text [_ {Activate ALEMESH Module}] \
	    -var ProblemTypePriv(show_alemesh)
    if { $ProgramName=="Tdyn3D" } {
	set ProblemTypePriv(show_naval) [IsVarOnTdynDefaults show_naval 1] 
	checkbutton $prbframe.c6 -text [_ {Activate NAVAL Module}] \
		-var ProblemTypePriv(show_naval)
    } else {
	set ProblemTypePriv(show_naval) 0 
    }
    GidHelp "$w.f1" [_ {Select the modules you are going to use.\nYou can change\
	    these values in the future, selecting Utilities > Tdyn_Preferences.}]

    grid $prbtitle -row 1 -column 0 -sticky wnes -pady 10
    grid $prbframe.c1 -row 0 -column 0 -sticky nw
    grid $prbframe.c2 -row 1 -column 0 -sticky nw 
    grid $prbframe.c3 -row 2 -column 0 -sticky nw 
    grid $prbframe.c4 -row 3 -column 0 -sticky nw 
    grid $prbframe.c5 -row 4 -column 0 -sticky nw
    if { $ProgramName=="Tdyn3D" } {
	grid $prbframe.c6 -row 5 -column 0 -sticky nw 
    }
    frame $w.buts
    button $w.buts.ac -text Accept -command "SetTdynPreferences $w $war"
    button $w.buts.cn -text Cancel -command "destroy $w"
    grid $w.buts.ac $w.buts.cn  -padx 5 -pady 5 
    grid $w.buts -sticky swe

    grid rowconfigure $w {0 1 2} -weight 1
    grid columnconfigure $w 0 -weight 1
}

proc SetTdynPreferences { w war } {
    global ProblemTypePriv ProgramName
    if { ($ProblemTypePriv(show_fluid)==0) && ($ProblemTypePriv(show_solid)==0) } {
	WarnWin [_ {You must select at least one Domain to solve}]
	return
    }
    if { ($ProblemTypePriv(show_ransol)==0) && ($ProblemTypePriv(show_heatrans)==0) &&\
	 ($ProblemTypePriv(show_advect)==0) && ($ProblemTypePriv(show_ursolver)==0) } {
	WarnWin [_ {You must select at least one Problem (module) to be used}]
	return
    }
    if { $ProgramName=="Tdyn3D" } {
	if { ($ProblemTypePriv(show_fluid)==0) } {
	    set ProblemTypePriv(show_naval) 0
	}
	if { ($ProblemTypePriv(show_ransol)==0) && ($ProblemTypePriv(show_naval)==1) } {
	    WarnWin "NAVAL module cannot be used without RANSOL module.\n\
		    RANSOL module will be switched on."
	    set ProblemTypePriv(show_ransol) 1
	}
    } else {
	set ProblemTypePriv(show_naval) 0
    }

    WriteVarTdynDefaults show_fluid    $ProblemTypePriv(show_fluid)
    WriteVarTdynDefaults show_solid    $ProblemTypePriv(show_solid)
    WriteVarTdynDefaults show_ransol   $ProblemTypePriv(show_ransol)
    WriteVarTdynDefaults show_heatrans $ProblemTypePriv(show_heatrans)
    WriteVarTdynDefaults show_advect   $ProblemTypePriv(show_advect)
    WriteVarTdynDefaults show_ursolver $ProblemTypePriv(show_ursolver)
    WriteVarTdynDefaults show_alemesh  $ProblemTypePriv(show_alemesh)
    WriteVarTdynDefaults show_naval    $ProblemTypePriv(show_naval)
    destroy $w
    if { $war==1 } {
	WarnWin [_ {You must restart Tdyn before these changes take effect}]
    }
}
#
# Devuelve el archivo de configuracin de Tdyn
#
proc GiveTdynDefaultsFile { } {
    global ProgramName VersionNumber
    set filename [GiveGidDefaultsFile]
    set dirname [file dirname $filename]
    set extname [file extension $filename]
    set tdynname $ProgramName$VersionNumber
    return [file join $dirname $tdynname.ini]
}
#
#   Comprueba el valor de una variable en el archivo de configuracin de Tdyn
#   Si la encuentra devuelve su valor, en otro caso devuelve el valor por 
#   defecto dado en def
#
proc IsVarOnTdynDefaults { var {def 0} } {
    set file [GiveTdynDefaultsFile]
    if { [catch { set fileid [open $file r] }] } {
	return $def
    }
    while { ![eof $fileid] } {
	set aa [gets $fileid]
	if { [regexp "$var\[ ]*(\[01])" $aa {} val] } {
	    close $fileid
	    return $val
	}
    }
    close $fileid
    return $def
}
#
#   Escribe el valor de una variable en el archivo de configuracin de Tdyn
#
proc WriteVarTdynDefaults { var val } {
    set file [GiveTdynDefaultsFile]
    if { [file readable $file] } {
	if { [catch { set fileid [open $file r] }] } { return 0 }
	set fileread [read $fileid]
	close $fileid
    } else {
	set fileread ""
    }
    if { [regexp "$var" $fileread {}] } {
	regsub "$var\[ ]*(\[01])" $fileread "$var $val"  filewrite 
    } else {
	set filewrite ""
	append filewrite $fileread "\n$var $val"
    }
    if { [catch { set fileid [open $file w+] }] } {
	WarnWin "Cannot write file $file.\n Permission denied."
	return 0
    }
    puts $fileid $filewrite
    close $fileid
    return 1
}

proc GidShowTitleMat { title show } {

    global GidData

 set ListGDN [info globals G*]
WarnWin $ListGDN

    foreach GDN [array names GD_MAT*] {
	upvar #0 $GDN GidData
	foreach mat $GidData(MAT,nameslist) {
	    set mat [DWSpace2Under $mat]
	    if { $show == 0 } {
		DepActionTITLESTATE $GDN MAT,$mat $title disabled
	    } else {
		DepActionTITLESTATE $GDN MAT,$mat $title enabled
	    }
	}
#    }
}